define("pdpilot",["@jupyter-widgets/base"],(t=>(()=>{"use strict";var e={146:e=>{e.exports=t},147:t=>{t.exports=JSON.parse('{"name":"pdpilot","version":"0.4.1","description":"A Jupyter widget for exploring PDP and ICE plots.","keywords":["jupyter","jupyterlab","jupyterlab-extension","widgets"],"files":["lib/**/*.js","dist/*.js","css/*.css"],"homepage":"https://github.com/DanielKerrigan/PDPilot","bugs":{"url":"https://github.com/DanielKerrigan/PDPilot/issues"},"license":"BSD-3-Clause","author":{"name":"Daniel Kerrigan","email":"kerrigan.d@northeastern.edu"},"main":"lib/index.js","types":"./lib/index.d.ts","repository":{"type":"git","url":"https://github.com/DanielKerrigan/PDPilot"},"scripts":{"build":"webpack --mode=development && jupyter labextension build --development=True .","build:prod":"webpack --mode=production && jupyter labextension build .","clean":"npm run clean:lib && npm run clean:nbextension && npm run clean:labextension","clean:lib":"rimraf lib","clean:labextension":"rimraf pdpilot/labextension","clean:nbextension":"rimraf pdpilot/nbextension/static/index.js","fix":"prettier --plugin-search-dir . --write src && eslint . --ext .ts,.tsx,.svelte --fix","check":"prettier --plugin-search-dir . --check src && eslint . --ext .ts,.tsx,.svelte","prepack":"npm run build:prod","watch":"npm run watch:nbextension","watch:nbextension":"webpack --watch --mode=development","watch:labextension":"jupyter labextension watch .","test":"uvu -r tsm tests"},"dependencies":{"@jupyter-widgets/base":"^1.1.10 || ^2 || ^3 || ^4 || ^5 || ^6","d3":"^7.4.4","simple-statistics":"^7.8.0"},"devDependencies":{"@babel/core":"^7.5.0","@babel/preset-env":"^7.5.0","@jupyterlab/builder":"^3.0.0","@lumino/application":"^1.6.0","@lumino/widgets":"^1.6.0","@tsconfig/svelte":"^3.0.0","@types/d3":"^7.4.0","@types/webpack-env":"^1.13.6","@typescript-eslint/eslint-plugin":"^5.45.0","@typescript-eslint/parser":"^5.45.0","acorn":"^7.2.0","css-loader":"^6.7.0","eslint":"^8.28.0","eslint-config-prettier":"^8.5.0","eslint-plugin-svelte3":"^4.0.0","fs-extra":"^7.0.0","identity-obj-proxy":"^3.0.0","mkdirp":"^0.5.1","npm-run-all":"^4.1.3","prettier":"^2.8.0","prettier-plugin-svelte":"^2.8.1","rimraf":"^2.6.2","source-map-loader":"^1.1.3","style-loader":"^3.0.0","svelte":"^3.54.0","svelte-loader":"^3.1.5","svelte-preprocess":"5.0.0","ts-loader":"^9.0.0","tslib":"^2.4.1","tsm":"^2.2.1","typescript":"^4.9.3","uvu":"^0.5.3","webpack":"^5.0.0","webpack-cli":"^4.0.0"},"jupyterlab":{"extension":true,"outputDir":"pdpilot/labextension/"}}')}},n={};function i(t){var r=n[t];if(void 0!==r)return r.exports;var o=n[t]={exports:{}};return e[t](o,o.exports,i),o.exports}i.d=(t,e)=>{for(var n in e)i.o(e,n)&&!i.o(t,n)&&Object.defineProperty(t,n,{enumerable:!0,get:e[n]})},i.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e),i.r=t=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})};var r={};return(()=>{i.r(r),i.d(r,{MODULE_NAME:()=>n,MODULE_VERSION:()=>e,PDPilotModel:()=>qh,PDPilotView:()=>Eh});const t=i(147),e=t.version,n=t.name;var o=i(146);function l(){}function a(t){return t()}function s(){return Object.create(null)}function c(t){t.forEach(a)}function u(t){return"function"==typeof t}function h(t,e){return t!=t?e==e:t!==e||t&&"object"==typeof t||"function"==typeof t}function d(t){return 0===Object.keys(t).length}function f(t,...e){if(null==t)return l;const n=t.subscribe(...e);return n.unsubscribe?()=>n.unsubscribe():n}function p(t,e,n){t.$$.on_destroy.push(f(e,n))}function g(t,e,n,i){return t[1]&&i?function(t,e){for(const n in e)t[n]=e[n];return t}(n.ctx.slice(),t[1](i(e))):n.ctx}function m(t,e,n){return t.set(n),e}new Set;let v,y=!1;function b(t,e){t.appendChild(e)}function w(t,e,n){const i=function(t){if(!t)return document;const e=t.getRootNode?t.getRootNode():t.ownerDocument;return e&&e.host?e:t.ownerDocument}(t);if(!i.getElementById(e)){const t=k("style");t.id=e,t.textContent=n,function(t,e){b(t.head||t,e),e.sheet}(i,t)}}function $(t,e,n){t.insertBefore(e,n||null)}function x(t){t.parentNode&&t.parentNode.removeChild(t)}function _(t,e){for(let n=0;n<t.length;n+=1)t[n]&&t[n].d(e)}function k(t){return document.createElement(t)}function M(t){return document.createElementNS("http://www.w3.org/2000/svg",t)}function L(t){return document.createTextNode(t)}function A(){return L(" ")}function S(){return L("")}function N(t,e,n,i){return t.addEventListener(e,n,i),()=>t.removeEventListener(e,n,i)}function z(t,e,n){null==n?t.removeAttribute(e):t.getAttribute(e)!==n&&t.setAttribute(e,n)}function T(t,e,n){const i=new Set;for(let e=0;e<t.length;e+=1)t[e].checked&&i.add(t[e].__value);return n||i.delete(e),Array.from(i)}function C(t,e){e=""+e,t.wholeText!==e&&(t.data=e)}function q(t,e){t.value=null==e?"":e}function E(t,e,n,i){null===n?t.style.removeProperty(e):t.style.setProperty(e,n,i?"important":"")}function O(t,e){for(let n=0;n<t.options.length;n+=1){const i=t.options[n];if(i.__value===e)return void(i.selected=!0)}t.selectedIndex=-1}function D(t){const e=t.querySelector(":checked")||t.options[0];return e&&e.__value}function B(t,e,n){t.classList[n?"add":"remove"](e)}function j(t){v=t}function P(){if(!v)throw new Error("Function called outside component initialization");return v}function H(t){P().$$.on_mount.push(t)}function R(){const t=P();return(e,n,{cancelable:i=!1}={})=>{const r=t.$$.callbacks[e];if(r){const o=function(t,e,{bubbles:n=!1,cancelable:i=!1}={}){const r=document.createEvent("CustomEvent");return r.initCustomEvent(t,n,i,e),r}(e,n,{cancelable:i});return r.slice().forEach((e=>{e.call(t,o)})),!o.defaultPrevented}return!0}}new Map;const I=[],V=[],W=[],F=[],X=Promise.resolve();let Y=!1;function K(t){W.push(t)}function U(t){F.push(t)}const G=new Set;let Z=0;function J(){const t=v;do{for(;Z<I.length;){const t=I[Z];Z++,j(t),Q(t.$$)}for(j(null),I.length=0,Z=0;V.length;)V.pop()();for(let t=0;t<W.length;t+=1){const e=W[t];G.has(e)||(G.add(e),e())}W.length=0}while(I.length);for(;F.length;)F.pop()();Y=!1,G.clear(),j(t)}function Q(t){if(null!==t.fragment){t.update(),c(t.before_update);const e=t.dirty;t.dirty=[-1],t.fragment&&t.fragment.p(t.ctx,e),t.after_update.forEach(K)}}const tt=new Set;let et,nt;function it(){et={r:0,c:[],p:et}}function rt(){et.r||c(et.c),et=et.p}function ot(t,e){t&&t.i&&(tt.delete(t),t.i(e))}function lt(t,e,n,i){if(t&&t.o){if(tt.has(t))return;tt.add(t),et.c.push((()=>{tt.delete(t),i&&(n&&t.d(1),i())})),t.o(e)}else i&&i()}function at(t,e){t.d(1),e.delete(t.key)}function st(t,e){lt(t,1,1,(()=>{e.delete(t.key)}))}function ct(t,e,n,i,r,o,l,a,s,c,u,h){let d=t.length,f=o.length,p=d;const g={};for(;p--;)g[t[p].key]=p;const m=[],v=new Map,y=new Map;for(p=f;p--;){const t=h(r,o,p),a=n(t);let s=l.get(a);s?i&&s.p(t,e):(s=c(a,t),s.c()),v.set(a,m[p]=s),a in g&&y.set(a,Math.abs(p-g[a]))}const b=new Set,w=new Set;function $(t){ot(t,1),t.m(a,u),l.set(t.key,t),u=t.first,f--}for(;d&&f;){const e=m[f-1],n=t[d-1],i=e.key,r=n.key;e===n?(u=e.first,d--,f--):v.has(r)?!l.has(i)||b.has(i)?$(e):w.has(r)?d--:y.get(i)>y.get(r)?(w.add(i),$(e)):(b.add(r),d--):(s(n,l),d--)}for(;d--;){const e=t[d];v.has(e.key)||s(e,l)}for(;f;)$(m[f-1]);return m}function ut(t,e,n,i){const r=t.$$.props[e];void 0!==r&&(t.$$.bound[r]=n,void 0===i&&n(t.$$.ctx[r]))}function ht(t){t&&t.c()}function dt(t,e,n,i){const{fragment:r,after_update:o}=t.$$;r&&r.m(e,n),i||K((()=>{const e=t.$$.on_mount.map(a).filter(u);t.$$.on_destroy?t.$$.on_destroy.push(...e):c(e),t.$$.on_mount=[]})),o.forEach(K)}function ft(t,e){const n=t.$$;null!==n.fragment&&(c(n.on_destroy),n.fragment&&n.fragment.d(e),n.on_destroy=n.fragment=null,n.ctx=[])}function pt(t,e,n,i,r,o,a,u=[-1]){const h=v;j(t);const d=t.$$={fragment:null,ctx:[],props:o,update:l,not_equal:r,bound:s(),on_mount:[],on_destroy:[],on_disconnect:[],before_update:[],after_update:[],context:new Map(e.context||(h?h.$$.context:[])),callbacks:s(),dirty:u,skip_bound:!1,root:e.target||h.$$.root};a&&a(d.root);let f=!1;if(d.ctx=n?n(t,e.props||{},((e,n,...i)=>{const o=i.length?i[0]:n;return d.ctx&&r(d.ctx[e],d.ctx[e]=o)&&(!d.skip_bound&&d.bound[e]&&d.bound[e](o),f&&function(t,e){-1===t.$$.dirty[0]&&(I.push(t),Y||(Y=!0,X.then(J)),t.$$.dirty.fill(0)),t.$$.dirty[e/31|0]|=1<<e%31}(t,e)),n})):[],d.update(),f=!0,c(d.before_update),d.fragment=!!i&&i(d.ctx),e.target){if(e.hydrate){y=!0;const t=(p=e.target,Array.from(p.childNodes));d.fragment&&d.fragment.l(t),t.forEach(x)}else d.fragment&&d.fragment.c();e.intro&&ot(t.$$.fragment),dt(t,e.target,e.anchor,e.customElement),y=!1,J()}var p;j(h)}"undefined"!=typeof window?window:"undefined"!=typeof globalThis?globalThis:global,new Set(["allowfullscreen","allowpaymentrequest","async","autofocus","autoplay","checked","controls","default","defer","disabled","formnovalidate","hidden","inert","ismap","itemscope","loop","multiple","muted","nomodule","novalidate","open","playsinline","readonly","required","reversed","selected"]),"function"==typeof HTMLElement&&(nt=class extends HTMLElement{constructor(){super(),this.attachShadow({mode:"open"})}connectedCallback(){const{on_mount:t}=this.$$;this.$$.on_disconnect=t.map(a).filter(u);for(const t in this.$$.slotted)this.appendChild(this.$$.slotted[t])}attributeChangedCallback(t,e,n){this[t]=n}disconnectedCallback(){c(this.$$.on_disconnect)}$destroy(){ft(this,1),this.$destroy=l}$on(t,e){if(!u(e))return l;const n=this.$$.callbacks[t]||(this.$$.callbacks[t]=[]);return n.push(e),()=>{const t=n.indexOf(e);-1!==t&&n.splice(t,1)}}$set(t){this.$$set&&!d(t)&&(this.$$.skip_bound=!0,this.$$set(t),this.$$.skip_bound=!1)}});class gt{$destroy(){ft(this,1),this.$destroy=l}$on(t,e){if(!u(e))return l;const n=this.$$.callbacks[t]||(this.$$.callbacks[t]=[]);return n.push(e),()=>{const t=n.indexOf(e);-1!==t&&n.splice(t,1)}}$set(t){this.$$set&&!d(t)&&(this.$$.skip_bound=!0,this.$$set(t),this.$$.skip_bound=!1)}}const mt=[];function vt(t,e=l){let n;const i=new Set;function r(e){if(h(t,e)&&(t=e,n)){const e=!mt.length;for(const e of i)e[1](),mt.push(e,t);if(e){for(let t=0;t<mt.length;t+=2)mt[t][0](mt[t+1]);mt.length=0}}}return{set:r,update:function(e){r(e(t))},subscribe:function(o,a=l){const s=[o,a];return i.add(s),1===i.size&&(n=e(r)||l),o(t),()=>{i.delete(s),0===i.size&&(n(),n=null)}}}}function yt(t,e,n){const i=!Array.isArray(t),r=i?[t]:t,o=e.length<2;return function(t,n){return{subscribe:vt(t,(t=>{let n=!1;const a=[];let s=0,h=l;const d=()=>{if(s)return;h();const n=e(i?a[0]:a,t);o?t(n):h=u(n)?n:l},p=r.map(((t,e)=>f(t,(t=>{a[e]=t,s&=~(1<<e),n&&d()}),(()=>{s|=1<<e}))));return n=!0,d(),function(){c(p),h()}})).subscribe}}(n)}function bt(t,e,n){t.prototype=e.prototype=n,n.constructor=t}function wt(t,e){var n=Object.create(t.prototype);for(var i in e)n[i]=e[i];return n}function $t(){}var xt=.7,_t=1/xt,kt="\\s*([+-]?\\d+)\\s*",Mt="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",Lt="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",At=/^#([0-9a-f]{3,8})$/,St=new RegExp(`^rgb\\(${kt},${kt},${kt}\\)$`),Nt=new RegExp(`^rgb\\(${Lt},${Lt},${Lt}\\)$`),zt=new RegExp(`^rgba\\(${kt},${kt},${kt},${Mt}\\)$`),Tt=new RegExp(`^rgba\\(${Lt},${Lt},${Lt},${Mt}\\)$`),Ct=new RegExp(`^hsl\\(${Mt},${Lt},${Lt}\\)$`),qt=new RegExp(`^hsla\\(${Mt},${Lt},${Lt},${Mt}\\)$`),Et={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function Ot(){return this.rgb().formatHex()}function Dt(){return this.rgb().formatRgb()}function Bt(t){var e,n;return t=(t+"").trim().toLowerCase(),(e=At.exec(t))?(n=e[1].length,e=parseInt(e[1],16),6===n?jt(e):3===n?new It(e>>8&15|e>>4&240,e>>4&15|240&e,(15&e)<<4|15&e,1):8===n?Pt(e>>24&255,e>>16&255,e>>8&255,(255&e)/255):4===n?Pt(e>>12&15|e>>8&240,e>>8&15|e>>4&240,e>>4&15|240&e,((15&e)<<4|15&e)/255):null):(e=St.exec(t))?new It(e[1],e[2],e[3],1):(e=Nt.exec(t))?new It(255*e[1]/100,255*e[2]/100,255*e[3]/100,1):(e=zt.exec(t))?Pt(e[1],e[2],e[3],e[4]):(e=Tt.exec(t))?Pt(255*e[1]/100,255*e[2]/100,255*e[3]/100,e[4]):(e=Ct.exec(t))?Kt(e[1],e[2]/100,e[3]/100,1):(e=qt.exec(t))?Kt(e[1],e[2]/100,e[3]/100,e[4]):Et.hasOwnProperty(t)?jt(Et[t]):"transparent"===t?new It(NaN,NaN,NaN,0):null}function jt(t){return new It(t>>16&255,t>>8&255,255&t,1)}function Pt(t,e,n,i){return i<=0&&(t=e=n=NaN),new It(t,e,n,i)}function Ht(t){return t instanceof $t||(t=Bt(t)),t?new It((t=t.rgb()).r,t.g,t.b,t.opacity):new It}function Rt(t,e,n,i){return 1===arguments.length?Ht(t):new It(t,e,n,null==i?1:i)}function It(t,e,n,i){this.r=+t,this.g=+e,this.b=+n,this.opacity=+i}function Vt(){return`#${Yt(this.r)}${Yt(this.g)}${Yt(this.b)}`}function Wt(){const t=Ft(this.opacity);return`${1===t?"rgb(":"rgba("}${Xt(this.r)}, ${Xt(this.g)}, ${Xt(this.b)}${1===t?")":`, ${t})`}`}function Ft(t){return isNaN(t)?1:Math.max(0,Math.min(1,t))}function Xt(t){return Math.max(0,Math.min(255,Math.round(t)||0))}function Yt(t){return((t=Xt(t))<16?"0":"")+t.toString(16)}function Kt(t,e,n,i){return i<=0?t=e=n=NaN:n<=0||n>=1?t=e=NaN:e<=0&&(t=NaN),new Gt(t,e,n,i)}function Ut(t){if(t instanceof Gt)return new Gt(t.h,t.s,t.l,t.opacity);if(t instanceof $t||(t=Bt(t)),!t)return new Gt;if(t instanceof Gt)return t;var e=(t=t.rgb()).r/255,n=t.g/255,i=t.b/255,r=Math.min(e,n,i),o=Math.max(e,n,i),l=NaN,a=o-r,s=(o+r)/2;return a?(l=e===o?(n-i)/a+6*(n<i):n===o?(i-e)/a+2:(e-n)/a+4,a/=s<.5?o+r:2-o-r,l*=60):a=s>0&&s<1?0:l,new Gt(l,a,s,t.opacity)}function Gt(t,e,n,i){this.h=+t,this.s=+e,this.l=+n,this.opacity=+i}function Zt(t){return(t=(t||0)%360)<0?t+360:t}function Jt(t){return Math.max(0,Math.min(1,t||0))}function Qt(t,e,n){return 255*(t<60?e+(n-e)*t/60:t<180?n:t<240?e+(n-e)*(240-t)/60:e)}function te(t,e,n,i,r){var o=t*t,l=o*t;return((1-3*t+3*o-l)*e+(4-6*o+3*l)*n+(1+3*t+3*o-3*l)*i+l*r)/6}bt($t,Bt,{copy(t){return Object.assign(new this.constructor,this,t)},displayable(){return this.rgb().displayable()},hex:Ot,formatHex:Ot,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return Ut(this).formatHsl()},formatRgb:Dt,toString:Dt}),bt(It,Rt,wt($t,{brighter(t){return t=null==t?_t:Math.pow(_t,t),new It(this.r*t,this.g*t,this.b*t,this.opacity)},darker(t){return t=null==t?xt:Math.pow(xt,t),new It(this.r*t,this.g*t,this.b*t,this.opacity)},rgb(){return this},clamp(){return new It(Xt(this.r),Xt(this.g),Xt(this.b),Ft(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:Vt,formatHex:Vt,formatHex8:function(){return`#${Yt(this.r)}${Yt(this.g)}${Yt(this.b)}${Yt(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:Wt,toString:Wt})),bt(Gt,(function(t,e,n,i){return 1===arguments.length?Ut(t):new Gt(t,e,n,null==i?1:i)}),wt($t,{brighter(t){return t=null==t?_t:Math.pow(_t,t),new Gt(this.h,this.s,this.l*t,this.opacity)},darker(t){return t=null==t?xt:Math.pow(xt,t),new Gt(this.h,this.s,this.l*t,this.opacity)},rgb(){var t=this.h%360+360*(this.h<0),e=isNaN(t)||isNaN(this.s)?0:this.s,n=this.l,i=n+(n<.5?n:1-n)*e,r=2*n-i;return new It(Qt(t>=240?t-240:t+120,r,i),Qt(t,r,i),Qt(t<120?t+240:t-120,r,i),this.opacity)},clamp(){return new Gt(Zt(this.h),Jt(this.s),Jt(this.l),Ft(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const t=Ft(this.opacity);return`${1===t?"hsl(":"hsla("}${Zt(this.h)}, ${100*Jt(this.s)}%, ${100*Jt(this.l)}%${1===t?")":`, ${t})`}`}}));const ee=t=>()=>t;function ne(t,e){var n=e-t;return n?function(t,e){return function(n){return t+n*e}}(t,n):ee(isNaN(t)?e:t)}const ie=function t(e){var n=function(t){return 1==(t=+t)?ne:function(e,n){return n-e?function(t,e,n){return t=Math.pow(t,n),e=Math.pow(e,n)-t,n=1/n,function(i){return Math.pow(t+i*e,n)}}(e,n,t):ee(isNaN(e)?n:e)}}(e);function i(t,e){var i=n((t=Rt(t)).r,(e=Rt(e)).r),r=n(t.g,e.g),o=n(t.b,e.b),l=ne(t.opacity,e.opacity);return function(e){return t.r=i(e),t.g=r(e),t.b=o(e),t.opacity=l(e),t+""}}return i.gamma=t,i}(1);function re(t){return function(e){var n,i,r=e.length,o=new Array(r),l=new Array(r),a=new Array(r);for(n=0;n<r;++n)i=Rt(e[n]),o[n]=i.r||0,l[n]=i.g||0,a[n]=i.b||0;return o=t(o),l=t(l),a=t(a),i.opacity=1,function(t){return i.r=o(t),i.g=l(t),i.b=a(t),i+""}}}var oe=re((function(t){var e=t.length-1;return function(n){var i=n<=0?n=0:n>=1?(n=1,e-1):Math.floor(n*e),r=t[i],o=t[i+1],l=i>0?t[i-1]:2*r-o,a=i<e-1?t[i+2]:2*o-r;return te((n-i/e)*e,l,r,o,a)}}));function le(t,e){var n,i=e?e.length:0,r=t?Math.min(i,t.length):0,o=new Array(r),l=new Array(i);for(n=0;n<r;++n)o[n]=pe(t[n],e[n]);for(;n<i;++n)l[n]=e[n];return function(t){for(n=0;n<r;++n)l[n]=o[n](t);return l}}function ae(t,e){var n=new Date;return t=+t,e=+e,function(i){return n.setTime(t*(1-i)+e*i),n}}function se(t,e){return t=+t,e=+e,function(n){return t*(1-n)+e*n}}function ce(t,e){var n,i={},r={};for(n in null!==t&&"object"==typeof t||(t={}),null!==e&&"object"==typeof e||(e={}),e)n in t?i[n]=pe(t[n],e[n]):r[n]=e[n];return function(t){for(n in i)r[n]=i[n](t);return r}}re((function(t){var e=t.length;return function(n){var i=Math.floor(((n%=1)<0?++n:n)*e),r=t[(i+e-1)%e],o=t[i%e],l=t[(i+1)%e],a=t[(i+2)%e];return te((n-i/e)*e,r,o,l,a)}}));var ue=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,he=new RegExp(ue.source,"g");function de(t,e){var n,i,r,o=ue.lastIndex=he.lastIndex=0,l=-1,a=[],s=[];for(t+="",e+="";(n=ue.exec(t))&&(i=he.exec(e));)(r=i.index)>o&&(r=e.slice(o,r),a[l]?a[l]+=r:a[++l]=r),(n=n[0])===(i=i[0])?a[l]?a[l]+=i:a[++l]=i:(a[++l]=null,s.push({i:l,x:se(n,i)})),o=he.lastIndex;return o<e.length&&(r=e.slice(o),a[l]?a[l]+=r:a[++l]=r),a.length<2?s[0]?function(t){return function(e){return t(e)+""}}(s[0].x):function(t){return function(){return t}}(e):(e=s.length,function(t){for(var n,i=0;i<e;++i)a[(n=s[i]).i]=n.x(t);return a.join("")})}function fe(t,e){e||(e=[]);var n,i=t?Math.min(e.length,t.length):0,r=e.slice();return function(o){for(n=0;n<i;++n)r[n]=t[n]*(1-o)+e[n]*o;return r}}function pe(t,e){var n,i,r=typeof e;return null==e||"boolean"===r?ee(e):("number"===r?se:"string"===r?(n=Bt(e))?(e=n,ie):de:e instanceof Bt?ie:e instanceof Date?ae:(i=e,!ArrayBuffer.isView(i)||i instanceof DataView?Array.isArray(e)?le:"function"!=typeof e.valueOf&&"function"!=typeof e.toString||isNaN(e)?ce:se:fe))(t,e)}function ge(t,e){return t=+t,e=+e,function(n){return Math.round(t*(1-n)+e*n)}}function me(t,e){return null==t||null==e?NaN:t<e?-1:t>e?1:t>=e?0:NaN}function ve(t,e){return null==t||null==e?NaN:e<t?-1:e>t?1:e>=t?0:NaN}function ye(t){let e,n,i;function r(t,i,r=0,o=t.length){if(r<o){if(0!==e(i,i))return o;do{const e=r+o>>>1;n(t[e],i)<0?r=e+1:o=e}while(r<o)}return r}return 2!==t.length?(e=me,n=(e,n)=>me(t(e),n),i=(e,n)=>t(e)-n):(e=t===me||t===ve?t:be,n=t,i=t),{left:r,center:function(t,e,n=0,o=t.length){const l=r(t,e,n,o-1);return l>n&&i(t[l-1],e)>-i(t[l],e)?l-1:l},right:function(t,i,r=0,o=t.length){if(r<o){if(0!==e(i,i))return o;do{const e=r+o>>>1;n(t[e],i)<=0?r=e+1:o=e}while(r<o)}return r}}}function be(){return 0}function we(t){return null===t?NaN:+t}const $e=ye(me),xe=$e.right,_e=($e.left,ye(we).center,xe);function ke(t){return+t}var Me=[0,1];function Le(t){return t}function Ae(t,e){return(e-=t=+t)?function(n){return(n-t)/e}:(n=isNaN(e)?NaN:.5,function(){return n});var n}function Se(t,e,n){var i=t[0],r=t[1],o=e[0],l=e[1];return r<i?(i=Ae(r,i),o=n(l,o)):(i=Ae(i,r),o=n(o,l)),function(t){return o(i(t))}}function Ne(t,e,n){var i=Math.min(t.length,e.length)-1,r=new Array(i),o=new Array(i),l=-1;for(t[i]<t[0]&&(t=t.slice().reverse(),e=e.slice().reverse());++l<i;)r[l]=Ae(t[l],t[l+1]),o[l]=n(e[l],e[l+1]);return function(e){var n=_e(t,e,1,i)-1;return o[n](r[n](e))}}function ze(t,e){return e.domain(t.domain()).range(t.range()).interpolate(t.interpolate()).clamp(t.clamp()).unknown(t.unknown())}function Te(){return function(){var t,e,n,i,r,o,l=Me,a=Me,s=pe,c=Le;function u(){var t,e,n,s=Math.min(l.length,a.length);return c!==Le&&(t=l[0],e=l[s-1],t>e&&(n=t,t=e,e=n),c=function(n){return Math.max(t,Math.min(e,n))}),i=s>2?Ne:Se,r=o=null,h}function h(e){return null==e||isNaN(e=+e)?n:(r||(r=i(l.map(t),a,s)))(t(c(e)))}return h.invert=function(n){return c(e((o||(o=i(a,l.map(t),se)))(n)))},h.domain=function(t){return arguments.length?(l=Array.from(t,ke),u()):l.slice()},h.range=function(t){return arguments.length?(a=Array.from(t),u()):a.slice()},h.rangeRound=function(t){return a=Array.from(t),s=ge,u()},h.clamp=function(t){return arguments.length?(c=!!t||Le,u()):c!==Le},h.interpolate=function(t){return arguments.length?(s=t,u()):s},h.unknown=function(t){return arguments.length?(n=t,h):n},function(n,i){return t=n,e=i,u()}}()(Le,Le)}function Ce(t,e){switch(arguments.length){case 0:break;case 1:this.range(t);break;default:this.range(e).domain(t)}return this}function qe(t,e){switch(arguments.length){case 0:break;case 1:"function"==typeof t?this.interpolator(t):this.range(t);break;default:this.domain(t),"function"==typeof e?this.interpolator(e):this.range(e)}return this}var Ee=Math.sqrt(50),Oe=Math.sqrt(10),De=Math.sqrt(2);function Be(t,e,n){var i,r,o,l,a=-1;if(n=+n,(t=+t)==(e=+e)&&n>0)return[t];if((i=e<t)&&(r=t,t=e,e=r),0===(l=je(t,e,n))||!isFinite(l))return[];if(l>0){let n=Math.round(t/l),i=Math.round(e/l);for(n*l<t&&++n,i*l>e&&--i,o=new Array(r=i-n+1);++a<r;)o[a]=(n+a)*l}else{l=-l;let n=Math.round(t*l),i=Math.round(e*l);for(n/l<t&&++n,i/l>e&&--i,o=new Array(r=i-n+1);++a<r;)o[a]=(n+a)/l}return i&&o.reverse(),o}function je(t,e,n){var i=(e-t)/Math.max(0,n),r=Math.floor(Math.log(i)/Math.LN10),o=i/Math.pow(10,r);return r>=0?(o>=Ee?10:o>=Oe?5:o>=De?2:1)*Math.pow(10,r):-Math.pow(10,-r)/(o>=Ee?10:o>=Oe?5:o>=De?2:1)}var Pe,He=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function Re(t){if(!(e=He.exec(t)))throw new Error("invalid format: "+t);var e;return new Ie({fill:e[1],align:e[2],sign:e[3],symbol:e[4],zero:e[5],width:e[6],comma:e[7],precision:e[8]&&e[8].slice(1),trim:e[9],type:e[10]})}function Ie(t){this.fill=void 0===t.fill?" ":t.fill+"",this.align=void 0===t.align?">":t.align+"",this.sign=void 0===t.sign?"-":t.sign+"",this.symbol=void 0===t.symbol?"":t.symbol+"",this.zero=!!t.zero,this.width=void 0===t.width?void 0:+t.width,this.comma=!!t.comma,this.precision=void 0===t.precision?void 0:+t.precision,this.trim=!!t.trim,this.type=void 0===t.type?"":t.type+""}function Ve(t,e){if((n=(t=e?t.toExponential(e-1):t.toExponential()).indexOf("e"))<0)return null;var n,i=t.slice(0,n);return[i.length>1?i[0]+i.slice(2):i,+t.slice(n+1)]}function We(t){return(t=Ve(Math.abs(t)))?t[1]:NaN}function Fe(t,e){var n=Ve(t,e);if(!n)return t+"";var i=n[0],r=n[1];return r<0?"0."+new Array(-r).join("0")+i:i.length>r+1?i.slice(0,r+1)+"."+i.slice(r+1):i+new Array(r-i.length+2).join("0")}Re.prototype=Ie.prototype,Ie.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};const Xe={"%":(t,e)=>(100*t).toFixed(e),b:t=>Math.round(t).toString(2),c:t=>t+"",d:function(t){return Math.abs(t=Math.round(t))>=1e21?t.toLocaleString("en").replace(/,/g,""):t.toString(10)},e:(t,e)=>t.toExponential(e),f:(t,e)=>t.toFixed(e),g:(t,e)=>t.toPrecision(e),o:t=>Math.round(t).toString(8),p:(t,e)=>Fe(100*t,e),r:Fe,s:function(t,e){var n=Ve(t,e);if(!n)return t+"";var i=n[0],r=n[1],o=r-(Pe=3*Math.max(-8,Math.min(8,Math.floor(r/3))))+1,l=i.length;return o===l?i:o>l?i+new Array(o-l+1).join("0"):o>0?i.slice(0,o)+"."+i.slice(o):"0."+new Array(1-o).join("0")+Ve(t,Math.max(0,e+o-1))[0]},X:t=>Math.round(t).toString(16).toUpperCase(),x:t=>Math.round(t).toString(16)};function Ye(t){return t}var Ke,Ue,Ge,Ze=Array.prototype.map,Je=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];function Qe(t){var e=t.domain;return t.ticks=function(t){var n=e();return Be(n[0],n[n.length-1],null==t?10:t)},t.tickFormat=function(t,n){var i=e();return function(t,e,n,i){var r,o=function(t,e,n){var i=Math.abs(e-t)/Math.max(0,n),r=Math.pow(10,Math.floor(Math.log(i)/Math.LN10)),o=i/r;return o>=Ee?r*=10:o>=Oe?r*=5:o>=De&&(r*=2),e<t?-r:r}(t,e,n);switch((i=Re(null==i?",f":i)).type){case"s":var l=Math.max(Math.abs(t),Math.abs(e));return null!=i.precision||isNaN(r=function(t,e){return Math.max(0,3*Math.max(-8,Math.min(8,Math.floor(We(e)/3)))-We(Math.abs(t)))}(o,l))||(i.precision=r),Ge(i,l);case"":case"e":case"g":case"p":case"r":null!=i.precision||isNaN(r=function(t,e){return t=Math.abs(t),e=Math.abs(e)-t,Math.max(0,We(e)-We(t))+1}(o,Math.max(Math.abs(t),Math.abs(e))))||(i.precision=r-("e"===i.type));break;case"f":case"%":null!=i.precision||isNaN(r=function(t){return Math.max(0,-We(Math.abs(t)))}(o))||(i.precision=r-2*("%"===i.type))}return Ue(i)}(i[0],i[i.length-1],null==t?10:t,n)},t.nice=function(n){null==n&&(n=10);var i,r,o=e(),l=0,a=o.length-1,s=o[l],c=o[a],u=10;for(c<s&&(r=s,s=c,c=r,r=l,l=a,a=r);u-- >0;){if((r=je(s,c,n))===i)return o[l]=s,o[a]=c,e(o);if(r>0)s=Math.floor(s/r)*r,c=Math.ceil(c/r)*r;else{if(!(r<0))break;s=Math.ceil(s*r)/r,c=Math.floor(c*r)/r}i=r}return t},t}function tn(){var t=Te();return t.copy=function(){return ze(t,tn())},Ce.apply(t,arguments),Qe(t)}function en(){var t,e,n,i,r,o=0,l=1,a=Le,s=!1;function c(e){return null==e||isNaN(e=+e)?r:a(0===n?.5:(e=(i(e)-t)*n,s?Math.max(0,Math.min(1,e)):e))}function u(t){return function(e){var n,i;return arguments.length?([n,i]=e,a=t(n,i),c):[a(0),a(1)]}}return c.domain=function(r){return arguments.length?([o,l]=r,t=i(o=+o),e=i(l=+l),n=t===e?0:1/(e-t),c):[o,l]},c.clamp=function(t){return arguments.length?(s=!!t,c):s},c.interpolator=function(t){return arguments.length?(a=t,c):a},c.range=u(pe),c.rangeRound=u(ge),c.unknown=function(t){return arguments.length?(r=t,c):r},function(r){return i=r,t=r(o),e=r(l),n=t===e?0:1/(e-t),c}}function nn(t,e){return e.domain(t.domain()).interpolator(t.interpolator()).clamp(t.clamp()).unknown(t.unknown())}function rn(){var t=Qe(en()(Le));return t.copy=function(){return nn(t,rn())},qe.apply(t,arguments)}function on(t,e){void 0===e&&(e=t,t=pe);for(var n=0,i=e.length-1,r=e[0],o=new Array(i<0?0:i);n<i;)o[n]=t(r,r=e[++n]);return function(t){var e=Math.max(0,Math.min(i-1,Math.floor(t*=i)));return o[e](t-e)}}function ln(){var t,e,n,i,r,o,l,a=0,s=.5,c=1,u=1,h=Le,d=!1;function f(t){return isNaN(t=+t)?l:(t=.5+((t=+o(t))-e)*(u*t<u*e?i:r),h(d?Math.max(0,Math.min(1,t)):t))}function p(t){return function(e){var n,i,r;return arguments.length?([n,i,r]=e,h=on(t,[n,i,r]),f):[h(0),h(.5),h(1)]}}return f.domain=function(l){return arguments.length?([a,s,c]=l,t=o(a=+a),e=o(s=+s),n=o(c=+c),i=t===e?0:.5/(e-t),r=e===n?0:.5/(n-e),u=e<t?-1:1,f):[a,s,c]},f.clamp=function(t){return arguments.length?(d=!!t,f):d},f.interpolator=function(t){return arguments.length?(h=t,f):h},f.range=p(pe),f.rangeRound=p(ge),f.unknown=function(t){return arguments.length?(l=t,f):l},function(l){return o=l,t=l(a),e=l(s),n=l(c),i=t===e?0:.5/(e-t),r=e===n?0:.5/(n-e),u=e<t?-1:1,f}}function an(){var t=Qe(ln()(Le));return t.copy=function(){return nn(t,an())},qe.apply(t,arguments)}function sn(t){for(var e=t.length/6|0,n=new Array(e),i=0;i<e;)n[i]="#"+t.slice(6*i,6*++i);return n}Ke=function(t){var e,n,i=void 0===t.grouping||void 0===t.thousands?Ye:(e=Ze.call(t.grouping,Number),n=t.thousands+"",function(t,i){for(var r=t.length,o=[],l=0,a=e[0],s=0;r>0&&a>0&&(s+a+1>i&&(a=Math.max(1,i-s)),o.push(t.substring(r-=a,r+a)),!((s+=a+1)>i));)a=e[l=(l+1)%e.length];return o.reverse().join(n)}),r=void 0===t.currency?"":t.currency[0]+"",o=void 0===t.currency?"":t.currency[1]+"",l=void 0===t.decimal?".":t.decimal+"",a=void 0===t.numerals?Ye:function(t){return function(e){return e.replace(/[0-9]/g,(function(e){return t[+e]}))}}(Ze.call(t.numerals,String)),s=void 0===t.percent?"%":t.percent+"",c=void 0===t.minus?"−":t.minus+"",u=void 0===t.nan?"NaN":t.nan+"";function h(t){var e=(t=Re(t)).fill,n=t.align,h=t.sign,d=t.symbol,f=t.zero,p=t.width,g=t.comma,m=t.precision,v=t.trim,y=t.type;"n"===y?(g=!0,y="g"):Xe[y]||(void 0===m&&(m=12),v=!0,y="g"),(f||"0"===e&&"="===n)&&(f=!0,e="0",n="=");var b="$"===d?r:"#"===d&&/[boxX]/.test(y)?"0"+y.toLowerCase():"",w="$"===d?o:/[%p]/.test(y)?s:"",$=Xe[y],x=/[defgprs%]/.test(y);function _(t){var r,o,s,d=b,_=w;if("c"===y)_=$(t)+_,t="";else{var k=(t=+t)<0||1/t<0;if(t=isNaN(t)?u:$(Math.abs(t),m),v&&(t=function(t){t:for(var e,n=t.length,i=1,r=-1;i<n;++i)switch(t[i]){case".":r=e=i;break;case"0":0===r&&(r=i),e=i;break;default:if(!+t[i])break t;r>0&&(r=0)}return r>0?t.slice(0,r)+t.slice(e+1):t}(t)),k&&0==+t&&"+"!==h&&(k=!1),d=(k?"("===h?h:c:"-"===h||"("===h?"":h)+d,_=("s"===y?Je[8+Pe/3]:"")+_+(k&&"("===h?")":""),x)for(r=-1,o=t.length;++r<o;)if(48>(s=t.charCodeAt(r))||s>57){_=(46===s?l+t.slice(r+1):t.slice(r))+_,t=t.slice(0,r);break}}g&&!f&&(t=i(t,1/0));var M=d.length+t.length+_.length,L=M<p?new Array(p-M+1).join(e):"";switch(g&&f&&(t=i(L+t,L.length?p-_.length:1/0),L=""),n){case"<":t=d+t+_+L;break;case"=":t=d+L+t+_;break;case"^":t=L.slice(0,M=L.length>>1)+d+t+_+L.slice(M);break;default:t=L+d+t+_}return a(t)}return m=void 0===m?6:/[gprs]/.test(y)?Math.max(1,Math.min(21,m)):Math.max(0,Math.min(20,m)),_.toString=function(){return t+""},_}return{format:h,formatPrefix:function(t,e){var n=h(((t=Re(t)).type="f",t)),i=3*Math.max(-8,Math.min(8,Math.floor(We(e)/3))),r=Math.pow(10,-i),o=Je[8+i/3];return function(t){return n(r*t)+o}}}}({thousands:",",grouping:[3],currency:["$",""]}),Ue=Ke.format,Ge=Ke.formatPrefix;const cn=t=>oe(t[t.length-1]),un=cn(new Array(3).concat("edf8b17fcdbb2c7fb8","ffffcca1dab441b6c4225ea8","ffffcca1dab441b6c42c7fb8253494","ffffccc7e9b47fcdbb41b6c42c7fb8253494","ffffccc7e9b47fcdbb41b6c41d91c0225ea80c2c84","ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea80c2c84","ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea8253494081d58").map(sn)),hn=cn(new Array(3).concat("d8b365f5f5f55ab4ac","a6611adfc27d80cdc1018571","a6611adfc27df5f5f580cdc1018571","8c510ad8b365f6e8c3c7eae55ab4ac01665e","8c510ad8b365f6e8c3f5f5f5c7eae55ab4ac01665e","8c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e","8c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e","5430058c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e003c30","5430058c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e003c30").map(sn));class dn extends Map{constructor(t,e=vn){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:e}}),null!=t)for(const[e,n]of t)this.set(e,n)}get(t){return super.get(pn(this,t))}has(t){return super.has(pn(this,t))}set(t,e){return super.set(gn(this,t),e)}delete(t){return super.delete(mn(this,t))}}class fn extends Set{constructor(t,e=vn){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:e}}),null!=t)for(const e of t)this.add(e)}has(t){return super.has(pn(this,t))}add(t){return super.add(gn(this,t))}delete(t){return super.delete(mn(this,t))}}function pn({_intern:t,_key:e},n){const i=e(n);return t.has(i)?t.get(i):n}function gn({_intern:t,_key:e},n){const i=e(n);return t.has(i)?t.get(i):(t.set(i,n),n)}function mn({_intern:t,_key:e},n){const i=e(n);return t.has(i)&&(n=t.get(i),t.delete(i)),n}function vn(t){return null!==t&&"object"==typeof t?t.valueOf():t}function yn(t){return t}function bn(t,e,...n){return function(t,e,n,i){return function t(r,o){if(o>=i.length)return n(r);const l=new dn,a=i[o++];let s=-1;for(const t of r){const e=a(t,++s,r),n=l.get(e);n?n.push(t):l.set(e,[t])}for(const[e,n]of l)l.set(e,t(n,o));return e(l)}(t,0)}(t,yn,e,n)}function wn(t,e,n){t=+t,e=+e,n=(r=arguments.length)<2?(e=t,t=0,1):r<3?1:+n;for(var i=-1,r=0|Math.max(0,Math.ceil((e-t)/n)),o=new Array(r);++i<r;)o[i]=t+i*n;return o}function $n(t){const e=function(t,e){let n=0;for(let e of t)(e=+e)&&(n+=e);return n}(t);return t.map((t=>t/e))}function xn(t,e,n,i){const r=window.devicePixelRatio||1;t.width=n*r,t.height=i*r,t.style.width=n+"px",t.style.height=i+"px",e.scale(r,r)}function _n(t){return t>=.001&&t<=1||t>=-1&&t<=.001?Ue(".3~f")(t):Ue("~s")(t)}function kn(t,e,n,i,r,o,l,a,s,c){return r?"lines"===i?tn().domain([t.ice.ice_min,t.ice.ice_max]).nice().range([e-c.bottom,c.top]):"centered-lines"===i?tn().domain([t.ice.centered_ice_min,t.ice.centered_ice_max]).nice().range([e-c.bottom,c.top]):"cluster-centers"===i?tn().domain([t.ice.centered_mean_min,t.ice.centered_mean_max]).nice().range([e-c.bottom,c.top]):tn().domain([t.ice.centered_ice_min,t.ice.centered_ice_max]).nice().range([n-c.bottom,c.top]):"lines"===i?tn().domain(o).nice().range([e-c.bottom,c.top]):"centered-lines"===i?tn().domain(s).nice().range([e-c.bottom,c.top]):"cluster-centers"===i?tn().domain(l).nice().range([e-c.bottom,c.top]):tn().domain(s).nice().range([n-c.bottom,c.top])}function Mn(t,e,n){const i=n.map((t=>e[t]));if("categorical"===t.kind){const e=bn(i,(t=>t.length),(t=>t)),n=t.distribution.bins.map((t=>{var n;return null!==(n=e.get(t))&&void 0!==n?n:0})),r=$n(n);return{bins:t.distribution.bins,counts:n,percents:r}}{const e=bn(i,(t=>t.length),(e=>xe(t.distribution.bins,e,0,t.distribution.bins.length-1)-1)),n=wn(t.distribution.counts.length).map((t=>{var n;return null!==(n=e.get(t))&&void 0!==n?n:0})),r=$n(n);return{bins:t.distribution.bins,counts:n,percents:r}}}const Ln=["#a6cee3","#fdbf6f","#b2df8a","#fb9a99","#cab2d6"],An=["#67a3cb","#fea13f","#7abf5a","#f4645d","#9c76b7"],Sn=["#1f78b4","#ff7f00","#33a02c","#e31a1c","#6a3d9a"];function Nn(t,e,n){const i=t,r=vt(e),o=n.get(i);return void 0!==o&&r.set(o),n.on("change:"+i,(()=>r.set(n.get(i))),null),{set:t=>{r.set(t),n&&(n.set(i,t),n.save_changes())},subscribe:r.subscribe,update:t=>{r.update((e=>{const r=t(e);return n&&(n.set(i,r),n.save_changes()),r}))}}}let zn,Tn,Cn,qn,En,On,Dn,Bn,jn,Pn,Hn,Rn,In,Vn,Wn,Fn,Xn,Yn,Kn,Un,Gn,Zn,Jn;function Qn(t){zn=Nn("feature_names",[],t),Tn=Nn("feature_info",{},t),Cn=Nn("dataset",{},t),qn=Nn("num_instances",0,t),En=Nn("one_way_pds",[],t),On=Nn("two_way_pds",[],t),Dn=Nn("two_way_pdp_extent",[0,0],t),Bn=Nn("two_way_interaction_extent",[0,0],t),jn=Nn("ice_line_extent",[0,0],t),Pn=Nn("ice_cluster_center_extent",[0,0],t),Hn=Nn("ice_cluster_band_extent",[0,0],t),Rn=Nn("ice_cluster_line_extent",[0,0],t),In=Nn("height",600,t),Vn=Nn("highlighted_indices",[],t),Wn=Nn("two_way_to_calculate",[],t),Fn=vt("one-way-plots");const e=t.get("one_way_pds"),n=e&&e.length>0?e[0].x_feature:"";Xn=vt(n),Yn=vt(""),Kn=vt(!1),Un=yt(Dn,(t=>rn().domain(t).interpolator(un).unknown("black"))),Gn=yt(Bn,(t=>an().domain([t[0],0,t[1]]).interpolator(hn).unknown("black"))),Zn=yt(En,(t=>new Map(t.map((t=>[t.x_feature,t]))))),Jn=yt([Tn,Cn,Vn],(([t,e,n])=>new Map(Object.entries(t).map((([t,i])=>[t,Mn(i,e[t],n)])))))}function ti(t){w(t,"svelte-a3do9k","div.svelte-a3do9k.svelte-a3do9k{display:flex;padding:0.25em;background-color:var(--gray-1)}button.svelte-a3do9k.svelte-a3do9k{border:none;border-radius:0;background-color:transparent}button.tab-selected.svelte-a3do9k.svelte-a3do9k{border-bottom:1px solid black}ul.svelte-a3do9k.svelte-a3do9k{list-style:none}li.svelte-a3do9k.svelte-a3do9k{display:inline-flex}li.svelte-a3do9k+li.svelte-a3do9k{margin-left:0.5em}")}function ei(t,e,n){const i=t.slice();return i[4]=e[n].value,i[5]=e[n].title,i}function ni(t){let e,n,i,r,o,l,a=t[5]+"";function s(){return t[3](t[4])}return{c(){e=k("li"),n=k("button"),i=L(a),r=A(),z(n,"class","svelte-a3do9k"),B(n,"tab-selected",t[4]===t[0]),z(e,"class","svelte-a3do9k")},m(t,a){$(t,e,a),b(e,n),b(n,i),b(e,r),o||(l=N(n,"click",s),o=!0)},p(e,i){t=e,3&i&&B(n,"tab-selected",t[4]===t[0])},d(t){t&&x(e),o=!1,l()}}}function ii(t){let e,n,i=t[1],r=[];for(let e=0;e<i.length;e+=1)r[e]=ni(ei(t,i,e));return{c(){e=k("div"),n=k("ul");for(let t=0;t<r.length;t+=1)r[t].c();z(n,"class","svelte-a3do9k"),z(e,"class","svelte-a3do9k")},m(t,i){$(t,e,i),b(e,n);for(let t=0;t<r.length;t+=1)r[t].m(n,null)},p(t,[e]){if(7&e){let o;for(i=t[1],o=0;o<i.length;o+=1){const l=ei(t,i,o);r[o]?r[o].p(l,e):(r[o]=ni(l),r[o].c(),r[o].m(n,null))}for(;o<r.length;o+=1)r[o].d(1);r.length=i.length}},i:l,o:l,d(t){t&&x(e),_(r,t)}}}function ri(t,e,n){let i;function r(t){m(Fn,i=t,i)}return p(t,Fn,(t=>n(0,i=t))),[i,[{value:"one-way-plots",title:"One-way Plots"},{value:"two-way-plots",title:"Two-way Plots"},{value:"detailed-plot",title:"Detailed Plot"}],r,t=>r(t)]}const oi=class extends gt{constructor(t){super(),pt(this,t,ri,ii,h,{},ti)}},li=Symbol("implicit");function ai(){var t=new dn,e=[],n=[],i=li;function r(r){let o=t.get(r);if(void 0===o){if(i!==li)return i;t.set(r,o=e.push(r)-1)}return n[o%n.length]}return r.domain=function(n){if(!arguments.length)return e.slice();e=[],t=new dn;for(const i of n)t.has(i)||t.set(i,e.push(i)-1);return r},r.range=function(t){return arguments.length?(n=Array.from(t),r):n.slice()},r.unknown=function(t){return arguments.length?(i=t,r):i},r.copy=function(){return ai(e,n).unknown(i)},Ce.apply(r,arguments),r}function si(){var t,e,n=ai().unknown(void 0),i=n.domain,r=n.range,o=0,l=1,a=!1,s=0,c=0,u=.5;function h(){var n=i().length,h=l<o,d=h?l:o,f=h?o:l;t=(f-d)/Math.max(1,n-s+2*c),a&&(t=Math.floor(t)),d+=(f-d-t*(n-s))*u,e=t*(1-s),a&&(d=Math.round(d),e=Math.round(e));var p=wn(n).map((function(e){return d+t*e}));return r(h?p.reverse():p)}return delete n.unknown,n.domain=function(t){return arguments.length?(i(t),h()):i()},n.range=function(t){return arguments.length?([o,l]=t,o=+o,l=+l,h()):[o,l]},n.rangeRound=function(t){return[o,l]=t,o=+o,l=+l,a=!0,h()},n.bandwidth=function(){return e},n.step=function(){return t},n.round=function(t){return arguments.length?(a=!!t,h()):a},n.padding=function(t){return arguments.length?(s=Math.min(1,c=+t),h()):s},n.paddingInner=function(t){return arguments.length?(s=Math.min(1,t),h()):s},n.paddingOuter=function(t){return arguments.length?(c=+t,h()):c},n.align=function(t){return arguments.length?(u=Math.max(0,Math.min(1,t)),h()):u},n.copy=function(){return si(i(),[o,l]).round(a).paddingInner(s).paddingOuter(c).align(u)},Ce.apply(h(),arguments)}function ci(t){var e=t.copy;return t.padding=t.paddingOuter,delete t.paddingInner,delete t.paddingOuter,t.copy=function(){return ci(e())},t}function ui(){return ci(si.apply(null,arguments).paddingInner(1))}const hi=Math.PI,di=2*hi,fi=1e-6,pi=di-fi;function gi(){this._x0=this._y0=this._x1=this._y1=null,this._=""}function mi(){return new gi}gi.prototype=mi.prototype={constructor:gi,moveTo:function(t,e){this._+="M"+(this._x0=this._x1=+t)+","+(this._y0=this._y1=+e)},closePath:function(){null!==this._x1&&(this._x1=this._x0,this._y1=this._y0,this._+="Z")},lineTo:function(t,e){this._+="L"+(this._x1=+t)+","+(this._y1=+e)},quadraticCurveTo:function(t,e,n,i){this._+="Q"+ +t+","+ +e+","+(this._x1=+n)+","+(this._y1=+i)},bezierCurveTo:function(t,e,n,i,r,o){this._+="C"+ +t+","+ +e+","+ +n+","+ +i+","+(this._x1=+r)+","+(this._y1=+o)},arcTo:function(t,e,n,i,r){t=+t,e=+e,n=+n,i=+i,r=+r;var o=this._x1,l=this._y1,a=n-t,s=i-e,c=o-t,u=l-e,h=c*c+u*u;if(r<0)throw new Error("negative radius: "+r);if(null===this._x1)this._+="M"+(this._x1=t)+","+(this._y1=e);else if(h>fi)if(Math.abs(u*a-s*c)>fi&&r){var d=n-o,f=i-l,p=a*a+s*s,g=d*d+f*f,m=Math.sqrt(p),v=Math.sqrt(h),y=r*Math.tan((hi-Math.acos((p+h-g)/(2*m*v)))/2),b=y/v,w=y/m;Math.abs(b-1)>fi&&(this._+="L"+(t+b*c)+","+(e+b*u)),this._+="A"+r+","+r+",0,0,"+ +(u*d>c*f)+","+(this._x1=t+w*a)+","+(this._y1=e+w*s)}else this._+="L"+(this._x1=t)+","+(this._y1=e)},arc:function(t,e,n,i,r,o){t=+t,e=+e,o=!!o;var l=(n=+n)*Math.cos(i),a=n*Math.sin(i),s=t+l,c=e+a,u=1^o,h=o?i-r:r-i;if(n<0)throw new Error("negative radius: "+n);null===this._x1?this._+="M"+s+","+c:(Math.abs(this._x1-s)>fi||Math.abs(this._y1-c)>fi)&&(this._+="L"+s+","+c),n&&(h<0&&(h=h%di+di),h>pi?this._+="A"+n+","+n+",0,1,"+u+","+(t-l)+","+(e-a)+"A"+n+","+n+",0,1,"+u+","+(this._x1=s)+","+(this._y1=c):h>fi&&(this._+="A"+n+","+n+",0,"+ +(h>=hi)+","+u+","+(this._x1=t+n*Math.cos(r))+","+(this._y1=e+n*Math.sin(r))))},rect:function(t,e,n,i){this._+="M"+(this._x0=this._x1=+t)+","+(this._y0=this._y1=+e)+"h"+ +n+"v"+ +i+"h"+-n+"Z"},toString:function(){return this._}};const vi=mi;function yi(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function bi(t){return function(){return t}}function wi(t){this._context=t}function $i(t){return new wi(t)}function xi(t){return t[0]}function _i(t){return t[1]}function ki(t,e){var n=bi(!0),i=null,r=$i,o=null;function l(l){var a,s,c,u=(l=yi(l)).length,h=!1;for(null==i&&(o=r(c=vi())),a=0;a<=u;++a)!(a<u&&n(s=l[a],a,l))===h&&((h=!h)?o.lineStart():o.lineEnd()),h&&o.point(+t(s,a,l),+e(s,a,l));if(c)return o=null,c+""||null}return t="function"==typeof t?t:void 0===t?xi:bi(t),e="function"==typeof e?e:void 0===e?_i:bi(e),l.x=function(e){return arguments.length?(t="function"==typeof e?e:bi(+e),l):t},l.y=function(t){return arguments.length?(e="function"==typeof t?t:bi(+t),l):e},l.defined=function(t){return arguments.length?(n="function"==typeof t?t:bi(!!t),l):n},l.curve=function(t){return arguments.length?(r=t,null!=i&&(o=r(i)),l):r},l.context=function(t){return arguments.length?(null==t?i=o=null:o=r(i=t),l):i},l}function Mi(t){let e,n,i,r;return{c(){e=M("text"),n=M("title"),i=L(t[6]),z(e,"x",t[2]),z(e,"y",t[3]),z(e,"width",t[0]),z(e,"height",t[1]),z(e,"fill","black"),z(e,"dominant-baseline","hanging"),z(e,"text-anchor","middle"),z(e,"font-size",t[7]),z(e,"transform",r=t[5]?`rotate(270, ${t[2]}, ${t[3]})`:null),B(e,"pdpilot-bold",t[4])},m(r,o){$(r,e,o),b(e,n),b(n,i),t[9](e)},p(t,[n]){64&n&&C(i,t[6]),4&n&&z(e,"x",t[2]),8&n&&z(e,"y",t[3]),1&n&&z(e,"width",t[0]),2&n&&z(e,"height",t[1]),128&n&&z(e,"font-size",t[7]),44&n&&r!==(r=t[5]?`rotate(270, ${t[2]}, ${t[3]})`:null)&&z(e,"transform",r),16&n&&B(e,"pdpilot-bold",t[4])},i:l,o:l,d(n){n&&x(e),t[9](null)}}}function Li(t,e,n){let i,{width:r=0}=e,{height:o=0}=e,{x:l=0}=e,{y:a=0}=e,{bold:s=!1}=e,{rotate:c=!1}=e,{label:u=""}=e,{fontSize:h=14}=e;function d(t,e){if(!i)return;n(8,i.textContent=t,i);let r=t;for(;r.length>0&&i.getComputedTextLength()>e;)r=r.slice(0,-1),n(8,i.textContent=r+"…",i)}return H((()=>{d(u,r)})),t.$$set=t=>{"width"in t&&n(0,r=t.width),"height"in t&&n(1,o=t.height),"x"in t&&n(2,l=t.x),"y"in t&&n(3,a=t.y),"bold"in t&&n(4,s=t.bold),"rotate"in t&&n(5,c=t.rotate),"label"in t&&n(6,u=t.label),"fontSize"in t&&n(7,h=t.fontSize)},t.$$.update=()=>{65&t.$$.dirty&&d(u,r)},[r,o,l,a,s,c,u,h,i,function(t){V[t?"unshift":"push"]((()=>{i=t,n(8,i)}))}]}Array.prototype.slice,wi.prototype={areaStart:function(){this._line=0},areaEnd:function(){this._line=NaN},lineStart:function(){this._point=0},lineEnd:function(){(this._line||0!==this._line&&1===this._point)&&this._context.closePath(),this._line=1-this._line},point:function(t,e){switch(t=+t,e=+e,this._point){case 0:this._point=1,this._line?this._context.lineTo(t,e):this._context.moveTo(t,e);break;case 1:this._point=2;default:this._context.lineTo(t,e)}}};const Ai=class extends gt{constructor(t){super(),pt(this,t,Li,Mi,h,{width:0,height:1,x:2,y:3,bold:4,rotate:5,label:6,fontSize:7})}};function Si(t,e,n){const i=t.slice();return i[20]=e[n],i}function Ni(t,e,n){const i=t.slice();return i[20]=e[n],i}function zi(t){let e,n,i;return{c(){e=M("line"),z(e,"x1",n=t[0].range()[0]),z(e,"x2",i=t[0].range()[1]),z(e,"stroke",t[10])},m(t,n){$(t,e,n)},p(t,r){1&r&&n!==(n=t[0].range()[0])&&z(e,"x1",n),1&r&&i!==(i=t[0].range()[1])&&z(e,"x2",i),1024&r&&z(e,"stroke",t[10])},d(t){t&&x(e)}}}function Ti(t){let e,n=t[18](t[0],t[17],t[14]),i=[];for(let e=0;e<n.length;e+=1)i[e]=Ei(Si(t,n,e));return{c(){for(let t=0;t<i.length;t+=1)i[t].c();e=S()},m(t,n){for(let e=0;e<i.length;e+=1)i[e].m(t,n);$(t,e,n)},p(t,r){if(424625&r){let o;for(n=t[18](t[0],t[17],t[14]),o=0;o<n.length;o+=1){const l=Si(t,n,o);i[o]?i[o].p(l,r):(i[o]=Ei(l),i[o].c(),i[o].m(e.parentNode,e))}for(;o<i.length;o+=1)i[o].d(1);i.length=n.length}},i:l,o:l,d(t){_(i,t),t&&x(e)}}}function Ci(t){let e,n,i=t[0].domain(),r=[];for(let e=0;e<i.length;e+=1)r[e]=Bi(Ni(t,i,e));const o=t=>lt(r[t],1,1,(()=>{r[t]=null}));return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=S()},m(t,i){for(let e=0;e<r.length;e+=1)r[e].m(t,i);$(t,e,i),n=!0},p(t,n){if(47777&n){let l;for(i=t[0].domain(),l=0;l<i.length;l+=1){const o=Ni(t,i,l);r[l]?(r[l].p(o,n),ot(r[l],1)):(r[l]=Bi(o),r[l].c(),ot(r[l],1),r[l].m(e.parentNode,e))}for(it(),l=i.length;l<r.length;l+=1)o(l);rt()}},i(t){if(!n){for(let t=0;t<i.length;t+=1)ot(r[t]);n=!0}},o(t){r=r.filter(Boolean);for(let t=0;t<r.length;t+=1)lt(r[t]);n=!1},d(t){_(r,t),t&&x(e)}}}function qi(t){let e,n,i,r,o=t[4](t[20])+"";return{c(){e=M("text"),n=L(o),z(e,"y",i=t[12]+t[13]),z(e,"text-anchor","middle"),z(e,"dominant-baseline","hanging"),z(e,"font-size",t[11]),z(e,"fill","black"),z(e,"stroke-width",r=2),z(e,"paint-order","stroke")},m(t,i){$(t,e,i),b(e,n)},p(t,r){147473&r&&o!==(o=t[4](t[20])+"")&&C(n,o),12288&r&&i!==(i=t[12]+t[13])&&z(e,"y",i),2048&r&&z(e,"font-size",t[11])},d(t){t&&x(e)}}}function Ei(t){let e,n,i,r=t[7]&&qi(t);return{c(){e=M("g"),n=M("line"),r&&r.c(),z(n,"y1",t[5]),z(n,"y2",t[12]),z(n,"stroke",t[9]),z(e,"transform",i="translate("+t[0](t[20])+")")},m(t,i){$(t,e,i),b(e,n),r&&r.m(e,null)},p(t,o){32&o&&z(n,"y1",t[5]),4096&o&&z(n,"y2",t[12]),512&o&&z(n,"stroke",t[9]),t[7]?r?r.p(t,o):(r=qi(t),r.c(),r.m(e,null)):r&&(r.d(1),r=null),147457&o&&i!==(i="translate("+t[0](t[20])+")")&&z(e,"transform",i)},d(t){t&&x(e),r&&r.d()}}}function Oi(t){let e,n,i;return{c(){e=M("line"),z(e,"y1",t[5]),z(e,"y2",t[12]),z(e,"x1",n=t[0].bandwidth()/2),z(e,"x2",i=t[0].bandwidth()/2),z(e,"stroke",t[9])},m(t,n){$(t,e,n)},p(t,r){32&r&&z(e,"y1",t[5]),4096&r&&z(e,"y2",t[12]),1&r&&n!==(n=t[0].bandwidth()/2)&&z(e,"x1",n),1&r&&i!==(i=t[0].bandwidth()/2)&&z(e,"x2",i),512&r&&z(e,"stroke",t[9])},d(t){t&&x(e)}}}function Di(t){let e,n;return e=new Ai({props:{width:t[0].bandwidth()||t[0].step(),height:t[11]*Ri,x:0===t[0].bandwidth()?0:t[0].bandwidth()/2,y:t[12]+t[13],bold:!1,label:t[15][t[20]]??t[20],fontSize:t[11]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1&n&&(i.width=t[0].bandwidth()||t[0].step()),2048&n&&(i.height=t[11]*Ri),1&n&&(i.x=0===t[0].bandwidth()?0:t[0].bandwidth()/2),12288&n&&(i.y=t[12]+t[13]),32769&n&&(i.label=t[15][t[20]]??t[20]),2048&n&&(i.fontSize=t[11]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Bi(t){let e,n,i,r,o=t[12]>0&&Oi(t),l=t[7]&&Di(t);return{c(){e=M("g"),o&&o.c(),n=S(),l&&l.c(),z(e,"transform",i="translate("+t[0](t[20])+")")},m(t,i){$(t,e,i),o&&o.m(e,null),b(e,n),l&&l.m(e,null),r=!0},p(t,a){t[12]>0?o?o.p(t,a):(o=Oi(t),o.c(),o.m(e,n)):o&&(o.d(1),o=null),t[7]?l?(l.p(t,a),128&a&&ot(l,1)):(l=Di(t),l.c(),ot(l,1),l.m(e,null)):l&&(it(),lt(l,1,1,(()=>{l=null})),rt()),(!r||1&a&&i!==(i="translate("+t[0](t[20])+")"))&&z(e,"transform",i)},i(t){r||(ot(l),r=!0)},o(t){lt(l),r=!1},d(t){t&&x(e),o&&o.d(),l&&l.d()}}}function ji(t){let e,n;return e=new Ai({props:{width:t[17],height:t[11]*Ri,x:t[17]/2+t[16],y:t[12]+t[13]+t[11]+Hi,bold:!0,label:t[1],fontSize:t[11]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};131072&n&&(i.width=t[17]),2048&n&&(i.height=t[11]*Ri),196608&n&&(i.x=t[17]/2+t[16]),14336&n&&(i.y=t[12]+t[13]+t[11]+Hi),2&n&&(i.label=t[1]),2048&n&&(i.fontSize=t[11]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Pi(t){let e,n,i,r,o,l,a,s=t[8]&&zi(t);const c=[Ci,Ti],u=[];function h(t,e){return"bandwidth"in t[0]?0:1}r=h(t),o=u[r]=c[r](t);let d=t[6]&&ji(t);return{c(){e=M("g"),n=M("g"),s&&s.c(),i=S(),o.c(),d&&d.c(),z(e,"transform",l="translate("+t[2]+","+t[3]+")")},m(t,o){$(t,e,o),b(e,n),s&&s.m(n,null),b(n,i),u[r].m(n,null),d&&d.m(e,null),a=!0},p(t,[f]){t[8]?s?s.p(t,f):(s=zi(t),s.c(),s.m(n,i)):s&&(s.d(1),s=null);let p=r;r=h(t),r===p?u[r].p(t,f):(it(),lt(u[p],1,1,(()=>{u[p]=null})),rt(),o=u[r],o?o.p(t,f):(o=u[r]=c[r](t),o.c()),ot(o,1),o.m(n,null)),t[6]?d?(d.p(t,f),64&f&&ot(d,1)):(d=ji(t),d.c(),ot(d,1),d.m(e,null)):d&&(it(),lt(d,1,1,(()=>{d=null})),rt()),(!a||12&f&&l!==(l="translate("+t[2]+","+t[3]+")"))&&z(e,"transform",l)},i(t){a||(ot(o),ot(d),a=!0)},o(t){lt(o),lt(d),a=!1},d(t){t&&x(e),s&&s.d(),u[r].d(),d&&d.d()}}}const Hi=2,Ri=1.2;function Ii(t,e,n){let i,r,o,{scale:l}=e,{label:a=""}=e,{x:s=0}=e,{y:c=0}=e,{format:u=_n}=e,{gridHeight:h=0}=e,{showAxisLabel:d=!0}=e,{showTickLabels:f=!0}=e,{showBaseline:p=!1}=e,{tickColor:g="black"}=e,{baselineColor:m="black"}=e,{fontSize:v=10}=e,{tickSize:y=5}=e,{gapBetweenTickAndTickLabel:b=2}=e,{integerOnly:w=!1}=e,{value_map:$={}}=e;return t.$$set=t=>{"scale"in t&&n(0,l=t.scale),"label"in t&&n(1,a=t.label),"x"in t&&n(2,s=t.x),"y"in t&&n(3,c=t.y),"format"in t&&n(4,u=t.format),"gridHeight"in t&&n(5,h=t.gridHeight),"showAxisLabel"in t&&n(6,d=t.showAxisLabel),"showTickLabels"in t&&n(7,f=t.showTickLabels),"showBaseline"in t&&n(8,p=t.showBaseline),"tickColor"in t&&n(9,g=t.tickColor),"baselineColor"in t&&n(10,m=t.baselineColor),"fontSize"in t&&n(11,v=t.fontSize),"tickSize"in t&&n(12,y=t.tickSize),"gapBetweenTickAndTickLabel"in t&&n(13,b=t.gapBetweenTickAndTickLabel),"integerOnly"in t&&n(14,w=t.integerOnly),"value_map"in t&&n(15,$=t.value_map)},t.$$.update=()=>{1&t.$$.dirty&&n(16,i=l.range()[0]),1&t.$$.dirty&&n(19,r=l.range()[l.range().length-1]),589824&t.$$.dirty&&n(17,o=r-i)},[l,a,s,c,u,h,d,f,p,g,m,v,y,b,w,$,i,o,function(t,e,n){const i=t.ticks(e/80);return n?i.filter(Number.isInteger):i},r]}const Vi=class extends gt{constructor(t){super(),pt(this,t,Ii,Pi,h,{scale:0,label:1,x:2,y:3,format:4,gridHeight:5,showAxisLabel:6,showTickLabels:7,showBaseline:8,tickColor:9,baselineColor:10,fontSize:11,tickSize:12,gapBetweenTickAndTickLabel:13,integerOnly:14,value_map:15})}};function Wi(t,e,n){const i=t.slice();return i[20]=e[n],i}function Fi(t,e,n){const i=t.slice();return i[20]=e[n],i}function Xi(t){let e,n,i;return{c(){e=M("line"),z(e,"y1",n=t[0].range()[0]),z(e,"y2",i=t[0].range()[1]),z(e,"stroke",t[10])},m(t,n){$(t,e,n)},p(t,r){1&r&&n!==(n=t[0].range()[0])&&z(e,"y1",n),1&r&&i!==(i=t[0].range()[1])&&z(e,"y2",i),1024&r&&z(e,"stroke",t[10])},d(t){t&&x(e)}}}function Yi(t){let e,n=t[18](t[0],t[17],t[14]),i=[];for(let e=0;e<n.length;e+=1)i[e]=Gi(Wi(t,n,e));return{c(){for(let t=0;t<i.length;t+=1)i[t].c();e=S()},m(t,n){for(let e=0;e<i.length;e+=1)i[e].m(t,n);$(t,e,n)},p(t,r){if(424625&r){let o;for(n=t[18](t[0],t[17],t[14]),o=0;o<n.length;o+=1){const l=Wi(t,n,o);i[o]?i[o].p(l,r):(i[o]=Gi(l),i[o].c(),i[o].m(e.parentNode,e))}for(;o<i.length;o+=1)i[o].d(1);i.length=n.length}},i:l,o:l,d(t){_(i,t),t&&x(e)}}}function Ki(t){let e,n,i=[],r=new Map,o=t[0].domain();const l=t=>t[20];for(let e=0;e<o.length;e+=1){let n=Fi(t,o,e),a=l(n);r.set(a,i[e]=Qi(a,n))}return{c(){for(let t=0;t<i.length;t+=1)i[t].c();e=S()},m(t,r){for(let e=0;e<i.length;e+=1)i[e].m(t,r);$(t,e,r),n=!0},p(t,n){47777&n&&(o=t[0].domain(),it(),i=ct(i,n,l,1,t,o,r,e.parentNode,st,Qi,e,Fi),rt())},i(t){if(!n){for(let t=0;t<o.length;t+=1)ot(i[t]);n=!0}},o(t){for(let t=0;t<i.length;t+=1)lt(i[t]);n=!1},d(t){for(let e=0;e<i.length;e+=1)i[e].d(t);t&&x(e)}}}function Ui(t){let e,n,i,r,o=t[4](t[20])+"";return{c(){e=M("text"),n=L(o),z(e,"x",i=-t[12]-t[13]),z(e,"text-anchor","end"),z(e,"dominant-baseline","middle"),z(e,"font-size",t[11]),z(e,"fill","black"),z(e,"stroke-width",r=2),z(e,"paint-order","stroke")},m(t,i){$(t,e,i),b(e,n)},p(t,r){147473&r&&o!==(o=t[4](t[20])+"")&&C(n,o),12288&r&&i!==(i=-t[12]-t[13])&&z(e,"x",i),2048&r&&z(e,"font-size",t[11])},d(t){t&&x(e)}}}function Gi(t){let e,n,i,r,o=t[7]&&Ui(t);return{c(){e=M("g"),n=M("line"),o&&o.c(),z(n,"x1",i=-t[12]),z(n,"x2",t[5]),z(n,"stroke",t[9]),z(e,"transform",r="translate(0,"+t[0](t[20])+")")},m(t,i){$(t,e,i),b(e,n),o&&o.m(e,null)},p(t,l){4096&l&&i!==(i=-t[12])&&z(n,"x1",i),32&l&&z(n,"x2",t[5]),512&l&&z(n,"stroke",t[9]),t[7]?o?o.p(t,l):(o=Ui(t),o.c(),o.m(e,null)):o&&(o.d(1),o=null),147457&l&&r!==(r="translate(0,"+t[0](t[20])+")")&&z(e,"transform",r)},d(t){t&&x(e),o&&o.d()}}}function Zi(t){let e,n,i,r;return{c(){e=M("line"),z(e,"y1",n=t[0].bandwidth()/2),z(e,"y2",i=t[0].bandwidth()/2),z(e,"x1",r=-t[12]),z(e,"x2",t[5]),z(e,"stroke",t[9])},m(t,n){$(t,e,n)},p(t,o){1&o&&n!==(n=t[0].bandwidth()/2)&&z(e,"y1",n),1&o&&i!==(i=t[0].bandwidth()/2)&&z(e,"y2",i),4096&o&&r!==(r=-t[12])&&z(e,"x1",r),32&o&&z(e,"x2",t[5]),512&o&&z(e,"stroke",t[9])},d(t){t&&x(e)}}}function Ji(t){let e,n;return e=new Ai({props:{width:t[0].bandwidth()||t[0].step(),height:t[11]*ir,x:-(t[12]+t[11]+t[13]),y:0===t[0].bandwidth()?0:t[0].bandwidth()/2,bold:!1,label:t[15][t[20]]??t[20],fontSize:t[11],rotate:!0}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1&n&&(i.width=t[0].bandwidth()||t[0].step()),2048&n&&(i.height=t[11]*ir),14336&n&&(i.x=-(t[12]+t[11]+t[13])),1&n&&(i.y=0===t[0].bandwidth()?0:t[0].bandwidth()/2),32769&n&&(i.label=t[15][t[20]]??t[20]),2048&n&&(i.fontSize=t[11]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Qi(t,e){let n,i,r,o,l=e[12]>0&&Zi(e),a=e[7]&&Ji(e);return{key:t,first:null,c(){n=M("g"),l&&l.c(),i=S(),a&&a.c(),z(n,"transform",r="translate(0,"+e[0](e[20])+")"),this.first=n},m(t,e){$(t,n,e),l&&l.m(n,null),b(n,i),a&&a.m(n,null),o=!0},p(t,s){(e=t)[12]>0?l?l.p(e,s):(l=Zi(e),l.c(),l.m(n,i)):l&&(l.d(1),l=null),e[7]?a?(a.p(e,s),128&s&&ot(a,1)):(a=Ji(e),a.c(),ot(a,1),a.m(n,null)):a&&(it(),lt(a,1,1,(()=>{a=null})),rt()),(!o||1&s&&r!==(r="translate(0,"+e[0](e[20])+")"))&&z(n,"transform",r)},i(t){o||(ot(a),o=!0)},o(t){lt(a),o=!1},d(t){t&&x(n),l&&l.d(),a&&a.d()}}}function tr(t){let e,n;return e=new Ai({props:{width:t[17],height:t[11]*ir,x:-(t[12]+t[13]+t[11]+nr),y:t[17]/2+t[16],bold:!0,label:t[1],rotate:!0,fontSize:t[11]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};131072&n&&(i.width=t[17]),2048&n&&(i.height=t[11]*ir),14336&n&&(i.x=-(t[12]+t[13]+t[11]+nr)),196608&n&&(i.y=t[17]/2+t[16]),2&n&&(i.label=t[1]),2048&n&&(i.fontSize=t[11]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function er(t){let e,n,i,r,o,l,a,s=t[8]&&Xi(t);const c=[Ki,Yi],u=[];function h(t,e){return"bandwidth"in t[0]?0:1}r=h(t),o=u[r]=c[r](t);let d=t[6]&&tr(t);return{c(){e=M("g"),n=M("g"),s&&s.c(),i=S(),o.c(),d&&d.c(),z(e,"transform",l="translate("+t[2]+","+t[3]+")")},m(t,o){$(t,e,o),b(e,n),s&&s.m(n,null),b(n,i),u[r].m(n,null),d&&d.m(e,null),a=!0},p(t,[f]){t[8]?s?s.p(t,f):(s=Xi(t),s.c(),s.m(n,i)):s&&(s.d(1),s=null);let p=r;r=h(t),r===p?u[r].p(t,f):(it(),lt(u[p],1,1,(()=>{u[p]=null})),rt(),o=u[r],o?o.p(t,f):(o=u[r]=c[r](t),o.c()),ot(o,1),o.m(n,null)),t[6]?d?(d.p(t,f),64&f&&ot(d,1)):(d=tr(t),d.c(),ot(d,1),d.m(e,null)):d&&(it(),lt(d,1,1,(()=>{d=null})),rt()),(!a||12&f&&l!==(l="translate("+t[2]+","+t[3]+")"))&&z(e,"transform",l)},i(t){a||(ot(o),ot(d),a=!0)},o(t){lt(o),lt(d),a=!1},d(t){t&&x(e),s&&s.d(),u[r].d(),d&&d.d()}}}const nr=30,ir=1.2;function rr(t,e,n){let i,r,o,{scale:l}=e,{label:a=""}=e,{x:s=0}=e,{y:c=0}=e,{format:u=_n}=e,{gridWidth:h=0}=e,{showAxisLabel:d=!0}=e,{showTickLabels:f=!0}=e,{showBaseline:p=!1}=e,{tickColor:g="black"}=e,{baselineColor:m="black"}=e,{fontSize:v=10}=e,{tickSize:y=5}=e,{gapBetweenTickAndTickLabel:b=2}=e,{integerOnly:w=!1}=e,{value_map:$={}}=e;return t.$$set=t=>{"scale"in t&&n(0,l=t.scale),"label"in t&&n(1,a=t.label),"x"in t&&n(2,s=t.x),"y"in t&&n(3,c=t.y),"format"in t&&n(4,u=t.format),"gridWidth"in t&&n(5,h=t.gridWidth),"showAxisLabel"in t&&n(6,d=t.showAxisLabel),"showTickLabels"in t&&n(7,f=t.showTickLabels),"showBaseline"in t&&n(8,p=t.showBaseline),"tickColor"in t&&n(9,g=t.tickColor),"baselineColor"in t&&n(10,m=t.baselineColor),"fontSize"in t&&n(11,v=t.fontSize),"tickSize"in t&&n(12,y=t.tickSize),"gapBetweenTickAndTickLabel"in t&&n(13,b=t.gapBetweenTickAndTickLabel),"integerOnly"in t&&n(14,w=t.integerOnly),"value_map"in t&&n(15,$=t.value_map)},t.$$.update=()=>{1&t.$$.dirty&&n(16,i=Math.min(l.range()[0],l.range()[l.range().length-1])),1&t.$$.dirty&&n(19,r=Math.max(l.range()[0],l.range()[l.range().length-1])),589824&t.$$.dirty&&n(17,o=r-i)},[l,a,s,c,u,h,d,f,p,g,m,v,y,b,w,$,i,o,function(t,e,n){const i=t.ticks(Math.min(e/30,10));return n?i.filter(Number.isInteger):i},r]}const or=class extends gt{constructor(t){super(),pt(this,t,rr,er,h,{scale:0,label:1,x:2,y:3,format:4,gridWidth:5,showAxisLabel:6,showTickLabels:7,showBaseline:8,tickColor:9,baselineColor:10,fontSize:11,tickSize:12,gapBetweenTickAndTickLabel:13,integerOnly:14,value_map:15})}};function lr(t,e,n){const i=t.slice();return i[13]=e[n],i}function ar(t,e,n){const i=t.slice();return i[13]=e[n],i}function sr(t){let e,n,i,r,o,l=t[8],a=[];for(let e=0;e<l.length;e+=1)a[e]=ur(lr(t,l,e));return{c(){for(let t=0;t<a.length;t+=1)a[t].c();e=M("line"),z(e,"x1",n=0),z(e,"x2",i=0),z(e,"y1",r=t[3].range()[0]),z(e,"y2",o=t[3].range()[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<a.length;e+=1)a[e].m(t,n);$(t,e,n)},p(t,n){if(1001&n){let i;for(l=t[8],i=0;i<l.length;i+=1){const r=lr(t,l,i);a[i]?a[i].p(r,n):(a[i]=ur(r),a[i].c(),a[i].m(e.parentNode,e))}for(;i<a.length;i+=1)a[i].d(1);a.length=l.length}8&n&&r!==(r=t[3].range()[0])&&z(e,"y1",r),8&n&&o!==(o=t[3].range()[1])&&z(e,"y2",o)},d(t){_(a,t),t&&x(e)}}}function cr(t){let e,n,i,r=t[8],o=[];for(let e=0;e<r.length;e+=1)o[e]=hr(ar(t,r,e));return{c(){for(let t=0;t<o.length;t+=1)o[t].c();e=M("line"),z(e,"x1",n=t[3].range()[0]),z(e,"x2",i=t[3].range()[1]),z(e,"y1",t[1]),z(e,"y2",t[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<o.length;e+=1)o[e].m(t,n);$(t,e,n)},p(t,l){if(1001&l){let n;for(r=t[8],n=0;n<r.length;n+=1){const i=ar(t,r,n);o[n]?o[n].p(i,l):(o[n]=hr(i),o[n].c(),o[n].m(e.parentNode,e))}for(;n<o.length;n+=1)o[n].d(1);o.length=r.length}8&l&&n!==(n=t[3].range()[0])&&z(e,"x1",n),8&l&&i!==(i=t[3].range()[1])&&z(e,"x2",i),2&l&&z(e,"y1",t[1]),2&l&&z(e,"y2",t[1])},d(t){_(o,t),t&&x(e)}}}function ur(t){let e,n,i,r,o;return{c(){e=M("rect"),z(e,"x",n=0),z(e,"y",i=t[3](t[0].bins[t[13]+1])+1),z(e,"width",r=t[7](t[9](t[0],t[13]))),z(e,"height",o=t[3](t[0].bins[t[13]])-t[3](t[0].bins[t[13]+1])-2),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){$(t,e,n)},p(t,n){265&n&&i!==(i=t[3](t[0].bins[t[13]+1])+1)&&z(e,"y",i),897&n&&r!==(r=t[7](t[9](t[0],t[13])))&&z(e,"width",r),265&n&&o!==(o=t[3](t[0].bins[t[13]])-t[3](t[0].bins[t[13]+1])-2)&&z(e,"height",o),32&n&&z(e,"fill",t[5]),64&n&&z(e,"stroke",t[6])},d(t){t&&x(e)}}}function hr(t){let e,n,i,r,o;return{c(){e=M("rect"),z(e,"x",n=t[3](t[0].bins[t[13]])+1),z(e,"y",i=t[7](t[9](t[0],t[13]))),z(e,"width",r=t[3](t[0].bins[t[13]+1])-t[3](t[0].bins[t[13]])-2),z(e,"height",o=t[7](0)-t[7](t[9](t[0],t[13]))),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){$(t,e,n)},p(t,l){265&l&&n!==(n=t[3](t[0].bins[t[13]])+1)&&z(e,"x",n),897&l&&i!==(i=t[7](t[9](t[0],t[13])))&&z(e,"y",i),265&l&&r!==(r=t[3](t[0].bins[t[13]+1])-t[3](t[0].bins[t[13]])-2)&&z(e,"width",r),897&l&&o!==(o=t[7](0)-t[7](t[9](t[0],t[13])))&&z(e,"height",o),32&l&&z(e,"fill",t[5]),64&l&&z(e,"stroke",t[6])},d(t){t&&x(e)}}}function dr(t){let e,n;function i(t,e){return"horizontal"===t[2]?cr:sr}let r=i(t),o=r(t);return{c(){e=M("g"),o.c(),z(e,"transform",n="translate("+t[4]+")")},m(t,n){$(t,e,n),o.m(e,null)},p(t,[l]){r===(r=i(t))&&o?o.p(t,l):(o.d(1),o=r(t),o&&(o.c(),o.m(e,null))),16&l&&n!==(n="translate("+t[4]+")")&&z(e,"transform",n)},i:l,o:l,d(t){t&&x(e),o.d()}}}function fr(t,e){return t.counts[e]}function pr(t,e){return t.percents[e]}function gr(t,e,n){let i,r,o,l,{data:a}=e,{height:s}=e,{direction:c}=e,{x:u}=e,{translate:h=[0,0]}=e,{fill:d="var(--gray-3)"}=e,{stroke:f="none"}=e,{unit:p="count"}=e,{maxValue:g=0}=e;return t.$$set=t=>{"data"in t&&n(0,a=t.data),"height"in t&&n(1,s=t.height),"direction"in t&&n(2,c=t.direction),"x"in t&&n(3,u=t.x),"translate"in t&&n(4,h=t.translate),"fill"in t&&n(5,d=t.fill),"stroke"in t&&n(6,f=t.stroke),"unit"in t&&n(10,p=t.unit),"maxValue"in t&&n(11,g=t.maxValue)},t.$$.update=()=>{3073&t.$$.dirty&&n(12,i=g||("count"===p?Math.max(...a.counts):Math.max(...a.percents))),1024&t.$$.dirty&&n(9,r="count"===p?fr:pr),1&t.$$.dirty&&n(8,o=wn(a.counts.length)),4102&t.$$.dirty&&n(7,l=tn().domain([0,i]).range("horizontal"===c?[s,0]:[0,s]))},[a,s,c,u,h,d,f,l,o,r,p,g,i]}const mr=class extends gt{constructor(t){super(),pt(this,t,gr,dr,h,{data:0,height:1,direction:2,x:3,translate:4,fill:5,stroke:6,unit:10,maxValue:11})}};function vr(t,e,n){const i=t.slice();return i[15]=e[n],i}function yr(t,e,n){const i=t.slice();return i[15]=e[n],i}function br(t){let e,n,i,r,o,l=t[10],a=[];for(let e=0;e<l.length;e+=1)a[e]=$r(vr(t,l,e));return{c(){for(let t=0;t<a.length;t+=1)a[t].c();e=M("line"),z(e,"x1",n=0),z(e,"x2",i=0),z(e,"y1",r=t[3].range()[0]),z(e,"y2",o=t[3].range()[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<a.length;e+=1)a[e].m(t,n);$(t,e,n)},p(t,n){if(4073&n){let i;for(l=t[10],i=0;i<l.length;i+=1){const r=vr(t,l,i);a[i]?a[i].p(r,n):(a[i]=$r(r),a[i].c(),a[i].m(e.parentNode,e))}for(;i<a.length;i+=1)a[i].d(1);a.length=l.length}8&n&&r!==(r=t[3].range()[0])&&z(e,"y1",r),8&n&&o!==(o=t[3].range()[1])&&z(e,"y2",o)},d(t){_(a,t),t&&x(e)}}}function wr(t){let e,n,i,r=t[10],o=[];for(let e=0;e<r.length;e+=1)o[e]=xr(yr(t,r,e));return{c(){for(let t=0;t<o.length;t+=1)o[t].c();e=M("line"),z(e,"x1",n=t[3].range()[0]),z(e,"x2",i=t[3].range()[1]),z(e,"y1",t[1]),z(e,"y2",t[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<o.length;e+=1)o[e].m(t,n);$(t,e,n)},p(t,l){if(4073&l){let n;for(r=t[10],n=0;n<r.length;n+=1){const i=yr(t,r,n);o[n]?o[n].p(i,l):(o[n]=xr(i),o[n].c(),o[n].m(e.parentNode,e))}for(;n<o.length;n+=1)o[n].d(1);o.length=r.length}8&l&&n!==(n=t[3].range()[0])&&z(e,"x1",n),8&l&&i!==(i=t[3].range()[1])&&z(e,"x2",i),2&l&&z(e,"y1",t[1]),2&l&&z(e,"y2",t[1])},d(t){_(o,t),t&&x(e)}}}function $r(t){let e,n,i,r;return{c(){e=M("rect"),z(e,"x",n=0),z(e,"y",i=(t[3](t[0].bins[t[15]])??0)-t[8]),z(e,"width",r=t[9](t[11](t[0],t[15]))),z(e,"height",t[7]),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){$(t,e,n)},p(t,n){1289&n&&i!==(i=(t[3](t[0].bins[t[15]])??0)-t[8])&&z(e,"y",i),3585&n&&r!==(r=t[9](t[11](t[0],t[15])))&&z(e,"width",r),128&n&&z(e,"height",t[7]),32&n&&z(e,"fill",t[5]),64&n&&z(e,"stroke",t[6])},d(t){t&&x(e)}}}function xr(t){let e,n,i,r;return{c(){e=M("rect"),z(e,"x",n=(t[3](t[0].bins[t[15]])??0)-t[8]),z(e,"y",i=t[9](t[11](t[0],t[15]))),z(e,"width",t[7]),z(e,"height",r=t[9](0)-t[9](t[11](t[0],t[15]))),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){$(t,e,n)},p(t,o){1289&o&&n!==(n=(t[3](t[0].bins[t[15]])??0)-t[8])&&z(e,"x",n),3585&o&&i!==(i=t[9](t[11](t[0],t[15])))&&z(e,"y",i),128&o&&z(e,"width",t[7]),3585&o&&r!==(r=t[9](0)-t[9](t[11](t[0],t[15])))&&z(e,"height",r),32&o&&z(e,"fill",t[5]),64&o&&z(e,"stroke",t[6])},d(t){t&&x(e)}}}function _r(t){let e,n;function i(t,e){return"horizontal"===t[2]?wr:br}let r=i(t),o=r(t);return{c(){e=M("g"),o.c(),z(e,"transform",n="translate("+t[4]+")")},m(t,n){$(t,e,n),o.m(e,null)},p(t,[l]){r===(r=i(t))&&o?o.p(t,l):(o.d(1),o=r(t),o&&(o.c(),o.m(e,null))),16&l&&n!==(n="translate("+t[4]+")")&&z(e,"transform",n)},i:l,o:l,d(t){t&&x(e),o.d()}}}function kr(t,e){return t.counts[e]}function Mr(t,e){return t.percents[e]}function Lr(t,e,n){let i,r,o,l,a,s,{data:c}=e,{height:u}=e,{direction:h}=e,{x:d}=e,{translate:f=[0,0]}=e,{fill:p="var(--gray-3)"}=e,{stroke:g="none"}=e,{unit:m="count"}=e,{maxValue:v=0}=e;return t.$$set=t=>{"data"in t&&n(0,c=t.data),"height"in t&&n(1,u=t.height),"direction"in t&&n(2,h=t.direction),"x"in t&&n(3,d=t.x),"translate"in t&&n(4,f=t.translate),"fill"in t&&n(5,p=t.fill),"stroke"in t&&n(6,g=t.stroke),"unit"in t&&n(12,m=t.unit),"maxValue"in t&&n(13,v=t.maxValue)},t.$$.update=()=>{12289&t.$$.dirty&&n(14,i=v||("count"===m?Math.max(...c.counts):Math.max(...c.percents))),4096&t.$$.dirty&&n(11,r="count"===m?kr:Mr),1&t.$$.dirty&&n(10,o=wn(c.counts.length)),16390&t.$$.dirty&&n(9,l=tn().domain([0,i]).range("horizontal"===h?[u,0]:[0,u])),8&t.$$.dirty&&n(7,a=(d.bandwidth()||d.step()*d.padding())-2),136&t.$$.dirty&&n(8,s=(0===d.bandwidth()?a/2:0)-1)},[c,u,h,d,f,p,g,a,s,l,o,r,m,v,i]}const Ar=class extends gt{constructor(t){super(),pt(this,t,Lr,_r,h,{data:0,height:1,direction:2,x:3,translate:4,fill:5,stroke:6,unit:12,maxValue:13})}};function Sr(t){w(t,"svelte-1pymoqc","div.svelte-1pymoqc{position:relative;width:100%;height:100%}.svg-for-clusters.svelte-1pymoqc,canvas.svelte-1pymoqc{position:absolute;top:0;left:0}")}function Nr(t,e,n){const i=t.slice();return i[29]=e[n],i}function zr(t){let e,n,i,r;const o=[Cr,Tr],l=[];function a(t,e){return"bandwidth"in t[9]?0:1}return n=a(t),i=l[n]=o[n](t),{c(){e=M("svg"),i.c(),z(e,"width",t[1]),z(e,"height",t[3])},m(t,i){$(t,e,i),l[n].m(e,null),r=!0},p(t,s){let c=n;n=a(t),n===c?l[n].p(t,s):(it(),lt(l[c],1,1,(()=>{l[c]=null})),rt(),i=l[n],i?i.p(t,s):(i=l[n]=o[n](t),i.c()),ot(i,1),i.m(e,null)),(!r||2&s[0])&&z(e,"width",t[1]),(!r||8&s[0])&&z(e,"height",t[3])},i(t){r||(ot(i),r=!0)},o(t){lt(i),r=!1},d(t){t&&x(e),l[n].d()}}}function Tr(t){let e,n;return e=new mr({props:{data:t[14][t[0].x_feature].distribution,x:t[9],height:t[4],direction:"horizontal",translate:[0,t[3]-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};16385&n[0]&&(i.data=t[14][t[0].x_feature].distribution),512&n[0]&&(i.x=t[9]),16&n[0]&&(i.height=t[4]),24&n[0]&&(i.translate=[0,t[3]-t[4]]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Cr(t){let e,n;return e=new Ar({props:{data:t[14][t[0].x_feature].distribution,x:t[9],height:t[4],direction:"horizontal",translate:[0,t[3]-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};16385&n[0]&&(i.data=t[14][t[0].x_feature].distribution),512&n[0]&&(i.x=t[9]),16&n[0]&&(i.height=t[4]),24&n[0]&&(i.translate=[0,t[3]-t[4]]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function qr(t){let e,n,i,r,o;return n=new or({props:{scale:t[8],x:t[11].left,label:"centered prediction"}}),i=new Vi({props:{scale:t[9],y:t[12]-t[11].bottom,showTickLabels:t[29].id===t[10][t[10].length-1],showAxisLabel:t[29].id===t[10][t[10].length-1],label:t[0].x_feature,integerOnly:"discrete"===t[13].subkind,value_map:"value_map"in t[13]?t[13].value_map:{}}}),{c(){e=M("g"),ht(n.$$.fragment),ht(i.$$.fragment),z(e,"transform",r="translate(0,"+(t[7](t[29].id)??0)+")")},m(t,r){$(t,e,r),dt(n,e,null),dt(i,e,null),o=!0},p(t,l){const a={};256&l[0]&&(a.scale=t[8]),2048&l[0]&&(a.x=t[11].left),n.$set(a);const s={};512&l[0]&&(s.scale=t[9]),6144&l[0]&&(s.y=t[12]-t[11].bottom),1025&l[0]&&(s.showTickLabels=t[29].id===t[10][t[10].length-1]),1025&l[0]&&(s.showAxisLabel=t[29].id===t[10][t[10].length-1]),1&l[0]&&(s.label=t[0].x_feature),8192&l[0]&&(s.integerOnly="discrete"===t[13].subkind),8192&l[0]&&(s.value_map="value_map"in t[13]?t[13].value_map:{}),i.$set(s),(!o||129&l[0]&&r!==(r="translate(0,"+(t[7](t[29].id)??0)+")"))&&z(e,"transform",r)},i(t){o||(ot(n.$$.fragment,t),ot(i.$$.fragment,t),o=!0)},o(t){lt(n.$$.fragment,t),lt(i.$$.fragment,t),o=!1},d(t){t&&x(e),ft(n),ft(i)}}}function Er(t){let e,n,i,r,o,l,a=t[2]&&zr(t),s=t[0].ice.clusters,c=[];for(let e=0;e<s.length;e+=1)c[e]=qr(Nr(t,s,e));const u=t=>lt(c[t],1,1,(()=>{c[t]=null}));return{c(){a&&a.c(),e=A(),n=k("div"),i=k("canvas"),r=A(),o=M("svg");for(let t=0;t<c.length;t+=1)c[t].c();z(i,"class","svelte-1pymoqc"),z(o,"class","svg-for-clusters svelte-1pymoqc"),z(o,"height",t[6]),z(o,"width",t[1]),z(n,"class","svelte-1pymoqc")},m(s,u){a&&a.m(s,u),$(s,e,u),$(s,n,u),b(n,i),t[24](i),b(n,r),b(n,o);for(let t=0;t<c.length;t+=1)c[t].m(o,null);l=!0},p(t,n){if(t[2]?a?(a.p(t,n),4&n[0]&&ot(a,1)):(a=zr(t),a.c(),ot(a,1),a.m(e.parentNode,e)):a&&(it(),lt(a,1,1,(()=>{a=null})),rt()),16257&n[0]){let e;for(s=t[0].ice.clusters,e=0;e<s.length;e+=1){const i=Nr(t,s,e);c[e]?(c[e].p(i,n),ot(c[e],1)):(c[e]=qr(i),c[e].c(),ot(c[e],1),c[e].m(o,null))}for(it(),e=s.length;e<c.length;e+=1)u(e);rt()}(!l||64&n[0])&&z(o,"height",t[6]),(!l||2&n[0])&&z(o,"width",t[1])},i(t){if(!l){ot(a);for(let t=0;t<s.length;t+=1)ot(c[t]);l=!0}},o(t){lt(a),c=c.filter(Boolean);for(let t=0;t<c.length;t+=1)lt(c[t]);l=!1},d(i){a&&a.d(i),i&&x(e),i&&x(n),t[24](null),_(c,i)}}}function Or(t,e,n){let i,r,o,l,a,s,c,u,h,d,f,g,m,v,y,b;p(t,Rn,(t=>n(20,g=t))),p(t,Hn,(t=>n(21,m=t))),p(t,Pn,(t=>n(22,v=t))),p(t,jn,(t=>n(23,y=t))),p(t,Tn,(t=>n(14,b=t)));let w,$,{pd:x}=e,{width:_}=e,{height:k}=e,{scaleLocally:M}=e,{showMarginalDistribution:L}=e,{indices:A}=e,{marginTop:S}=e,{distributionHeight:N}=e;function z(t,e,n,i,r,o,l){null!=e&&null!=n&&(e.save(),e.clearRect(0,0,o,l),t.ice.clusters.forEach((o=>{var l,a;e.translate(0,null!==(l=r(o.id))&&void 0!==l?l:0),e.lineWidth=1,e.strokeStyle=d(o.id),e.globalAlpha=.25,o.indices.forEach((r=>{(null===i||i.includes(r))&&(e.beginPath(),n(t.ice.centered_ice_lines[r]),e.stroke())})),e.lineWidth=1,e.strokeStyle="black",e.globalAlpha=1,e.beginPath(),n(t.ice.centered_pdp),e.stroke(),e.lineWidth=2,e.strokeStyle=h(o.id),e.globalAlpha=1,e.beginPath(),n(o.centered_mean),e.stroke(),e.translate(0,-(null!==(a=r(o.id))&&void 0!==a?a:0))})),e.restore())}return H((()=>{n(18,$=w.getContext("2d"))})),t.$$set=t=>{"pd"in t&&n(0,x=t.pd),"width"in t&&n(1,_=t.width),"height"in t&&n(15,k=t.height),"scaleLocally"in t&&n(16,M=t.scaleLocally),"showMarginalDistribution"in t&&n(2,L=t.showMarginalDistribution),"indices"in t&&n(17,A=t.indices),"marginTop"in t&&n(3,S=t.marginTop),"distributionHeight"in t&&n(4,N=t.distributionHeight)},t.$$.update=()=>{16385&t.$$.dirty[0]&&n(13,i=b[x.x_feature]),32776&t.$$.dirty[0]&&n(6,o=k-S),1&t.$$.dirty[0]&&n(10,l=x.ice.clusters.map((t=>t.id))),1088&t.$$.dirty[0]&&n(7,a=si().domain(l).range([0,o])),128&t.$$.dirty[0]&&n(12,s=a.bandwidth()),10243&t.$$.dirty[0]&&n(9,c="quantitative"===i.kind?tn().domain([x.x_values[0],x.x_values[x.x_values.length-1]]).range([r.left,_-r.right]):ui().domain(x.x_values).range([r.left,_-r.right]).padding(.5)),15800385&t.$$.dirty[0]&&n(8,u=kn(x,o,s,"cluster-lines",M,y,v,0,g,r)),1024&t.$$.dirty[0]&&(h=ai().domain(l).range(Sn)),1024&t.$$.dirty[0]&&(d=ai().domain(l).range(Ln)),262913&t.$$.dirty[0]&&n(19,f=ki().x(((t,e)=>{var n;return null!==(n=c(x.x_values[e]))&&void 0!==n?n:0})).y((t=>u(t))).context($)),262242&t.$$.dirty[0]&&$&&(xn(w,$,_,o),z(x,$,f,A,a,_,o)),917699&t.$$.dirty[0]&&z(x,$,f,A,a,_,o)},n(11,r={top:5,right:10,bottom:35,left:50}),[x,_,L,S,N,w,o,a,u,c,l,r,s,i,b,k,M,A,$,f,g,m,v,y,function(t){V[t?"unshift":"push"]((()=>{w=t,n(5,w)}))}]}const Dr=class extends gt{constructor(t){super(),pt(this,t,Or,Er,h,{pd:0,width:1,height:15,scaleLocally:16,showMarginalDistribution:2,indices:17,marginTop:3,distributionHeight:4},Sr,[-1,-1])}};function Br(t,e,n){const i=t.slice();return i[21]=e[n],i}function jr(t,e,n){const i=t.slice();return i[24]=e[n],i}function Pr(t,e,n){const i=t.slice();return i[21]=e[n],i}function Hr(t){let e,n=t[12],i=[];for(let e=0;e<n.length;e+=1)i[e]=Rr(Pr(t,n,e));return{c(){e=M("g");for(let t=0;t<i.length;t+=1)i[t].c()},m(t,n){$(t,e,n);for(let t=0;t<i.length;t+=1)i[t].m(e,null)},p(t,r){if(12385&r){let o;for(n=t[12],o=0;o<n.length;o+=1){const l=Pr(t,n,o);i[o]?i[o].p(l,r):(i[o]=Rr(l),i[o].c(),i[o].m(e,null))}for(;o<i.length;o+=1)i[o].d(1);i.length=n.length}},d(t){t&&x(e),_(i,t)}}}function Rr(t){let e,n,i,r;return{c(){e=M("circle"),z(e,"cx",n=t[6](t[0].x_values[t[21]])),z(e,"cy",i=t[5](t[24].centered_mean[t[21]])),z(e,"r",t[13]),z(e,"fill",r="var(--gray-2)")},m(t,n){$(t,e,n)},p(t,r){4161&r&&n!==(n=t[6](t[0].x_values[t[21]]))&&z(e,"cx",n),4129&r&&i!==(i=t[5](t[24].centered_mean[t[21]]))&&z(e,"cy",i),8192&r&&z(e,"r",t[13])},d(t){t&&x(e)}}}function Ir(t){let e,n,i,r,o="categorical"===t[9].kind&&Hr(t);return{c(){e=M("path"),o&&o.c(),r=S(),z(e,"d",n=t[11](t[24].centered_mean)),z(e,"stroke",i="var(--gray-2)"),z(e,"stroke-width","2"),z(e,"fill","none")},m(t,n){$(t,e,n),o&&o.m(t,n),$(t,r,n)},p(t,i){2049&i&&n!==(n=t[11](t[24].centered_mean))&&z(e,"d",n),"categorical"===t[9].kind?o?o.p(t,i):(o=Hr(t),o.c(),o.m(r.parentNode,r)):o&&(o.d(1),o=null)},d(t){t&&x(e),o&&o.d(t),t&&x(r)}}}function Vr(t){let e,n=t[12],i=[];for(let e=0;e<n.length;e+=1)i[e]=Wr(Br(t,n,e));return{c(){for(let t=0;t<i.length;t+=1)i[t].c();e=S()},m(t,n){for(let e=0;e<i.length;e+=1)i[e].m(t,n);$(t,e,n)},p(t,r){if(12385&r){let o;for(n=t[12],o=0;o<n.length;o+=1){const l=Br(t,n,o);i[o]?i[o].p(l,r):(i[o]=Wr(l),i[o].c(),i[o].m(e.parentNode,e))}for(;o<i.length;o+=1)i[o].d(1);i.length=n.length}},d(t){_(i,t),t&&x(e)}}}function Wr(t){let e,n,i;return{c(){e=M("circle"),z(e,"cx",n=t[6](t[0].x_values[t[21]])),z(e,"cy",i=t[5](t[0].ice.centered_pdp[t[21]])),z(e,"r",t[13]),z(e,"fill","var(--black)")},m(t,n){$(t,e,n)},p(t,r){4161&r&&n!==(n=t[6](t[0].x_values[t[21]]))&&z(e,"cx",n),4129&r&&i!==(i=t[5](t[0].ice.centered_pdp[t[21]]))&&z(e,"cy",i),8192&r&&z(e,"r",t[13])},d(t){t&&x(e)}}}function Fr(t){let e,n,i,r;const o=[Yr,Xr],l=[];function a(t,e){return"bandwidth"in t[6]?0:1}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),i=S()},m(t,n){l[e].m(t,n),$(t,i,n),r=!0},p(t,r){let s=e;e=a(t),e===s?l[e].p(t,r):(it(),lt(l[s],1,1,(()=>{l[s]=null})),rt(),n=l[e],n?n.p(t,r):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(i.parentNode,i))},i(t){r||(ot(n),r=!0)},o(t){lt(n),r=!1},d(t){l[e].d(t),t&&x(i)}}}function Xr(t){let e,n;return e=new mr({props:{data:t[10][t[0].x_feature].distribution,x:t[6],height:t[4],direction:"horizontal",translate:[0,t[7].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1025&n&&(i.data=t[10][t[0].x_feature].distribution),64&n&&(i.x=t[6]),16&n&&(i.height=t[4]),144&n&&(i.translate=[0,t[7].top-t[4]]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Yr(t){let e,n;return e=new Ar({props:{data:t[10][t[0].x_feature].distribution,x:t[6],height:t[4],direction:"horizontal",translate:[0,t[7].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1025&n&&(i.data=t[10][t[0].x_feature].distribution),64&n&&(i.x=t[6]),16&n&&(i.height=t[4]),144&n&&(i.translate=[0,t[7].top-t[4]]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Kr(t){let e,n,i,r,o,l,a,s,c=t[0].ice.clusters,u=[];for(let e=0;e<c.length;e+=1)u[e]=Ir(jr(t,c,e));let h="categorical"===t[9].kind&&Vr(t);l=new Vi({props:{scale:t[6],y:t[8]-t[7].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[9].subkind,value_map:"value_map"in t[9]?t[9].value_map:{}}}),a=new or({props:{scale:t[5],x:t[7].left,label:"centered prediction"}});let d=t[3]&&Fr(t);return{c(){e=M("svg"),n=M("g");for(let t=0;t<u.length;t+=1)u[t].c();i=M("path"),h&&h.c(),o=S(),ht(l.$$.fragment),ht(a.$$.fragment),d&&d.c(),z(i,"d",r=t[11](t[0].ice.centered_pdp)),z(i,"stroke","var(--black)"),z(i,"stroke-width","2"),z(i,"fill","none"),z(e,"width",t[1]),z(e,"height",t[2])},m(t,r){$(t,e,r),b(e,n);for(let t=0;t<u.length;t+=1)u[t].m(n,null);b(e,i),h&&h.m(e,null),b(e,o),dt(l,e,null),dt(a,e,null),d&&d.m(e,null),s=!0},p(t,[f]){if(14945&f){let e;for(c=t[0].ice.clusters,e=0;e<c.length;e+=1){const i=jr(t,c,e);u[e]?u[e].p(i,f):(u[e]=Ir(i),u[e].c(),u[e].m(n,null))}for(;e<u.length;e+=1)u[e].d(1);u.length=c.length}(!s||2049&f&&r!==(r=t[11](t[0].ice.centered_pdp)))&&z(i,"d",r),"categorical"===t[9].kind?h?h.p(t,f):(h=Vr(t),h.c(),h.m(e,o)):h&&(h.d(1),h=null);const p={};64&f&&(p.scale=t[6]),384&f&&(p.y=t[8]-t[7].bottom),1&f&&(p.label=t[0].x_feature),512&f&&(p.integerOnly="discrete"===t[9].subkind),512&f&&(p.value_map="value_map"in t[9]?t[9].value_map:{}),l.$set(p);const g={};32&f&&(g.scale=t[5]),128&f&&(g.x=t[7].left),a.$set(g),t[3]?d?(d.p(t,f),8&f&&ot(d,1)):(d=Fr(t),d.c(),ot(d,1),d.m(e,null)):d&&(it(),lt(d,1,1,(()=>{d=null})),rt()),(!s||2&f)&&z(e,"width",t[1]),(!s||4&f)&&z(e,"height",t[2])},i(t){s||(ot(l.$$.fragment,t),ot(a.$$.fragment,t),ot(d),s=!0)},o(t){lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(d),s=!1},d(t){t&&x(e),_(u,t),h&&h.d(),ft(l),ft(a),d&&d.d()}}}function Ur(t,e,n){let i,r,o,l,a,s,c,u,h,d,f,g,m,v;p(t,Rn,(t=>n(17,d=t))),p(t,Hn,(t=>n(18,f=t))),p(t,Pn,(t=>n(19,g=t))),p(t,jn,(t=>n(20,m=t))),p(t,Tn,(t=>n(10,v=t)));let{pd:y}=e,{width:b}=e,{height:w}=e,{scaleLocally:$}=e,{showMarginalDistribution:x}=e,{marginTop:_}=e,{distributionHeight:k}=e;return t.$$set=t=>{"pd"in t&&n(0,y=t.pd),"width"in t&&n(1,b=t.width),"height"in t&&n(2,w=t.height),"scaleLocally"in t&&n(14,$=t.scaleLocally),"showMarginalDistribution"in t&&n(3,x=t.showMarginalDistribution),"marginTop"in t&&n(15,_=t.marginTop),"distributionHeight"in t&&n(4,k=t.distributionHeight)},t.$$.update=()=>{1025&t.$$.dirty&&n(9,i=v[y.x_feature]),32768&t.$$.dirty&&n(7,r={top:_,right:10,bottom:35,left:50}),4&t.$$.dirty&&n(8,o=w),257&t.$$.dirty&&n(16,l=o/y.ice.clusters.length),643&t.$$.dirty&&n(6,a="quantitative"===i.kind?tn().domain([y.x_values[0],y.x_values[y.x_values.length-1]]).range([r.left,b-r.right]):ui().domain(y.x_values).range([r.left,b-r.right]).padding(.5)),64&t.$$.dirty&&n(13,s="step"in a?Math.min(3,a.step()/2-1):0),2048385&t.$$.dirty&&n(5,c=kn(y,o,l,"cluster-centers",$,m,g,0,d,r)),1&t.$$.dirty&&n(12,u=wn(y.x_values.length)),97&t.$$.dirty&&n(11,h=ki().x(((t,e)=>{var n;return null!==(n=a(y.x_values[e]))&&void 0!==n?n:0})).y((t=>c(t))))},[y,b,w,x,k,c,a,r,o,i,v,h,u,s,$,_,l,d,f,g,m]}const Gr=class extends gt{constructor(t){super(),pt(this,t,Ur,Kr,h,{pd:0,width:1,height:2,scaleLocally:14,showMarginalDistribution:3,marginTop:15,distributionHeight:4})}};function Zr(){}function Jr(t){return null==t?Zr:function(){return this.querySelector(t)}}function Qr(t){return null==t?[]:Array.isArray(t)?t:Array.from(t)}function to(){return[]}function eo(t){return null==t?to:function(){return this.querySelectorAll(t)}}function no(t){return function(){return this.matches(t)}}function io(t){return function(e){return e.matches(t)}}var ro=Array.prototype.find;function oo(){return this.firstElementChild}var lo=Array.prototype.filter;function ao(){return Array.from(this.children)}function so(t){return new Array(t.length)}function co(t,e){this.ownerDocument=t.ownerDocument,this.namespaceURI=t.namespaceURI,this._next=null,this._parent=t,this.__data__=e}function uo(t){return function(){return t}}function ho(t,e,n,i,r,o){for(var l,a=0,s=e.length,c=o.length;a<c;++a)(l=e[a])?(l.__data__=o[a],i[a]=l):n[a]=new co(t,o[a]);for(;a<s;++a)(l=e[a])&&(r[a]=l)}function fo(t,e,n,i,r,o,l){var a,s,c,u=new Map,h=e.length,d=o.length,f=new Array(h);for(a=0;a<h;++a)(s=e[a])&&(f[a]=c=l.call(s,s.__data__,a,e)+"",u.has(c)?r[a]=s:u.set(c,s));for(a=0;a<d;++a)c=l.call(t,o[a],a,o)+"",(s=u.get(c))?(i[a]=s,s.__data__=o[a],u.delete(c)):n[a]=new co(t,o[a]);for(a=0;a<h;++a)(s=e[a])&&u.get(f[a])===s&&(r[a]=s)}function po(t){return t.__data__}function go(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function mo(t,e){return t<e?-1:t>e?1:t>=e?0:NaN}co.prototype={constructor:co,appendChild:function(t){return this._parent.insertBefore(t,this._next)},insertBefore:function(t,e){return this._parent.insertBefore(t,e)},querySelector:function(t){return this._parent.querySelector(t)},querySelectorAll:function(t){return this._parent.querySelectorAll(t)}};var vo="http://www.w3.org/1999/xhtml";const yo={svg:"http://www.w3.org/2000/svg",xhtml:vo,xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace",xmlns:"http://www.w3.org/2000/xmlns/"};function bo(t){var e=t+="",n=e.indexOf(":");return n>=0&&"xmlns"!==(e=t.slice(0,n))&&(t=t.slice(n+1)),yo.hasOwnProperty(e)?{space:yo[e],local:t}:t}function wo(t){return function(){this.removeAttribute(t)}}function $o(t){return function(){this.removeAttributeNS(t.space,t.local)}}function xo(t,e){return function(){this.setAttribute(t,e)}}function _o(t,e){return function(){this.setAttributeNS(t.space,t.local,e)}}function ko(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttribute(t):this.setAttribute(t,n)}}function Mo(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttributeNS(t.space,t.local):this.setAttributeNS(t.space,t.local,n)}}function Lo(t){return t.ownerDocument&&t.ownerDocument.defaultView||t.document&&t||t.defaultView}function Ao(t){return function(){this.style.removeProperty(t)}}function So(t,e,n){return function(){this.style.setProperty(t,e,n)}}function No(t,e,n){return function(){var i=e.apply(this,arguments);null==i?this.style.removeProperty(t):this.style.setProperty(t,i,n)}}function zo(t,e){return t.style.getPropertyValue(e)||Lo(t).getComputedStyle(t,null).getPropertyValue(e)}function To(t){return function(){delete this[t]}}function Co(t,e){return function(){this[t]=e}}function qo(t,e){return function(){var n=e.apply(this,arguments);null==n?delete this[t]:this[t]=n}}function Eo(t){return t.trim().split(/^|\s+/)}function Oo(t){return t.classList||new Do(t)}function Do(t){this._node=t,this._names=Eo(t.getAttribute("class")||"")}function Bo(t,e){for(var n=Oo(t),i=-1,r=e.length;++i<r;)n.add(e[i])}function jo(t,e){for(var n=Oo(t),i=-1,r=e.length;++i<r;)n.remove(e[i])}function Po(t){return function(){Bo(this,t)}}function Ho(t){return function(){jo(this,t)}}function Ro(t,e){return function(){(e.apply(this,arguments)?Bo:jo)(this,t)}}function Io(){this.textContent=""}function Vo(t){return function(){this.textContent=t}}function Wo(t){return function(){var e=t.apply(this,arguments);this.textContent=null==e?"":e}}function Fo(){this.innerHTML=""}function Xo(t){return function(){this.innerHTML=t}}function Yo(t){return function(){var e=t.apply(this,arguments);this.innerHTML=null==e?"":e}}function Ko(){this.nextSibling&&this.parentNode.appendChild(this)}function Uo(){this.previousSibling&&this.parentNode.insertBefore(this,this.parentNode.firstChild)}function Go(t){return function(){var e=this.ownerDocument,n=this.namespaceURI;return n===vo&&e.documentElement.namespaceURI===vo?e.createElement(t):e.createElementNS(n,t)}}function Zo(t){return function(){return this.ownerDocument.createElementNS(t.space,t.local)}}function Jo(t){var e=bo(t);return(e.local?Zo:Go)(e)}function Qo(){return null}function tl(){var t=this.parentNode;t&&t.removeChild(this)}function el(){var t=this.cloneNode(!1),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function nl(){var t=this.cloneNode(!0),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function il(t){return t.trim().split(/^|\s+/).map((function(t){var e="",n=t.indexOf(".");return n>=0&&(e=t.slice(n+1),t=t.slice(0,n)),{type:t,name:e}}))}function rl(t){return function(){var e=this.__on;if(e){for(var n,i=0,r=-1,o=e.length;i<o;++i)n=e[i],t.type&&n.type!==t.type||n.name!==t.name?e[++r]=n:this.removeEventListener(n.type,n.listener,n.options);++r?e.length=r:delete this.__on}}}function ol(t,e,n){return function(){var i,r=this.__on,o=function(t){return function(e){t.call(this,e,this.__data__)}}(e);if(r)for(var l=0,a=r.length;l<a;++l)if((i=r[l]).type===t.type&&i.name===t.name)return this.removeEventListener(i.type,i.listener,i.options),this.addEventListener(i.type,i.listener=o,i.options=n),void(i.value=e);this.addEventListener(t.type,o,n),i={type:t.type,name:t.name,value:e,listener:o,options:n},r?r.push(i):this.__on=[i]}}function ll(t,e,n){var i=Lo(t),r=i.CustomEvent;"function"==typeof r?r=new r(e,n):(r=i.document.createEvent("Event"),n?(r.initEvent(e,n.bubbles,n.cancelable),r.detail=n.detail):r.initEvent(e,!1,!1)),t.dispatchEvent(r)}function al(t,e){return function(){return ll(this,t,e)}}function sl(t,e){return function(){return ll(this,t,e.apply(this,arguments))}}Do.prototype={add:function(t){this._names.indexOf(t)<0&&(this._names.push(t),this._node.setAttribute("class",this._names.join(" ")))},remove:function(t){var e=this._names.indexOf(t);e>=0&&(this._names.splice(e,1),this._node.setAttribute("class",this._names.join(" ")))},contains:function(t){return this._names.indexOf(t)>=0}};var cl=[null];function ul(t,e){this._groups=t,this._parents=e}function hl(){return new ul([[document.documentElement]],cl)}ul.prototype=hl.prototype={constructor:ul,select:function(t){"function"!=typeof t&&(t=Jr(t));for(var e=this._groups,n=e.length,i=new Array(n),r=0;r<n;++r)for(var o,l,a=e[r],s=a.length,c=i[r]=new Array(s),u=0;u<s;++u)(o=a[u])&&(l=t.call(o,o.__data__,u,a))&&("__data__"in o&&(l.__data__=o.__data__),c[u]=l);return new ul(i,this._parents)},selectAll:function(t){t="function"==typeof t?function(t){return function(){return Qr(t.apply(this,arguments))}}(t):eo(t);for(var e=this._groups,n=e.length,i=[],r=[],o=0;o<n;++o)for(var l,a=e[o],s=a.length,c=0;c<s;++c)(l=a[c])&&(i.push(t.call(l,l.__data__,c,a)),r.push(l));return new ul(i,r)},selectChild:function(t){return this.select(null==t?oo:function(t){return function(){return ro.call(this.children,t)}}("function"==typeof t?t:io(t)))},selectChildren:function(t){return this.selectAll(null==t?ao:function(t){return function(){return lo.call(this.children,t)}}("function"==typeof t?t:io(t)))},filter:function(t){"function"!=typeof t&&(t=no(t));for(var e=this._groups,n=e.length,i=new Array(n),r=0;r<n;++r)for(var o,l=e[r],a=l.length,s=i[r]=[],c=0;c<a;++c)(o=l[c])&&t.call(o,o.__data__,c,l)&&s.push(o);return new ul(i,this._parents)},data:function(t,e){if(!arguments.length)return Array.from(this,po);var n=e?fo:ho,i=this._parents,r=this._groups;"function"!=typeof t&&(t=uo(t));for(var o=r.length,l=new Array(o),a=new Array(o),s=new Array(o),c=0;c<o;++c){var u=i[c],h=r[c],d=h.length,f=go(t.call(u,u&&u.__data__,c,i)),p=f.length,g=a[c]=new Array(p),m=l[c]=new Array(p),v=s[c]=new Array(d);n(u,h,g,m,v,f,e);for(var y,b,w=0,$=0;w<p;++w)if(y=g[w]){for(w>=$&&($=w+1);!(b=m[$])&&++$<p;);y._next=b||null}}return(l=new ul(l,i))._enter=a,l._exit=s,l},enter:function(){return new ul(this._enter||this._groups.map(so),this._parents)},exit:function(){return new ul(this._exit||this._groups.map(so),this._parents)},join:function(t,e,n){var i=this.enter(),r=this,o=this.exit();return"function"==typeof t?(i=t(i))&&(i=i.selection()):i=i.append(t+""),null!=e&&(r=e(r))&&(r=r.selection()),null==n?o.remove():n(o),i&&r?i.merge(r).order():r},merge:function(t){for(var e=t.selection?t.selection():t,n=this._groups,i=e._groups,r=n.length,o=i.length,l=Math.min(r,o),a=new Array(r),s=0;s<l;++s)for(var c,u=n[s],h=i[s],d=u.length,f=a[s]=new Array(d),p=0;p<d;++p)(c=u[p]||h[p])&&(f[p]=c);for(;s<r;++s)a[s]=n[s];return new ul(a,this._parents)},selection:function(){return this},order:function(){for(var t=this._groups,e=-1,n=t.length;++e<n;)for(var i,r=t[e],o=r.length-1,l=r[o];--o>=0;)(i=r[o])&&(l&&4^i.compareDocumentPosition(l)&&l.parentNode.insertBefore(i,l),l=i);return this},sort:function(t){function e(e,n){return e&&n?t(e.__data__,n.__data__):!e-!n}t||(t=mo);for(var n=this._groups,i=n.length,r=new Array(i),o=0;o<i;++o){for(var l,a=n[o],s=a.length,c=r[o]=new Array(s),u=0;u<s;++u)(l=a[u])&&(c[u]=l);c.sort(e)}return new ul(r,this._parents).order()},call:function(){var t=arguments[0];return arguments[0]=this,t.apply(null,arguments),this},nodes:function(){return Array.from(this)},node:function(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var i=t[e],r=0,o=i.length;r<o;++r){var l=i[r];if(l)return l}return null},size:function(){let t=0;for(const e of this)++t;return t},empty:function(){return!this.node()},each:function(t){for(var e=this._groups,n=0,i=e.length;n<i;++n)for(var r,o=e[n],l=0,a=o.length;l<a;++l)(r=o[l])&&t.call(r,r.__data__,l,o);return this},attr:function(t,e){var n=bo(t);if(arguments.length<2){var i=this.node();return n.local?i.getAttributeNS(n.space,n.local):i.getAttribute(n)}return this.each((null==e?n.local?$o:wo:"function"==typeof e?n.local?Mo:ko:n.local?_o:xo)(n,e))},style:function(t,e,n){return arguments.length>1?this.each((null==e?Ao:"function"==typeof e?No:So)(t,e,null==n?"":n)):zo(this.node(),t)},property:function(t,e){return arguments.length>1?this.each((null==e?To:"function"==typeof e?qo:Co)(t,e)):this.node()[t]},classed:function(t,e){var n=Eo(t+"");if(arguments.length<2){for(var i=Oo(this.node()),r=-1,o=n.length;++r<o;)if(!i.contains(n[r]))return!1;return!0}return this.each(("function"==typeof e?Ro:e?Po:Ho)(n,e))},text:function(t){return arguments.length?this.each(null==t?Io:("function"==typeof t?Wo:Vo)(t)):this.node().textContent},html:function(t){return arguments.length?this.each(null==t?Fo:("function"==typeof t?Yo:Xo)(t)):this.node().innerHTML},raise:function(){return this.each(Ko)},lower:function(){return this.each(Uo)},append:function(t){var e="function"==typeof t?t:Jo(t);return this.select((function(){return this.appendChild(e.apply(this,arguments))}))},insert:function(t,e){var n="function"==typeof t?t:Jo(t),i=null==e?Qo:"function"==typeof e?e:Jr(e);return this.select((function(){return this.insertBefore(n.apply(this,arguments),i.apply(this,arguments)||null)}))},remove:function(){return this.each(tl)},clone:function(t){return this.select(t?nl:el)},datum:function(t){return arguments.length?this.property("__data__",t):this.node().__data__},on:function(t,e,n){var i,r,o=il(t+""),l=o.length;if(!(arguments.length<2)){for(a=e?ol:rl,i=0;i<l;++i)this.each(a(o[i],e,n));return this}var a=this.node().__on;if(a)for(var s,c=0,u=a.length;c<u;++c)for(i=0,s=a[c];i<l;++i)if((r=o[i]).type===s.type&&r.name===s.name)return s.value},dispatch:function(t,e){return this.each(("function"==typeof e?sl:al)(t,e))},[Symbol.iterator]:function*(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var i,r=t[e],o=0,l=r.length;o<l;++o)(i=r[o])&&(yield i)}};const dl=hl;function fl(t){return"string"==typeof t?new ul([[document.querySelector(t)]],[document.documentElement]):new ul([[t]],cl)}var pl={value:()=>{}};function gl(){for(var t,e=0,n=arguments.length,i={};e<n;++e){if(!(t=arguments[e]+"")||t in i||/[\s.]/.test(t))throw new Error("illegal type: "+t);i[t]=[]}return new ml(i)}function ml(t){this._=t}function vl(t,e){return t.trim().split(/^|\s+/).map((function(t){var n="",i=t.indexOf(".");if(i>=0&&(n=t.slice(i+1),t=t.slice(0,i)),t&&!e.hasOwnProperty(t))throw new Error("unknown type: "+t);return{type:t,name:n}}))}function yl(t,e){for(var n,i=0,r=t.length;i<r;++i)if((n=t[i]).name===e)return n.value}function bl(t,e,n){for(var i=0,r=t.length;i<r;++i)if(t[i].name===e){t[i]=pl,t=t.slice(0,i).concat(t.slice(i+1));break}return null!=n&&t.push({name:e,value:n}),t}ml.prototype=gl.prototype={constructor:ml,on:function(t,e){var n,i=this._,r=vl(t+"",i),o=-1,l=r.length;if(!(arguments.length<2)){if(null!=e&&"function"!=typeof e)throw new Error("invalid callback: "+e);for(;++o<l;)if(n=(t=r[o]).type)i[n]=bl(i[n],t.name,e);else if(null==e)for(n in i)i[n]=bl(i[n],t.name,null);return this}for(;++o<l;)if((n=(t=r[o]).type)&&(n=yl(i[n],t.name)))return n},copy:function(){var t={},e=this._;for(var n in e)t[n]=e[n].slice();return new ml(t)},call:function(t,e){if((n=arguments.length-2)>0)for(var n,i,r=new Array(n),o=0;o<n;++o)r[o]=arguments[o+2];if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(o=0,n=(i=this._[t]).length;o<n;++o)i[o].value.apply(e,r)},apply:function(t,e,n){if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(var i=this._[t],r=0,o=i.length;r<o;++r)i[r].value.apply(e,n)}};const wl=gl,$l={capture:!0,passive:!1};function xl(t){t.preventDefault(),t.stopImmediatePropagation()}function _l(t){var e=t.document.documentElement,n=fl(t).on("dragstart.drag",xl,$l);"onselectstart"in e?n.on("selectstart.drag",xl,$l):(e.__noselect=e.style.MozUserSelect,e.style.MozUserSelect="none")}function kl(t,e){var n=t.document.documentElement,i=fl(t).on("dragstart.drag",null);e&&(i.on("click.drag",xl,$l),setTimeout((function(){i.on("click.drag",null)}),0)),"onselectstart"in n?i.on("selectstart.drag",null):(n.style.MozUserSelect=n.__noselect,delete n.__noselect)}function Ml(t,e){if(t=function(t){let e;for(;e=t.sourceEvent;)t=e;return t}(t),void 0===e&&(e=t.currentTarget),e){var n=e.ownerSVGElement||e;if(n.createSVGPoint){var i=n.createSVGPoint();return i.x=t.clientX,i.y=t.clientY,[(i=i.matrixTransform(e.getScreenCTM().inverse())).x,i.y]}if(e.getBoundingClientRect){var r=e.getBoundingClientRect();return[t.clientX-r.left-e.clientLeft,t.clientY-r.top-e.clientTop]}}return[t.pageX,t.pageY]}var Ll,Al,Sl=0,Nl=0,zl=0,Tl=0,Cl=0,ql=0,El="object"==typeof performance&&performance.now?performance:Date,Ol="object"==typeof window&&window.requestAnimationFrame?window.requestAnimationFrame.bind(window):function(t){setTimeout(t,17)};function Dl(){return Cl||(Ol(Bl),Cl=El.now()+ql)}function Bl(){Cl=0}function jl(){this._call=this._time=this._next=null}function Pl(t,e,n){var i=new jl;return i.restart(t,e,n),i}function Hl(){Cl=(Tl=El.now())+ql,Sl=Nl=0;try{!function(){Dl(),++Sl;for(var t,e=Ll;e;)(t=Cl-e._time)>=0&&e._call.call(void 0,t),e=e._next;--Sl}()}finally{Sl=0,function(){for(var t,e,n=Ll,i=1/0;n;)n._call?(i>n._time&&(i=n._time),t=n,n=n._next):(e=n._next,n._next=null,n=t?t._next=e:Ll=e);Al=t,Il(i)}(),Cl=0}}function Rl(){var t=El.now(),e=t-Tl;e>1e3&&(ql-=e,Tl=t)}function Il(t){Sl||(Nl&&(Nl=clearTimeout(Nl)),t-Cl>24?(t<1/0&&(Nl=setTimeout(Hl,t-El.now()-ql)),zl&&(zl=clearInterval(zl))):(zl||(Tl=El.now(),zl=setInterval(Rl,1e3)),Sl=1,Ol(Hl)))}function Vl(t,e,n){var i=new jl;return e=null==e?0:+e,i.restart((n=>{i.stop(),t(n+e)}),e,n),i}jl.prototype=Pl.prototype={constructor:jl,restart:function(t,e,n){if("function"!=typeof t)throw new TypeError("callback is not a function");n=(null==n?Dl():+n)+(null==e?0:+e),this._next||Al===this||(Al?Al._next=this:Ll=this,Al=this),this._call=t,this._time=n,Il()},stop:function(){this._call&&(this._call=null,this._time=1/0,Il())}};var Wl=wl("start","end","cancel","interrupt"),Fl=[];function Xl(t,e,n,i,r,o){var l=t.__transition;if(l){if(n in l)return}else t.__transition={};!function(t,e,n){var i,r=t.__transition;function o(s){var c,u,h,d;if(1!==n.state)return a();for(c in r)if((d=r[c]).name===n.name){if(3===d.state)return Vl(o);4===d.state?(d.state=6,d.timer.stop(),d.on.call("interrupt",t,t.__data__,d.index,d.group),delete r[c]):+c<e&&(d.state=6,d.timer.stop(),d.on.call("cancel",t,t.__data__,d.index,d.group),delete r[c])}if(Vl((function(){3===n.state&&(n.state=4,n.timer.restart(l,n.delay,n.time),l(s))})),n.state=2,n.on.call("start",t,t.__data__,n.index,n.group),2===n.state){for(n.state=3,i=new Array(h=n.tween.length),c=0,u=-1;c<h;++c)(d=n.tween[c].value.call(t,t.__data__,n.index,n.group))&&(i[++u]=d);i.length=u+1}}function l(e){for(var r=e<n.duration?n.ease.call(null,e/n.duration):(n.timer.restart(a),n.state=5,1),o=-1,l=i.length;++o<l;)i[o].call(t,r);5===n.state&&(n.on.call("end",t,t.__data__,n.index,n.group),a())}function a(){for(var i in n.state=6,n.timer.stop(),delete r[e],r)return;delete t.__transition}r[e]=n,n.timer=Pl((function(t){n.state=1,n.timer.restart(o,n.delay,n.time),n.delay<=t&&o(t-n.delay)}),0,n.time)}(t,n,{name:e,index:i,group:r,on:Wl,tween:Fl,time:o.time,delay:o.delay,duration:o.duration,ease:o.ease,timer:null,state:0})}function Yl(t,e){var n=Ul(t,e);if(n.state>0)throw new Error("too late; already scheduled");return n}function Kl(t,e){var n=Ul(t,e);if(n.state>3)throw new Error("too late; already running");return n}function Ul(t,e){var n=t.__transition;if(!n||!(n=n[e]))throw new Error("transition not found");return n}function Gl(t,e){var n,i,r,o=t.__transition,l=!0;if(o){for(r in e=null==e?null:e+"",o)(n=o[r]).name===e?(i=n.state>2&&n.state<5,n.state=6,n.timer.stop(),n.on.call(i?"interrupt":"cancel",t,t.__data__,n.index,n.group),delete o[r]):l=!1;l&&delete t.__transition}}var Zl,Jl=180/Math.PI,Ql={translateX:0,translateY:0,rotate:0,skewX:0,scaleX:1,scaleY:1};function ta(t,e,n,i,r,o){var l,a,s;return(l=Math.sqrt(t*t+e*e))&&(t/=l,e/=l),(s=t*n+e*i)&&(n-=t*s,i-=e*s),(a=Math.sqrt(n*n+i*i))&&(n/=a,i/=a,s/=a),t*i<e*n&&(t=-t,e=-e,s=-s,l=-l),{translateX:r,translateY:o,rotate:Math.atan2(e,t)*Jl,skewX:Math.atan(s)*Jl,scaleX:l,scaleY:a}}function ea(t,e,n,i){function r(t){return t.length?t.pop()+" ":""}return function(o,l){var a=[],s=[];return o=t(o),l=t(l),function(t,i,r,o,l,a){if(t!==r||i!==o){var s=l.push("translate(",null,e,null,n);a.push({i:s-4,x:se(t,r)},{i:s-2,x:se(i,o)})}else(r||o)&&l.push("translate("+r+e+o+n)}(o.translateX,o.translateY,l.translateX,l.translateY,a,s),function(t,e,n,o){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),o.push({i:n.push(r(n)+"rotate(",null,i)-2,x:se(t,e)})):e&&n.push(r(n)+"rotate("+e+i)}(o.rotate,l.rotate,a,s),function(t,e,n,o){t!==e?o.push({i:n.push(r(n)+"skewX(",null,i)-2,x:se(t,e)}):e&&n.push(r(n)+"skewX("+e+i)}(o.skewX,l.skewX,a,s),function(t,e,n,i,o,l){if(t!==n||e!==i){var a=o.push(r(o)+"scale(",null,",",null,")");l.push({i:a-4,x:se(t,n)},{i:a-2,x:se(e,i)})}else 1===n&&1===i||o.push(r(o)+"scale("+n+","+i+")")}(o.scaleX,o.scaleY,l.scaleX,l.scaleY,a,s),o=l=null,function(t){for(var e,n=-1,i=s.length;++n<i;)a[(e=s[n]).i]=e.x(t);return a.join("")}}}var na=ea((function(t){const e=new("function"==typeof DOMMatrix?DOMMatrix:WebKitCSSMatrix)(t+"");return e.isIdentity?Ql:ta(e.a,e.b,e.c,e.d,e.e,e.f)}),"px, ","px)","deg)"),ia=ea((function(t){return null==t?Ql:(Zl||(Zl=document.createElementNS("http://www.w3.org/2000/svg","g")),Zl.setAttribute("transform",t),(t=Zl.transform.baseVal.consolidate())?ta((t=t.matrix).a,t.b,t.c,t.d,t.e,t.f):Ql)}),", ",")",")");function ra(t,e){var n,i;return function(){var r=Kl(this,t),o=r.tween;if(o!==n)for(var l=0,a=(i=n=o).length;l<a;++l)if(i[l].name===e){(i=i.slice()).splice(l,1);break}r.tween=i}}function oa(t,e,n){var i,r;if("function"!=typeof n)throw new Error;return function(){var o=Kl(this,t),l=o.tween;if(l!==i){r=(i=l).slice();for(var a={name:e,value:n},s=0,c=r.length;s<c;++s)if(r[s].name===e){r[s]=a;break}s===c&&r.push(a)}o.tween=r}}function la(t,e,n){var i=t._id;return t.each((function(){var t=Kl(this,i);(t.value||(t.value={}))[e]=n.apply(this,arguments)})),function(t){return Ul(t,i).value[e]}}function aa(t,e){var n;return("number"==typeof e?se:e instanceof Bt?ie:(n=Bt(e))?(e=n,ie):de)(t,e)}function sa(t){return function(){this.removeAttribute(t)}}function ca(t){return function(){this.removeAttributeNS(t.space,t.local)}}function ua(t,e,n){var i,r,o=n+"";return function(){var l=this.getAttribute(t);return l===o?null:l===i?r:r=e(i=l,n)}}function ha(t,e,n){var i,r,o=n+"";return function(){var l=this.getAttributeNS(t.space,t.local);return l===o?null:l===i?r:r=e(i=l,n)}}function da(t,e,n){var i,r,o;return function(){var l,a,s=n(this);if(null!=s)return(l=this.getAttribute(t))===(a=s+"")?null:l===i&&a===r?o:(r=a,o=e(i=l,s));this.removeAttribute(t)}}function fa(t,e,n){var i,r,o;return function(){var l,a,s=n(this);if(null!=s)return(l=this.getAttributeNS(t.space,t.local))===(a=s+"")?null:l===i&&a===r?o:(r=a,o=e(i=l,s));this.removeAttributeNS(t.space,t.local)}}function pa(t,e){return function(n){this.setAttribute(t,e.call(this,n))}}function ga(t,e){return function(n){this.setAttributeNS(t.space,t.local,e.call(this,n))}}function ma(t,e){var n,i;function r(){var r=e.apply(this,arguments);return r!==i&&(n=(i=r)&&ga(t,r)),n}return r._value=e,r}function va(t,e){var n,i;function r(){var r=e.apply(this,arguments);return r!==i&&(n=(i=r)&&pa(t,r)),n}return r._value=e,r}function ya(t,e){return function(){Yl(this,t).delay=+e.apply(this,arguments)}}function ba(t,e){return e=+e,function(){Yl(this,t).delay=e}}function wa(t,e){return function(){Kl(this,t).duration=+e.apply(this,arguments)}}function $a(t,e){return e=+e,function(){Kl(this,t).duration=e}}function xa(t,e){if("function"!=typeof e)throw new Error;return function(){Kl(this,t).ease=e}}function _a(t,e,n){var i,r,o=function(t){return(t+"").trim().split(/^|\s+/).every((function(t){var e=t.indexOf(".");return e>=0&&(t=t.slice(0,e)),!t||"start"===t}))}(e)?Yl:Kl;return function(){var l=o(this,t),a=l.on;a!==i&&(r=(i=a).copy()).on(e,n),l.on=r}}var ka=dl.prototype.constructor;function Ma(t){return function(){this.style.removeProperty(t)}}function La(t,e,n){return function(i){this.style.setProperty(t,e.call(this,i),n)}}function Aa(t,e,n){var i,r;function o(){var o=e.apply(this,arguments);return o!==r&&(i=(r=o)&&La(t,o,n)),i}return o._value=e,o}function Sa(t){return function(e){this.textContent=t.call(this,e)}}function Na(t){var e,n;function i(){var i=t.apply(this,arguments);return i!==n&&(e=(n=i)&&Sa(i)),e}return i._value=t,i}var za=0;function Ta(t,e,n,i){this._groups=t,this._parents=e,this._name=n,this._id=i}function Ca(){return++za}var qa=dl.prototype;Ta.prototype=function(t){return dl().transition(t)}.prototype={constructor:Ta,select:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=Jr(t));for(var i=this._groups,r=i.length,o=new Array(r),l=0;l<r;++l)for(var a,s,c=i[l],u=c.length,h=o[l]=new Array(u),d=0;d<u;++d)(a=c[d])&&(s=t.call(a,a.__data__,d,c))&&("__data__"in a&&(s.__data__=a.__data__),h[d]=s,Xl(h[d],e,n,d,h,Ul(a,n)));return new Ta(o,this._parents,e,n)},selectAll:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=eo(t));for(var i=this._groups,r=i.length,o=[],l=[],a=0;a<r;++a)for(var s,c=i[a],u=c.length,h=0;h<u;++h)if(s=c[h]){for(var d,f=t.call(s,s.__data__,h,c),p=Ul(s,n),g=0,m=f.length;g<m;++g)(d=f[g])&&Xl(d,e,n,g,f,p);o.push(f),l.push(s)}return new Ta(o,l,e,n)},selectChild:qa.selectChild,selectChildren:qa.selectChildren,filter:function(t){"function"!=typeof t&&(t=no(t));for(var e=this._groups,n=e.length,i=new Array(n),r=0;r<n;++r)for(var o,l=e[r],a=l.length,s=i[r]=[],c=0;c<a;++c)(o=l[c])&&t.call(o,o.__data__,c,l)&&s.push(o);return new Ta(i,this._parents,this._name,this._id)},merge:function(t){if(t._id!==this._id)throw new Error;for(var e=this._groups,n=t._groups,i=e.length,r=n.length,o=Math.min(i,r),l=new Array(i),a=0;a<o;++a)for(var s,c=e[a],u=n[a],h=c.length,d=l[a]=new Array(h),f=0;f<h;++f)(s=c[f]||u[f])&&(d[f]=s);for(;a<i;++a)l[a]=e[a];return new Ta(l,this._parents,this._name,this._id)},selection:function(){return new ka(this._groups,this._parents)},transition:function(){for(var t=this._name,e=this._id,n=Ca(),i=this._groups,r=i.length,o=0;o<r;++o)for(var l,a=i[o],s=a.length,c=0;c<s;++c)if(l=a[c]){var u=Ul(l,e);Xl(l,t,n,c,a,{time:u.time+u.delay+u.duration,delay:0,duration:u.duration,ease:u.ease})}return new Ta(i,this._parents,t,n)},call:qa.call,nodes:qa.nodes,node:qa.node,size:qa.size,empty:qa.empty,each:qa.each,on:function(t,e){var n=this._id;return arguments.length<2?Ul(this.node(),n).on.on(t):this.each(_a(n,t,e))},attr:function(t,e){var n=bo(t),i="transform"===n?ia:aa;return this.attrTween(t,"function"==typeof e?(n.local?fa:da)(n,i,la(this,"attr."+t,e)):null==e?(n.local?ca:sa)(n):(n.local?ha:ua)(n,i,e))},attrTween:function(t,e){var n="attr."+t;if(arguments.length<2)return(n=this.tween(n))&&n._value;if(null==e)return this.tween(n,null);if("function"!=typeof e)throw new Error;var i=bo(t);return this.tween(n,(i.local?ma:va)(i,e))},style:function(t,e,n){var i="transform"==(t+="")?na:aa;return null==e?this.styleTween(t,function(t,e){var n,i,r;return function(){var o=zo(this,t),l=(this.style.removeProperty(t),zo(this,t));return o===l?null:o===n&&l===i?r:r=e(n=o,i=l)}}(t,i)).on("end.style."+t,Ma(t)):"function"==typeof e?this.styleTween(t,function(t,e,n){var i,r,o;return function(){var l=zo(this,t),a=n(this),s=a+"";return null==a&&(this.style.removeProperty(t),s=a=zo(this,t)),l===s?null:l===i&&s===r?o:(r=s,o=e(i=l,a))}}(t,i,la(this,"style."+t,e))).each(function(t,e){var n,i,r,o,l="style."+e,a="end."+l;return function(){var s=Kl(this,t),c=s.on,u=null==s.value[l]?o||(o=Ma(e)):void 0;c===n&&r===u||(i=(n=c).copy()).on(a,r=u),s.on=i}}(this._id,t)):this.styleTween(t,function(t,e,n){var i,r,o=n+"";return function(){var l=zo(this,t);return l===o?null:l===i?r:r=e(i=l,n)}}(t,i,e),n).on("end.style."+t,null)},styleTween:function(t,e,n){var i="style."+(t+="");if(arguments.length<2)return(i=this.tween(i))&&i._value;if(null==e)return this.tween(i,null);if("function"!=typeof e)throw new Error;return this.tween(i,Aa(t,e,null==n?"":n))},text:function(t){return this.tween("text","function"==typeof t?function(t){return function(){var e=t(this);this.textContent=null==e?"":e}}(la(this,"text",t)):function(t){return function(){this.textContent=t}}(null==t?"":t+""))},textTween:function(t){var e="text";if(arguments.length<1)return(e=this.tween(e))&&e._value;if(null==t)return this.tween(e,null);if("function"!=typeof t)throw new Error;return this.tween(e,Na(t))},remove:function(){return this.on("end.remove",function(t){return function(){var e=this.parentNode;for(var n in this.__transition)if(+n!==t)return;e&&e.removeChild(this)}}(this._id))},tween:function(t,e){var n=this._id;if(t+="",arguments.length<2){for(var i,r=Ul(this.node(),n).tween,o=0,l=r.length;o<l;++o)if((i=r[o]).name===t)return i.value;return null}return this.each((null==e?ra:oa)(n,t,e))},delay:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?ya:ba)(e,t)):Ul(this.node(),e).delay},duration:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?wa:$a)(e,t)):Ul(this.node(),e).duration},ease:function(t){var e=this._id;return arguments.length?this.each(xa(e,t)):Ul(this.node(),e).ease},easeVarying:function(t){if("function"!=typeof t)throw new Error;return this.each(function(t,e){return function(){var n=e.apply(this,arguments);if("function"!=typeof n)throw new Error;Kl(this,t).ease=n}}(this._id,t))},end:function(){var t,e,n=this,i=n._id,r=n.size();return new Promise((function(o,l){var a={value:l},s={value:function(){0==--r&&o()}};n.each((function(){var n=Kl(this,i),r=n.on;r!==t&&((e=(t=r).copy())._.cancel.push(a),e._.interrupt.push(a),e._.end.push(s)),n.on=e})),0===r&&o()}))},[Symbol.iterator]:qa[Symbol.iterator]};var Ea={time:null,delay:0,duration:250,ease:function(t){return((t*=2)<=1?t*t*t:(t-=2)*t*t+2)/2}};function Oa(t,e){for(var n;!(n=t.__transition)||!(n=n[e]);)if(!(t=t.parentNode))throw new Error(`transition ${e} not found`);return n}dl.prototype.interrupt=function(t){return this.each((function(){Gl(this,t)}))},dl.prototype.transition=function(t){var e,n;t instanceof Ta?(e=t._id,t=t._name):(e=Ca(),(n=Ea).time=Dl(),t=null==t?null:t+"");for(var i=this._groups,r=i.length,o=0;o<r;++o)for(var l,a=i[o],s=a.length,c=0;c<s;++c)(l=a[c])&&Xl(l,t,e,c,a,n||Oa(l,e));return new Ta(i,this._parents,t,e)};const Da=t=>()=>t;function Ba(t,{sourceEvent:e,target:n,selection:i,mode:r,dispatch:o}){Object.defineProperties(this,{type:{value:t,enumerable:!0,configurable:!0},sourceEvent:{value:e,enumerable:!0,configurable:!0},target:{value:n,enumerable:!0,configurable:!0},selection:{value:i,enumerable:!0,configurable:!0},mode:{value:r,enumerable:!0,configurable:!0},_:{value:o}})}function ja(t){t.stopImmediatePropagation()}function Pa(t){t.preventDefault(),t.stopImmediatePropagation()}var Ha={name:"drag"},Ra={name:"space"},Ia={name:"handle"},Va={name:"center"};const{abs:Wa,max:Fa,min:Xa}=Math;function Ya(t){return[+t[0],+t[1]]}function Ka(t){return[Ya(t[0]),Ya(t[1])]}var Ua={name:"x",handles:["w","e"].map(is),input:function(t,e){return null==t?null:[[+t[0],e[0][1]],[+t[1],e[1][1]]]},output:function(t){return t&&[t[0][0],t[1][0]]}},Ga={name:"y",handles:["n","s"].map(is),input:function(t,e){return null==t?null:[[e[0][0],+t[0]],[e[1][0],+t[1]]]},output:function(t){return t&&[t[0][1],t[1][1]]}},Za={name:"xy",handles:["n","w","e","s","nw","ne","sw","se"].map(is),input:function(t){return null==t?null:Ka(t)},output:function(t){return t}},Ja={overlay:"crosshair",selection:"move",n:"ns-resize",e:"ew-resize",s:"ns-resize",w:"ew-resize",nw:"nwse-resize",ne:"nesw-resize",se:"nwse-resize",sw:"nesw-resize"},Qa={e:"w",w:"e",nw:"ne",ne:"nw",se:"sw",sw:"se"},ts={n:"s",s:"n",nw:"sw",ne:"se",se:"ne",sw:"nw"},es={overlay:1,selection:1,n:null,e:1,s:null,w:-1,nw:-1,ne:1,se:1,sw:-1},ns={overlay:1,selection:1,n:-1,e:null,s:1,w:null,nw:-1,ne:-1,se:1,sw:1};function is(t){return{type:t}}function rs(t){return!t.ctrlKey&&!t.button}function os(){var t=this.ownerSVGElement||this;return t.hasAttribute("viewBox")?[[(t=t.viewBox.baseVal).x,t.y],[t.x+t.width,t.y+t.height]]:[[0,0],[t.width.baseVal.value,t.height.baseVal.value]]}function ls(){return navigator.maxTouchPoints||"ontouchstart"in this}function as(t){for(;!t.__brush;)if(!(t=t.parentNode))return;return t.__brush}function ss(t){return t[0][0]===t[1][0]||t[0][1]===t[1][1]}function cs(){return hs(Ua)}function us(){return hs(Za)}function hs(t){var e,n=os,i=rs,r=ls,o=!0,l=wl("start","brush","end"),a=6;function s(e){var n=e.property("__brush",g).selectAll(".overlay").data([is("overlay")]);n.enter().append("rect").attr("class","overlay").attr("pointer-events","all").attr("cursor",Ja.overlay).merge(n).each((function(){var t=as(this).extent;fl(this).attr("x",t[0][0]).attr("y",t[0][1]).attr("width",t[1][0]-t[0][0]).attr("height",t[1][1]-t[0][1])})),e.selectAll(".selection").data([is("selection")]).enter().append("rect").attr("class","selection").attr("cursor",Ja.selection).attr("fill","#777").attr("fill-opacity",.3).attr("stroke","#fff").attr("shape-rendering","crispEdges");var i=e.selectAll(".handle").data(t.handles,(function(t){return t.type}));i.exit().remove(),i.enter().append("rect").attr("class",(function(t){return"handle handle--"+t.type})).attr("cursor",(function(t){return Ja[t.type]})),e.each(c).attr("fill","none").attr("pointer-events","all").on("mousedown.brush",d).filter(r).on("touchstart.brush",d).on("touchmove.brush",f).on("touchend.brush touchcancel.brush",p).style("touch-action","none").style("-webkit-tap-highlight-color","rgba(0,0,0,0)")}function c(){var t=fl(this),e=as(this).selection;e?(t.selectAll(".selection").style("display",null).attr("x",e[0][0]).attr("y",e[0][1]).attr("width",e[1][0]-e[0][0]).attr("height",e[1][1]-e[0][1]),t.selectAll(".handle").style("display",null).attr("x",(function(t){return"e"===t.type[t.type.length-1]?e[1][0]-a/2:e[0][0]-a/2})).attr("y",(function(t){return"s"===t.type[0]?e[1][1]-a/2:e[0][1]-a/2})).attr("width",(function(t){return"n"===t.type||"s"===t.type?e[1][0]-e[0][0]+a:a})).attr("height",(function(t){return"e"===t.type||"w"===t.type?e[1][1]-e[0][1]+a:a}))):t.selectAll(".selection,.handle").style("display","none").attr("x",null).attr("y",null).attr("width",null).attr("height",null)}function u(t,e,n){var i=t.__brush.emitter;return!i||n&&i.clean?new h(t,e,n):i}function h(t,e,n){this.that=t,this.args=e,this.state=t.__brush,this.active=0,this.clean=n}function d(n){if((!e||n.touches)&&i.apply(this,arguments)){var r,l,a,s,h,d,f,p,g,m,v,y=this,b=n.target.__data__.type,w="selection"===(o&&n.metaKey?b="overlay":b)?Ha:o&&n.altKey?Va:Ia,$=t===Ga?null:es[b],x=t===Ua?null:ns[b],_=as(y),k=_.extent,M=_.selection,L=k[0][0],A=k[0][1],S=k[1][0],N=k[1][1],z=0,T=0,C=$&&x&&o&&n.shiftKey,q=Array.from(n.touches||[n],(t=>{const e=t.identifier;return(t=Ml(t,y)).point0=t.slice(),t.identifier=e,t}));Gl(y);var E=u(y,arguments,!0).beforestart();if("overlay"===b){M&&(g=!0);const e=[q[0],q[1]||q[0]];_.selection=M=[[r=t===Ga?L:Xa(e[0][0],e[1][0]),a=t===Ua?A:Xa(e[0][1],e[1][1])],[h=t===Ga?S:Fa(e[0][0],e[1][0]),f=t===Ua?N:Fa(e[0][1],e[1][1])]],q.length>1&&P(n)}else r=M[0][0],a=M[0][1],h=M[1][0],f=M[1][1];l=r,s=a,d=h,p=f;var O=fl(y).attr("pointer-events","none"),D=O.selectAll(".overlay").attr("cursor",Ja[b]);if(n.touches)E.moved=j,E.ended=H;else{var B=fl(n.view).on("mousemove.brush",j,!0).on("mouseup.brush",H,!0);o&&B.on("keydown.brush",R,!0).on("keyup.brush",I,!0),_l(n.view)}c.call(y),E.start(n,w.name)}function j(t){for(const e of t.changedTouches||[t])for(const t of q)t.identifier===e.identifier&&(t.cur=Ml(e,y));if(C&&!m&&!v&&1===q.length){const t=q[0];Wa(t.cur[0]-t[0])>Wa(t.cur[1]-t[1])?v=!0:m=!0}for(const t of q)t.cur&&(t[0]=t.cur[0],t[1]=t.cur[1]);g=!0,Pa(t),P(t)}function P(t){const e=q[0],n=e.point0;var i;switch(z=e[0]-n[0],T=e[1]-n[1],w){case Ra:case Ha:$&&(z=Fa(L-r,Xa(S-h,z)),l=r+z,d=h+z),x&&(T=Fa(A-a,Xa(N-f,T)),s=a+T,p=f+T);break;case Ia:q[1]?($&&(l=Fa(L,Xa(S,q[0][0])),d=Fa(L,Xa(S,q[1][0])),$=1),x&&(s=Fa(A,Xa(N,q[0][1])),p=Fa(A,Xa(N,q[1][1])),x=1)):($<0?(z=Fa(L-r,Xa(S-r,z)),l=r+z,d=h):$>0&&(z=Fa(L-h,Xa(S-h,z)),l=r,d=h+z),x<0?(T=Fa(A-a,Xa(N-a,T)),s=a+T,p=f):x>0&&(T=Fa(A-f,Xa(N-f,T)),s=a,p=f+T));break;case Va:$&&(l=Fa(L,Xa(S,r-z*$)),d=Fa(L,Xa(S,h+z*$))),x&&(s=Fa(A,Xa(N,a-T*x)),p=Fa(A,Xa(N,f+T*x)))}d<l&&($*=-1,i=r,r=h,h=i,i=l,l=d,d=i,b in Qa&&D.attr("cursor",Ja[b=Qa[b]])),p<s&&(x*=-1,i=a,a=f,f=i,i=s,s=p,p=i,b in ts&&D.attr("cursor",Ja[b=ts[b]])),_.selection&&(M=_.selection),m&&(l=M[0][0],d=M[1][0]),v&&(s=M[0][1],p=M[1][1]),M[0][0]===l&&M[0][1]===s&&M[1][0]===d&&M[1][1]===p||(_.selection=[[l,s],[d,p]],c.call(y),E.brush(t,w.name))}function H(t){if(ja(t),t.touches){if(t.touches.length)return;e&&clearTimeout(e),e=setTimeout((function(){e=null}),500)}else kl(t.view,g),B.on("keydown.brush keyup.brush mousemove.brush mouseup.brush",null);O.attr("pointer-events","all"),D.attr("cursor",Ja.overlay),_.selection&&(M=_.selection),ss(M)&&(_.selection=null,c.call(y)),E.end(t,w.name)}function R(t){switch(t.keyCode){case 16:C=$&&x;break;case 18:w===Ia&&($&&(h=d-z*$,r=l+z*$),x&&(f=p-T*x,a=s+T*x),w=Va,P(t));break;case 32:w!==Ia&&w!==Va||($<0?h=d-z:$>0&&(r=l-z),x<0?f=p-T:x>0&&(a=s-T),w=Ra,D.attr("cursor",Ja.selection),P(t));break;default:return}Pa(t)}function I(t){switch(t.keyCode){case 16:C&&(m=v=C=!1,P(t));break;case 18:w===Va&&($<0?h=d:$>0&&(r=l),x<0?f=p:x>0&&(a=s),w=Ia,P(t));break;case 32:w===Ra&&(t.altKey?($&&(h=d-z*$,r=l+z*$),x&&(f=p-T*x,a=s+T*x),w=Va):($<0?h=d:$>0&&(r=l),x<0?f=p:x>0&&(a=s),w=Ia),D.attr("cursor",Ja[b]),P(t));break;default:return}Pa(t)}}function f(t){u(this,arguments).moved(t)}function p(t){u(this,arguments).ended(t)}function g(){var e=this.__brush||{selection:null};return e.extent=Ka(n.apply(this,arguments)),e.dim=t,e}return s.move=function(e,n,i){e.tween?e.on("start.brush",(function(t){u(this,arguments).beforestart().start(t)})).on("interrupt.brush end.brush",(function(t){u(this,arguments).end(t)})).tween("brush",(function(){var e=this,i=e.__brush,r=u(e,arguments),o=i.selection,l=t.input("function"==typeof n?n.apply(this,arguments):n,i.extent),a=pe(o,l);function s(t){i.selection=1===t&&null===l?null:a(t),c.call(e),r.brush()}return null!==o&&null!==l?s:s(1)})):e.each((function(){var e=this,r=arguments,o=e.__brush,l=t.input("function"==typeof n?n.apply(e,r):n,o.extent),a=u(e,r).beforestart();Gl(e),o.selection=null===l?null:l,c.call(e),a.start(i).brush(i).end(i)}))},s.clear=function(t,e){s.move(t,null,e)},h.prototype={beforestart:function(){return 1==++this.active&&(this.state.emitter=this,this.starting=!0),this},start:function(t,e){return this.starting?(this.starting=!1,this.emit("start",t,e)):this.emit("brush",t),this},brush:function(t,e){return this.emit("brush",t,e),this},end:function(t,e){return 0==--this.active&&(delete this.state.emitter,this.emit("end",t,e)),this},emit:function(e,n,i){var r=fl(this.that).datum();l.call(e,this.that,new Ba(e,{sourceEvent:n,target:s,selection:t.output(this.state.selection),mode:i,dispatch:l}),r)}},s.extent=function(t){return arguments.length?(n="function"==typeof t?t:Da(Ka(t)),s):n},s.filter=function(t){return arguments.length?(i="function"==typeof t?t:Da(!!t),s):i},s.touchable=function(t){return arguments.length?(r="function"==typeof t?t:Da(!!t),s):r},s.handleSize=function(t){return arguments.length?(a=+t,s):a},s.keyModifiers=function(t){return arguments.length?(o=!!t,s):o},s.on=function(){var t=l.on.apply(l,arguments);return t===l?s:t},s}function ds(t){w(t,"svelte-1sazhg0","div.svelte-1sazhg0{position:relative;width:100%;height:100%}svg.svelte-1sazhg0,canvas.svelte-1sazhg0{position:absolute;top:0;left:0}")}function fs(t){let e,n,i,r,o,l=t[5]&&t[9]&&t[15].length>0&&ps(t);const a=[ys,vs],s=[];function c(t,e){return"bandwidth"in t[13]?0:1}return n=c(t),i=s[n]=a[n](t),{c(){l&&l.c(),e=S(),i.c(),r=S()},m(t,i){l&&l.m(t,i),$(t,e,i),s[n].m(t,i),$(t,r,i),o=!0},p(t,o){t[5]&&t[9]&&t[15].length>0?l?(l.p(t,o),33312&o[0]&&ot(l,1)):(l=ps(t),l.c(),ot(l,1),l.m(e.parentNode,e)):l&&(it(),lt(l,1,1,(()=>{l=null})),rt());let u=n;n=c(t),n===u?s[n].p(t,o):(it(),lt(s[u],1,1,(()=>{s[u]=null})),rt(),i=s[n],i?i.p(t,o):(i=s[n]=a[n](t),i.c()),ot(i,1),i.m(r.parentNode,r))},i(t){o||(ot(l),ot(i),o=!0)},o(t){lt(l),lt(i),o=!1},d(t){l&&l.d(t),t&&x(e),s[n].d(t),t&&x(r)}}}function ps(t){let e,n,i,r;const o=[ms,gs],l=[];function a(t,e){return"bandwidth"in t[13]?0:1}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),i=S()},m(t,n){l[e].m(t,n),$(t,i,n),r=!0},p(t,r){let s=e;e=a(t),e===s?l[e].p(t,r):(it(),lt(l[s],1,1,(()=>{l[s]=null})),rt(),n=l[e],n?n.p(t,r):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(i.parentNode,i))},i(t){r||(ot(n),r=!0)},o(t){lt(n),r=!1},d(t){l[e].d(t),t&&x(i)}}}function gs(t){let e,n;return e=new mr({props:{data:t[9],fill:"var(--light-red)",x:t[13],height:t[4],direction:"horizontal",translate:[0,t[11].top-t[4]],unit:"percent",maxValue:t[16]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};512&n[0]&&(i.data=t[9]),8192&n[0]&&(i.x=t[13]),16&n[0]&&(i.height=t[4]),2064&n[0]&&(i.translate=[0,t[11].top-t[4]]),65536&n[0]&&(i.maxValue=t[16]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function ms(t){let e,n;return e=new Ar({props:{data:t[9],fill:"var(--light-red)",x:t[13],height:t[4],direction:"horizontal",translate:[0,t[11].top-t[4]],unit:"percent",maxValue:t[16]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};512&n[0]&&(i.data=t[9]),8192&n[0]&&(i.x=t[13]),16&n[0]&&(i.height=t[4]),2064&n[0]&&(i.translate=[0,t[11].top-t[4]]),65536&n[0]&&(i.maxValue=t[16]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function vs(t){let e,n;return e=new mr({props:{data:t[10].distribution,fill:t[17]?"none":"var(--gray-3)",stroke:t[17]?"var(--black)":"none",x:t[13],height:t[4],direction:"horizontal",translate:[0,t[11].top-t[4]],unit:"percent",maxValue:t[16]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1024&n[0]&&(i.data=t[10].distribution),131072&n[0]&&(i.fill=t[17]?"none":"var(--gray-3)"),131072&n[0]&&(i.stroke=t[17]?"var(--black)":"none"),8192&n[0]&&(i.x=t[13]),16&n[0]&&(i.height=t[4]),2064&n[0]&&(i.translate=[0,t[11].top-t[4]]),65536&n[0]&&(i.maxValue=t[16]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function ys(t){let e,n;return e=new Ar({props:{data:t[10].distribution,fill:t[17]?"none":"var(--gray-3)",stroke:t[17]?"var(--black)":"none",x:t[13],height:t[4],direction:"horizontal",translate:[0,t[11].top-t[4]],unit:"percent",maxValue:t[16]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1024&n[0]&&(i.data=t[10].distribution),131072&n[0]&&(i.fill=t[17]?"none":"var(--gray-3)"),131072&n[0]&&(i.stroke=t[17]?"var(--black)":"none"),8192&n[0]&&(i.x=t[13]),16&n[0]&&(i.height=t[4]),2064&n[0]&&(i.translate=[0,t[11].top-t[4]]),65536&n[0]&&(i.maxValue=t[16]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function bs(t){let e,n,i,r,o,l,a,s;l=new Vi({props:{scale:t[13],y:t[14]-t[11].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[10].subkind,value_map:"value_map"in t[10]?t[10].value_map:{}}}),a=new or({props:{scale:t[12],x:t[11].left,label:t[6]?"centered prediction":"prediction"}});let c=t[3]&&fs(t);return{c(){e=k("div"),n=k("canvas"),i=A(),r=M("svg"),o=M("g"),ht(l.$$.fragment),ht(a.$$.fragment),c&&c.c(),z(n,"class","svelte-1sazhg0"),z(r,"width",t[1]),z(r,"height",t[2]),z(r,"class","svelte-1sazhg0"),z(e,"class","svelte-1sazhg0")},m(u,h){$(u,e,h),b(e,n),t[37](n),b(e,i),b(e,r),b(r,o),dt(l,o,null),dt(a,o,null),c&&c.m(o,null),t[38](o),s=!0},p(t,e){const n={};8192&e[0]&&(n.scale=t[13]),18432&e[0]&&(n.y=t[14]-t[11].bottom),1&e[0]&&(n.label=t[0].x_feature),1024&e[0]&&(n.integerOnly="discrete"===t[10].subkind),1024&e[0]&&(n.value_map="value_map"in t[10]?t[10].value_map:{}),l.$set(n);const i={};4096&e[0]&&(i.scale=t[12]),2048&e[0]&&(i.x=t[11].left),64&e[0]&&(i.label=t[6]?"centered prediction":"prediction"),a.$set(i),t[3]?c?(c.p(t,e),8&e[0]&&ot(c,1)):(c=fs(t),c.c(),ot(c,1),c.m(o,null)):c&&(it(),lt(c,1,1,(()=>{c=null})),rt()),(!s||2&e[0])&&z(r,"width",t[1]),(!s||4&e[0])&&z(r,"height",t[2])},i(t){s||(ot(l.$$.fragment,t),ot(a.$$.fragment,t),ot(c),s=!0)},o(t){lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(c),s=!1},d(n){n&&x(e),t[37](null),ft(l),ft(a),c&&c.d(),t[38](null)}}}function ws(t,e,n){let i,r,o,l,a,s,c,u,h,d,f,g,v,y,b,w,$,x,_,k;p(t,Vn,(t=>n(15,v=t))),p(t,Jn,(t=>n(30,y=t))),p(t,Kn,(t=>n(31,b=t))),p(t,Rn,(t=>n(32,w=t))),p(t,Hn,(t=>n(33,$=t))),p(t,Pn,(t=>n(34,x=t))),p(t,jn,(t=>n(35,_=t))),p(t,Tn,(t=>n(36,k=t)));let M,L,{pd:A}=e,{width:S}=e,{height:N}=e,{scaleLocally:z}=e,{showMarginalDistribution:T}=e,{marginTop:C}=e,{distributionHeight:q}=e,{allowBrushing:E=!1}=e,{iceLineWidth:O}=e,{center:D=!1}=e;function B(t,e,n,i,r,o,l,a,s,c,u,h){var d;if(null==e||null==n)return;e.save(),e.clearRect(0,0,c,u),e.lineWidth=l,e.strokeStyle="rgb(198, 198, 198)",e.globalAlpha=.15;const f=h?t.ice.centered_ice_lines:t.ice.ice_lines;if(f.forEach((t=>{e.beginPath(),n(t),e.stroke()})),s&&(e.strokeStyle="red",e.globalAlpha=.15,i.forEach((t=>{e.beginPath(),n(f[t]),e.stroke()}))),e.lineWidth=2,e.strokeStyle="black",e.globalAlpha=1,e.beginPath(),n(h?t.ice.centered_pdp:t.mean_predictions),e.stroke(),"step"in r)for(let n=0;n<t.x_values.length;n++){const i=null!==(d=r(t.x_values[n]))&&void 0!==d?d:0,l=o(h?t.ice.centered_pdp[n]:t.mean_predictions[n]);e.beginPath(),e.arc(i,l,a,0,2*Math.PI),e.fill()}e.restore()}H((()=>{n(21,L=M.getContext("2d"))}));let j,P,R,I=!1,W=!1;function F(t){n(22,I=!0),m(Kn,b=!0,b),n(23,W=!0)}function X({selection:t}){if(!t)return void m(Vn,v=[],v);const[[e,n],[i,r]]=t,o=A.x_values.map((t=>{var e;return null!==(e=a(t))&&void 0!==e?e:0})),l=D?A.ice.centered_ice_lines:A.ice.ice_lines;m(Vn,v=l.map(((t,e)=>({lines:t,index:e}))).filter((({lines:t})=>t.some(((t,l)=>{const a=c(t),s=o[l];return s>=e&&s<=i&&a>=n&&a<=r})))).map((({index:t})=>t)),v)}function Y({selection:t}){null===t&&(n(22,I=!1),m(Vn,v=[],v)),m(Kn,b=!1,b),n(23,W=!1)}return t.$$set=t=>{"pd"in t&&n(0,A=t.pd),"width"in t&&n(1,S=t.width),"height"in t&&n(2,N=t.height),"scaleLocally"in t&&n(18,z=t.scaleLocally),"showMarginalDistribution"in t&&n(3,T=t.showMarginalDistribution),"marginTop"in t&&n(19,C=t.marginTop),"distributionHeight"in t&&n(4,q=t.distributionHeight),"allowBrushing"in t&&n(5,E=t.allowBrushing),"iceLineWidth"in t&&n(20,O=t.iceLineWidth),"center"in t&&n(6,D=t.center)},t.$$.update=()=>{1&t.$$.dirty[0]|32&t.$$.dirty[1]&&n(10,i=k[A.x_feature]),524288&t.$$.dirty[0]&&n(11,r={top:C,right:10,bottom:35,left:50}),4&t.$$.dirty[0]&&n(14,o=N),16385&t.$$.dirty[0]&&n(29,l=o/A.ice.clusters.length),3075&t.$$.dirty[0]&&n(13,a="quantitative"===i.kind?tn().domain([A.x_values[0],A.x_values[A.x_values.length-1]]).range([r.left,S-r.right]):ui().domain(A.x_values).range([r.left,S-r.right]).padding(.5)),8192&t.$$.dirty[0]&&n(27,s="step"in a?Math.min(3,a.step()/2-1):0),537151553&t.$$.dirty[0]|30&t.$$.dirty[1]&&n(12,c=kn(A,o,l,D?"centered-lines":"lines",z,_,x,0,w,r)),2109441&t.$$.dirty[0]&&n(28,u=ki().x(((t,e)=>{var n;return null!==(n=a(A.x_values[e]))&&void 0!==n?n:0})).y((t=>c(t))).context(L)),32800&t.$$.dirty[0]&&n(26,h=E&&v.length>0),2097286&t.$$.dirty[0]&&L&&(xn(M,L,S,N),B(A,L,u,v,a,c,O,s,h,S,N,D)),472952903&t.$$.dirty[0]&&B(A,L,u,v,a,c,O,s,h,S,N,D),2054&t.$$.dirty[0]&&n(25,d=us().extent([[r.left,r.top],[S-r.right,N-r.bottom]]).on("start",F).on("brush",X).on("end",Y)),50331936&t.$$.dirty[0]&&j&&E&&(n(24,P=fl(j)),P.call(d)),62914560&t.$$.dirty[0]|1&t.$$.dirty[1]&&b&&I&&!W&&P.call(d.clear),1073741825&t.$$.dirty[0]&&n(9,R=y.get(A.x_feature)),33312&t.$$.dirty[0]&&n(17,f=E&&R&&v.length>0),1536&t.$$.dirty[0]&&n(16,g=function(t,e){const n=Math.max(...t.percents);if(!e)return n;const i=Math.max(...e.percents);return Math.max(n,i)}(i.distribution,R))},[A,S,N,T,q,E,D,M,j,R,i,r,c,a,o,v,g,f,z,C,O,L,I,W,P,d,h,s,u,l,y,b,w,$,x,_,k,function(t){V[t?"unshift":"push"]((()=>{M=t,n(7,M)}))},function(t){V[t?"unshift":"push"]((()=>{j=t,n(8,j)}))}]}const $s=class extends gt{constructor(t){super(),pt(this,t,ws,bs,h,{pd:0,width:1,height:2,scaleLocally:18,showMarginalDistribution:3,marginTop:19,distributionHeight:4,allowBrushing:5,iceLineWidth:20,center:6},ds,[-1,-1])}};function xs(t){let e,n;return e=new Dr({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],distributionHeight:t[7],indices:t[8]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1&n&&(i.pd=t[0]),2&n&&(i.width=t[1]),4&n&&(i.height=t[2]),8&n&&(i.scaleLocally=t[3]),32&n&&(i.showMarginalDistribution=t[5]),64&n&&(i.marginTop=t[6]),128&n&&(i.distributionHeight=t[7]),256&n&&(i.indices=t[8]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function _s(t){let e,n;return e=new Gr({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],distributionHeight:t[7]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1&n&&(i.pd=t[0]),2&n&&(i.width=t[1]),4&n&&(i.height=t[2]),8&n&&(i.scaleLocally=t[3]),32&n&&(i.showMarginalDistribution=t[5]),64&n&&(i.marginTop=t[6]),128&n&&(i.distributionHeight=t[7]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function ks(t){let e,n;return e=new $s({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],distributionHeight:t[7],allowBrushing:t[9],iceLineWidth:t[10],center:"centered-lines"===t[4]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};1&n&&(i.pd=t[0]),2&n&&(i.width=t[1]),4&n&&(i.height=t[2]),8&n&&(i.scaleLocally=t[3]),32&n&&(i.showMarginalDistribution=t[5]),64&n&&(i.marginTop=t[6]),128&n&&(i.distributionHeight=t[7]),512&n&&(i.allowBrushing=t[9]),1024&n&&(i.iceLineWidth=t[10]),16&n&&(i.center="centered-lines"===t[4]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Ms(t){let e,n,i,r;const o=[ks,_s,xs],l=[];function a(t,e){return"lines"===t[4]||"centered-lines"===t[4]?0:"cluster-centers"===t[4]?1:2}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),i=S()},m(t,n){l[e].m(t,n),$(t,i,n),r=!0},p(t,[r]){let s=e;e=a(t),e===s?l[e].p(t,r):(it(),lt(l[s],1,1,(()=>{l[s]=null})),rt(),n=l[e],n?n.p(t,r):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(i.parentNode,i))},i(t){r||(ot(n),r=!0)},o(t){lt(n),r=!1},d(t){l[e].d(t),t&&x(i)}}}function Ls(t,e,n){let{pd:i}=e,{width:r}=e,{height:o}=e,{scaleLocally:l}=e,{iceLevel:a}=e,{showMarginalDistribution:s}=e,{marginTop:c}=e,{distributionHeight:u}=e,{indices:h}=e,{allowBrushing:d}=e,{iceLineWidth:f}=e;return t.$$set=t=>{"pd"in t&&n(0,i=t.pd),"width"in t&&n(1,r=t.width),"height"in t&&n(2,o=t.height),"scaleLocally"in t&&n(3,l=t.scaleLocally),"iceLevel"in t&&n(4,a=t.iceLevel),"showMarginalDistribution"in t&&n(5,s=t.showMarginalDistribution),"marginTop"in t&&n(6,c=t.marginTop),"distributionHeight"in t&&n(7,u=t.distributionHeight),"indices"in t&&n(8,h=t.indices),"allowBrushing"in t&&n(9,d=t.allowBrushing),"iceLineWidth"in t&&n(10,f=t.iceLineWidth)},[i,r,o,l,a,s,c,u,h,d,f]}const As=class extends gt{constructor(t){super(),pt(this,t,Ls,Ms,h,{pd:0,width:1,height:2,scaleLocally:3,iceLevel:4,showMarginalDistribution:5,marginTop:6,distributionHeight:7,indices:8,allowBrushing:9,iceLineWidth:10})}};function Ss(t,e,n,i,r,o,l,a,s,c){var u,h;e.save(),e.clearRect(0,0,n,i);for(let n=0;n<t.x_values.length;n++){const i=t.x_values[n],d=t.y_values[n],f=t.mean_predictions[n],p=t.interactions[n];e.fillStyle=l("interactions"===a?p:f);const g="bandwidth"in r?(null!==(u=r(i))&&void 0!==u?u:0)+1:r(i)-s/2,m="bandwidth"in o?(null!==(h=o(d))&&void 0!==h?h:0)+1:o(d)-c/2;e.fillRect(g,m,s,c)}e.restore()}function Ns(t){w(t,"svelte-sh84n1",".color-container.svelte-sh84n1{position:relative}svg.svelte-sh84n1{position:absolute;left:0;top:0}")}function zs(t,e,n){const i=t.slice();return i[16]=e[n],i}function Ts(t){let e,n,i,r,o,l,a,s=_n(t[16])+"";return{c(){e=M("g"),n=M("line"),r=M("text"),o=L(s),z(n,"y1",i=0),z(n,"y2",t[5]),z(n,"stroke","black"),z(r,"y",l=t[5]+qs),z(r,"dominant-baseline","hanging"),z(r,"text-anchor","middle"),z(r,"font-size",Es),z(e,"transform",a="translate("+t[4](t[16])+","+t[2]+")")},m(t,i){$(t,e,i),b(e,n),b(e,r),b(r,o)},p(t,i){32&i&&z(n,"y2",t[5]),64&i&&s!==(s=_n(t[16])+"")&&C(o,s),32&i&&l!==(l=t[5]+qs)&&z(r,"y",l),84&i&&a!==(a="translate("+t[4](t[16])+","+t[2]+")")&&z(e,"transform",a)},d(t){t&&x(e)}}}function Cs(t){let e,n,i,r,o=t[6],a=[];for(let e=0;e<o.length;e+=1)a[e]=Ts(zs(t,o,e));return{c(){e=k("div"),n=k("canvas"),i=A(),r=M("svg");for(let t=0;t<a.length;t+=1)a[t].c();z(r,"width",t[0]),z(r,"height",t[1]),z(r,"class","svelte-sh84n1"),z(e,"class","color-container svelte-sh84n1"),E(e,"height",t[1]+"px")},m(o,l){$(o,e,l),b(e,n),t[14](n),b(e,i),b(e,r);for(let t=0;t<a.length;t+=1)a[t].m(r,null)},p(t,[n]){if(116&n){let e;for(o=t[6],e=0;e<o.length;e+=1){const i=zs(t,o,e);a[e]?a[e].p(i,n):(a[e]=Ts(i),a[e].c(),a[e].m(r,null))}for(;e<a.length;e+=1)a[e].d(1);a.length=o.length}1&n&&z(r,"width",t[0]),2&n&&z(r,"height",t[1]),2&n&&E(e,"height",t[1]+"px")},i:l,o:l,d(n){n&&x(e),t[14](null),_(a,n)}}}const qs=2,Es=10;function Os(t,e,n){let i,r,o,l,a,s,c,{width:u}=e,{height:h}=e,{color:d}=e,{marginTop:f=0}=e,{marginRight:p=0}=e,{marginBottom:g=0}=e,{marginLeft:m=0}=e;return H((()=>{n(11,c=s.getContext("2d"))})),t.$$set=t=>{"width"in t&&n(0,u=t.width),"height"in t&&n(1,h=t.height),"color"in t&&n(7,d=t.color),"marginTop"in t&&n(2,f=t.marginTop),"marginRight"in t&&n(8,p=t.marginRight),"marginBottom"in t&&n(9,g=t.marginBottom),"marginLeft"in t&&n(10,m=t.marginLeft)},t.$$.update=()=>{1281&t.$$.dirty&&n(13,i=u-m-p),518&t.$$.dirty&&n(5,r=h-f-g-Es-qs),2059&t.$$.dirty&&c&&xn(s,c,u,h),11431&t.$$.dirty&&c&&function(t,e,n,i,r,o,l,a){t.clearRect(0,0,n,i);for(let n=0;n<r;n++)t.fillStyle=e(n/r),t.fillRect(n+l,a,1,o)}(c,d.interpolator(),u,h,i,r,m,f),1409&t.$$.dirty&&n(4,o=tn().domain([d.domain()[0],d.domain()[d.domain().length-1]]).range([m,u-p])),128&t.$$.dirty&&n(12,l=d.domain().length),12304&t.$$.dirty&&n(6,a=o.ticks(Math.max(i/50,l)))},[u,h,f,s,o,r,a,d,p,g,m,c,l,i,function(t){V[t?"unshift":"push"]((()=>{s=t,n(3,s)}))}]}const Ds=class extends gt{constructor(t){super(),pt(this,t,Os,Cs,h,{width:0,height:1,color:7,marginTop:2,marginRight:8,marginBottom:9,marginLeft:10},Ns)}};function Bs(t,e=js){const n=[];let i,r=!1;for(const o of t)r&&n.push(e(i,o)),i=o,r=!0;return n}function js(t,e){return[t,e]}function Ps(t){w(t,"svelte-1fhirhh","div.svelte-1fhirhh{position:relative;width:100%;height:100%}svg.svelte-1fhirhh,canvas.svelte-1fhirhh{position:absolute;top:var(--top);left:0}")}function Hs(t){let e,n;return e=new Ds({props:{width:t[1],height:t[13],color:t[6],marginLeft:t[10].left,marginRight:t[10].right}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};2&n[0]&&(i.width=t[1]),8192&n[0]&&(i.height=t[13]),64&n[0]&&(i.color=t[6]),1024&n[0]&&(i.marginLeft=t[10].left),1024&n[0]&&(i.marginRight=t[10].right),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Rs(t){let e,n,i,r,o,l,a;const s=[Vs,Is],c=[];function u(t,e){return"bandwidth"in t[8]?0:1}e=u(t),n=c[e]=s[e](t);const h=[Fs,Ws],d=[];function f(t,e){return"bandwidth"in t[7]?0:1}return r=f(t),o=d[r]=h[r](t),{c(){n.c(),i=S(),o.c(),l=S()},m(t,n){c[e].m(t,n),$(t,i,n),d[r].m(t,n),$(t,l,n),a=!0},p(t,a){let p=e;e=u(t),e===p?c[e].p(t,a):(it(),lt(c[p],1,1,(()=>{c[p]=null})),rt(),n=c[e],n?n.p(t,a):(n=c[e]=s[e](t),n.c()),ot(n,1),n.m(i.parentNode,i));let g=r;r=f(t),r===g?d[r].p(t,a):(it(),lt(d[g],1,1,(()=>{d[g]=null})),rt(),o=d[r],o?o.p(t,a):(o=d[r]=h[r](t),o.c()),ot(o,1),o.m(l.parentNode,l))},i(t){a||(ot(n),ot(o),a=!0)},o(t){lt(n),lt(o),a=!1},d(t){c[e].d(t),t&&x(i),d[r].d(t),t&&x(l)}}}function Is(t){let e,n;return e=new mr({props:{data:t[12].distribution,x:t[8],height:t[4],direction:"horizontal",translate:[0,t[10].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};4096&n[0]&&(i.data=t[12].distribution),256&n[0]&&(i.x=t[8]),16&n[0]&&(i.height=t[4]),1040&n[0]&&(i.translate=[0,t[10].top-t[4]]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Vs(t){let e,n;return e=new Ar({props:{data:t[12].distribution,x:t[8],height:t[4],direction:"horizontal",translate:[0,t[10].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};4096&n[0]&&(i.data=t[12].distribution),256&n[0]&&(i.x=t[8]),16&n[0]&&(i.height=t[4]),1040&n[0]&&(i.translate=[0,t[10].top-t[4]]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Ws(t){let e,n;return e=new mr({props:{data:t[11].distribution,x:t[7],height:t[4],direction:"vertical",translate:[t[1]-t[10].right,0]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};2048&n[0]&&(i.data=t[11].distribution),128&n[0]&&(i.x=t[7]),16&n[0]&&(i.height=t[4]),1026&n[0]&&(i.translate=[t[1]-t[10].right,0]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Fs(t){let e,n;return e=new Ar({props:{data:t[11].distribution,x:t[7],height:t[4],direction:"vertical",translate:[t[1]-t[10].right,0]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};2048&n[0]&&(i.data=t[11].distribution),128&n[0]&&(i.x=t[7]),16&n[0]&&(i.height=t[4]),1026&n[0]&&(i.translate=[t[1]-t[10].right,0]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Xs(t){let e,n,i,r,o,l,a,s,c=t[3]&&Hs(t);l=new Vi({props:{scale:t[8],y:t[9]-t[10].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[12].subkind,value_map:"value_map"in t[12]?t[12].value_map:{}}}),a=new or({props:{scale:t[7],x:t[10].left,label:t[0].y_feature,integerOnly:"discrete"===t[11].subkind,value_map:"value_map"in t[11]?t[11].value_map:{}}});let u=t[2]&&Rs(t);return{c(){e=k("div"),c&&c.c(),n=A(),i=k("canvas"),r=A(),o=M("svg"),ht(l.$$.fragment),ht(a.$$.fragment),u&&u.c(),z(i,"class","svelte-1fhirhh"),z(o,"width",t[1]),z(o,"height",t[9]),z(o,"class","svelte-1fhirhh"),z(e,"class","svelte-1fhirhh"),E(e,"--top",t[13])},m(h,d){$(h,e,d),c&&c.m(e,null),b(e,n),b(e,i),t[37](i),b(e,r),b(e,o),dt(l,o,null),dt(a,o,null),u&&u.m(o,null),s=!0},p(t,i){t[3]?c?(c.p(t,i),8&i[0]&&ot(c,1)):(c=Hs(t),c.c(),ot(c,1),c.m(e,n)):c&&(it(),lt(c,1,1,(()=>{c=null})),rt());const r={};256&i[0]&&(r.scale=t[8]),1536&i[0]&&(r.y=t[9]-t[10].bottom),1&i[0]&&(r.label=t[0].x_feature),4096&i[0]&&(r.integerOnly="discrete"===t[12].subkind),4096&i[0]&&(r.value_map="value_map"in t[12]?t[12].value_map:{}),l.$set(r);const h={};128&i[0]&&(h.scale=t[7]),1024&i[0]&&(h.x=t[10].left),1&i[0]&&(h.label=t[0].y_feature),2048&i[0]&&(h.integerOnly="discrete"===t[11].subkind),2048&i[0]&&(h.value_map="value_map"in t[11]?t[11].value_map:{}),a.$set(h),t[2]?u?(u.p(t,i),4&i[0]&&ot(u,1)):(u=Rs(t),u.c(),ot(u,1),u.m(o,null)):u&&(it(),lt(u,1,1,(()=>{u=null})),rt()),(!s||2&i[0])&&z(o,"width",t[1]),(!s||512&i[0])&&z(o,"height",t[9]),8192&i[0]&&E(e,"--top",t[13])},i(t){s||(ot(c),ot(l.$$.fragment,t),ot(a.$$.fragment,t),ot(u),s=!0)},o(t){lt(c),lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(u),s=!1},d(n){n&&x(e),c&&c.d(),t[37](null),ft(l),ft(a),u&&u.d()}}}function Ys(t,e,n){let i,r,o,l,a,s,c,u,h,d,f,g,m,v,y,b,w,$,x,_,k,M,L,A,S;p(t,Un,(t=>n(34,L=t))),p(t,Gn,(t=>n(35,A=t))),p(t,Tn,(t=>n(36,S=t)));let N,z,{pd:T}=e,{width:C}=e,{height:q}=e,{scaleLocally:E}=e,{showMarginalDistribution:O}=e,{colorShows:D}=e,{showColorLegend:B}=e,{marginTop:j=0}=e,{marginRight:P=0}=e,{distributionHeight:R}=e;return H((()=>{n(19,z=N.getContext("2d"))})),t.$$set=t=>{"pd"in t&&n(0,T=t.pd),"width"in t&&n(1,C=t.width),"height"in t&&n(14,q=t.height),"scaleLocally"in t&&n(15,E=t.scaleLocally),"showMarginalDistribution"in t&&n(2,O=t.showMarginalDistribution),"colorShows"in t&&n(16,D=t.colorShows),"showColorLegend"in t&&n(3,B=t.showColorLegend),"marginTop"in t&&n(17,j=t.marginTop),"marginRight"in t&&n(18,P=t.marginRight),"distributionHeight"in t&&n(4,R=t.distributionHeight)},t.$$.update=()=>{8&t.$$.dirty[0]&&n(13,i=B?24:0),24576&t.$$.dirty[0]&&n(9,r=q-i),393216&t.$$.dirty[0]&&n(31,o={top:j,right:P,bottom:35,left:50}),514&t.$$.dirty[0]|1&t.$$.dirty[1]&&n(33,l=Math.min(C-o.left-o.right,r-o.top-o.bottom)),2&t.$$.dirty[0]|5&t.$$.dirty[1]&&n(30,a=(C-l-o.left-o.right)/2),512&t.$$.dirty[0]|5&t.$$.dirty[1]&&n(32,s=(r-l-o.top-o.bottom)/2),1073741824&t.$$.dirty[0]|3&t.$$.dirty[1]&&n(10,c={top:o.top+s,right:o.right+a,bottom:o.bottom+s,left:o.left+a}),1&t.$$.dirty[0]|32&t.$$.dirty[1]&&n(12,u=S[T.x_feature]),1&t.$$.dirty[0]|32&t.$$.dirty[1]&&n(11,h=S[T.y_feature]),1&t.$$.dirty[0]|8&t.$$.dirty[1]&&n(28,d=L.copy().domain([T.pdp_min,T.pdp_max])),1&t.$$.dirty[0]|16&t.$$.dirty[1]&&n(29,f=A.copy().domain([T.interaction_min,0,T.interaction_max])),805404672&t.$$.dirty[0]|24&t.$$.dirty[1]&&n(6,g="interactions"===D?E?f:A:E?d:L),1&t.$$.dirty[0]&&n(25,m=Math.min(...Bs(T.x_axis,((t,e)=>e-t)))),1&t.$$.dirty[0]&&n(22,v=Math.min(...Bs(T.y_axis,((t,e)=>e-t)))),33554433&t.$$.dirty[0]&&n(24,y=T.x_axis[0]-m/2),33554433&t.$$.dirty[0]&&n(27,b=T.x_axis[T.x_axis.length-1]+m/2),4194305&t.$$.dirty[0]&&n(23,w=T.y_axis[0]-v/2),4194305&t.$$.dirty[0]&&n(26,$=T.y_axis[T.y_axis.length-1]+v/2),151000067&t.$$.dirty[0]&&n(8,x="quantitative"===u.kind?tn().domain([y,b]).range([c.left,C-c.right]):si().domain(T.x_axis).range([c.left,C-c.right])),75501057&t.$$.dirty[0]&&n(7,_="quantitative"===h.kind?tn().domain([w,$]).range([r-c.bottom,c.top]):si().domain(T.y_axis).range([r-c.bottom,c.top])),50331904&t.$$.dirty[0]&&n(21,k="bandwidth"in x?x.bandwidth()-2:x(y+m)-x(y)),12583040&t.$$.dirty[0]&&n(20,M="bandwidth"in _?_.bandwidth()-2:_(w)-_(w+v)),524834&t.$$.dirty[0]&&z&&(xn(N,z,C,r),z&&null!=x&&null!=_&&Ss(T,z,C,r,x,_,g,D,k,M)),3736515&t.$$.dirty[0]&&z&&null!=x&&null!=_&&Ss(T,z,C,r,x,_,g,D,k,M)},[T,C,O,B,R,N,g,_,x,r,c,h,u,i,q,E,D,j,P,z,M,k,v,w,y,m,$,b,d,f,a,o,s,l,L,A,S,function(t){V[t?"unshift":"push"]((()=>{N=t,n(5,N)}))}]}const Ks=class extends gt{constructor(t){super(),pt(this,t,Ys,Xs,h,{pd:0,width:1,height:14,scaleLocally:15,showMarginalDistribution:2,colorShows:16,showColorLegend:3,marginTop:17,marginRight:18,distributionHeight:4},Ps,[-1,-1])}};function Us(t){let e,n,i,r;const o=[Zs,Gs],l=[];function a(t,e){return 1===t[0].num_features?0:2===t[0].num_features?1:-1}return~(e=a(t))&&(n=l[e]=o[e](t)),{c(){n&&n.c(),i=S()},m(t,n){~e&&l[e].m(t,n),$(t,i,n),r=!0},p(t,r){let s=e;e=a(t),e===s?~e&&l[e].p(t,r):(n&&(it(),lt(l[s],1,1,(()=>{l[s]=null})),rt()),~e?(n=l[e],n?n.p(t,r):(n=l[e]=o[e](t),n.c()),ot(n,1),n.m(i.parentNode,i)):n=null)},i(t){r||(ot(n),r=!0)},o(t){lt(n),r=!1},d(t){~e&&l[e].d(t),t&&x(i)}}}function Gs(t){let e,n;return e=new Ks({props:{width:t[1],height:t[2],pd:t[0],scaleLocally:t[3],colorShows:t[4],showColorLegend:t[5],marginTop:t[9],marginRight:t[10],distributionHeight:t[11],showMarginalDistribution:t[8]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};2&n&&(i.width=t[1]),4&n&&(i.height=t[2]),1&n&&(i.pd=t[0]),8&n&&(i.scaleLocally=t[3]),16&n&&(i.colorShows=t[4]),32&n&&(i.showColorLegend=t[5]),512&n&&(i.marginTop=t[9]),1024&n&&(i.marginRight=t[10]),2048&n&&(i.distributionHeight=t[11]),256&n&&(i.showMarginalDistribution=t[8]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Zs(t){let e,n;return e=new As({props:{width:t[1],height:t[2],pd:t[0],scaleLocally:t[3],iceLevel:t[6],showMarginalDistribution:t[8],marginTop:t[9],distributionHeight:t[11],indices:t[7],allowBrushing:t[12],iceLineWidth:t[13]}}),{c(){ht(e.$$.fragment)},m(t,i){dt(e,t,i),n=!0},p(t,n){const i={};2&n&&(i.width=t[1]),4&n&&(i.height=t[2]),1&n&&(i.pd=t[0]),8&n&&(i.scaleLocally=t[3]),64&n&&(i.iceLevel=t[6]),256&n&&(i.showMarginalDistribution=t[8]),512&n&&(i.marginTop=t[9]),2048&n&&(i.distributionHeight=t[11]),128&n&&(i.indices=t[7]),4096&n&&(i.allowBrushing=t[12]),8192&n&&(i.iceLineWidth=t[13]),e.$set(i)},i(t){n||(ot(e.$$.fragment,t),n=!0)},o(t){lt(e.$$.fragment,t),n=!1},d(t){ft(e,t)}}}function Js(t){let e,n,i=t[1]>0&&t[2]>0&&Us(t);return{c(){i&&i.c(),e=S()},m(t,r){i&&i.m(t,r),$(t,e,r),n=!0},p(t,[n]){t[1]>0&&t[2]>0?i?(i.p(t,n),6&n&&ot(i,1)):(i=Us(t),i.c(),ot(i,1),i.m(e.parentNode,e)):i&&(it(),lt(i,1,1,(()=>{i=null})),rt())},i(t){n||(ot(i),n=!0)},o(t){lt(i),n=!1},d(t){i&&i.d(t),t&&x(e)}}}function Qs(t,e,n){let{pd:i}=e,{width:r}=e,{height:o}=e,{scaleLocally:l}=e,{colorShows:a="predictions"}=e,{showColorLegend:s=!1}=e,{iceLevel:c}=e,{indices:u=null}=e,{showMarginalDistribution:h=!1}=e,{marginTop:d=0}=e,{marginRight:f=0}=e,{distributionHeight:p=0}=e,{allowBrushing:g=!1}=e,{iceLineWidth:m=1}=e;return t.$$set=t=>{"pd"in t&&n(0,i=t.pd),"width"in t&&n(1,r=t.width),"height"in t&&n(2,o=t.height),"scaleLocally"in t&&n(3,l=t.scaleLocally),"colorShows"in t&&n(4,a=t.colorShows),"showColorLegend"in t&&n(5,s=t.showColorLegend),"iceLevel"in t&&n(6,c=t.iceLevel),"indices"in t&&n(7,u=t.indices),"showMarginalDistribution"in t&&n(8,h=t.showMarginalDistribution),"marginTop"in t&&n(9,d=t.marginTop),"marginRight"in t&&n(10,f=t.marginRight),"distributionHeight"in t&&n(11,p=t.distributionHeight),"allowBrushing"in t&&n(12,g=t.allowBrushing),"iceLineWidth"in t&&n(13,m=t.iceLineWidth)},[i,r,o,l,a,s,c,u,h,d,f,p,g,m]}const tc=class extends gt{constructor(t){super(),pt(this,t,Qs,Js,h,{pd:0,width:1,height:2,scaleLocally:3,colorShows:4,showColorLegend:5,iceLevel:6,indices:7,showMarginalDistribution:8,marginTop:9,marginRight:10,distributionHeight:11,allowBrushing:12,iceLineWidth:13})}};function ec(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n<e||void 0===n&&e>=e)&&(n=e);else{let i=-1;for(let r of t)null!=(r=e(r,++i,t))&&(n<r||void 0===n&&r>=r)&&(n=r)}return n}function nc(t,e,n=we){if(i=t.length){if((e=+e)<=0||i<2)return+n(t[0],0,t);if(e>=1)return+n(t[i-1],i-1,t);var i,r=(i-1)*e,o=Math.floor(r),l=+n(t[o],o,t);return l+(+n(t[o+1],o+1,t)-l)*(r-o)}}function ic(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n>e||void 0===n&&e>=e)&&(n=e);else{let i=-1;for(let r of t)null!=(r=e(r,++i,t))&&(n>r||void 0===n&&r>=r)&&(n=r)}return n}function rc(t,e){if((r=t.length)>1)for(var n,i,r,o=1,l=t[e[0]],a=l.length;o<r;++o)for(i=l,l=t[e[o]],n=0;n<a;++n)l[n][1]+=l[n][0]=isNaN(i[n][1])?i[n][0]:i[n][1]}function oc(t){for(var e=t.length,n=new Array(e);--e>=0;)n[e]=e;return n}function lc(t,e){return t[e]}function ac(t){const e=[];return e.key=t,e}function sc(t,e){if((i=t.length)>0){for(var n,i,r,o=0,l=t[0].length;o<l;++o){for(r=n=0;n<i;++n)r+=t[n][o][1]||0;if(r)for(n=0;n<i;++n)t[n][o][1]/=r}rc(t,e)}}function cc(t){return oc(t).reverse()}function uc(t,e){var n,i,r=function(t){if(0===t.length)throw new Error("mean requires at least one data point");return function(t){if(0===t.length)return 0;var e,n=t[0],i=0;if("number"!=typeof n)return NaN;for(var r=1;r<t.length;r++){if("number"!=typeof t[r])return NaN;e=n+t[r],Math.abs(n)>=Math.abs(t[r])?i+=n-e+t[r]:i+=t[r]-e+n,n=e}return n+i}(t)/t.length}(t),o=0;if(2===e)for(i=0;i<t.length;i++)o+=(n=t[i]-r)*n;else for(i=0;i<t.length;i++)o+=Math.pow(t[i]-r,e);return o}function hc(t,e){var n=t.length*e;if(0===t.length)throw new Error("quantile requires at least one data point.");if(e<0||e>1)throw new Error("quantiles must be between 0 and 1");return 1===e?t[t.length-1]:0===e?t[0]:n%1!=0?t[Math.ceil(n)-1]:t.length%2==0?(t[n-1]+t[n])/2:t[n]}function dc(t,e,n,i){for(n=n||0,i=i||t.length-1;i>n;){if(i-n>600){var r=i-n+1,o=e-n+1,l=Math.log(r),a=.5*Math.exp(2*l/3),s=.5*Math.sqrt(l*a*(r-a)/r);o-r/2<0&&(s*=-1),dc(t,e,Math.max(n,Math.floor(e-o*a/r+s)),Math.min(i,Math.floor(e+(r-o)*a/r+s)))}var c=t[e],u=n,h=i;for(fc(t,n,e),t[i]>c&&fc(t,n,i);u<h;){for(fc(t,u,h),u++,h--;t[u]<c;)u++;for(;t[h]>c;)h--}t[n]===c?fc(t,n,h):fc(t,++h,i),h<=e&&(n=h+1),e<=h&&(i=h-1)}}function fc(t,e,n){var i=t[e];t[e]=t[n],t[n]=i}function pc(t,e){var n=t.slice();if(Array.isArray(e)){!function(t,e){for(var n=[0],i=0;i<e.length;i++)n.push(vc(t.length,e[i]));n.push(t.length-1),n.sort(mc);for(var r=[0,n.length-1];r.length;){var o=Math.ceil(r.pop()),l=Math.floor(r.pop());if(!(o-l<=1)){var a=Math.floor((l+o)/2);gc(t,n[a],Math.floor(n[l]),Math.ceil(n[o])),r.push(l,a,a,o)}}}(n,e);for(var i=[],r=0;r<e.length;r++)i[r]=hc(n,e[r]);return i}return gc(n,vc(n.length,e),0,n.length-1),hc(n,e)}function gc(t,e,n,i){e%1==0?dc(t,e,n,i):(dc(t,e=Math.floor(e),n,i),dc(t,e+1,e+1,i))}function mc(t,e){return t-e}function vc(t,e){var n=t*e;return 1===e?t-1:0===e?0:n%1!=0?Math.ceil(n)-1:t%2==0?n-.5:n}function yc(t){var e=function(t){if(t.length<2)throw new Error("sampleVariance requires at least two data points");return uc(t,2)/(t.length-1)}(t);return Math.sqrt(e)}var bc=function(){this.totalCount=0,this.data={}};bc.prototype.train=function(t,e){for(var n in this.data[e]||(this.data[e]={}),t){var i=t[n];void 0===this.data[e][n]&&(this.data[e][n]={}),void 0===this.data[e][n][i]&&(this.data[e][n][i]=0),this.data[e][n][i]++}this.totalCount++},bc.prototype.score=function(t){var e,n={};for(var i in t){var r=t[i];for(e in this.data)n[e]={},this.data[e][i]?n[e][i+"_"+r]=(this.data[e][i][r]||0)/this.totalCount:n[e][i+"_"+r]=0}var o={};for(e in n)for(var l in o[e]=0,n[e])o[e]+=n[e][l];return o};var wc=function(){this.weights=[],this.bias=0};wc.prototype.predict=function(t){if(t.length!==this.weights.length)return null;for(var e=0,n=0;n<this.weights.length;n++)e+=this.weights[n]*t[n];return(e+=this.bias)>0?1:0},wc.prototype.train=function(t,e){if(0!==e&&1!==e)return null;t.length!==this.weights.length&&(this.weights=t,this.bias=1);var n=this.predict(t);if("number"==typeof n&&n!==e){for(var i=e-n,r=0;r<this.weights.length;r++)this.weights[r]+=i*t[r];this.bias+=i}return this},Math.log(Math.sqrt(2*Math.PI));var $c=Math.sqrt(2*Math.PI),xc={gaussian:function(t){return Math.exp(-.5*t*t)/$c}},_c={nrd:function(t){var e=yc(t),n=function(t){var e=pc(t,.75),n=pc(t,.25);if("number"==typeof e&&"number"==typeof n)return e-n}(t);return"number"==typeof n&&(e=Math.min(e,n/1.34)),1.06*e*Math.pow(t.length,-.2)}},kc=Math.sqrt(2*Math.PI);function Mc(t){for(var e=t,n=t,i=1;i<15;i++)e+=n*=t*t/(2*i+1);return Math.round(1e4*(.5+e/kc*Math.exp(-t*t/2)))/1e4}for(var Lc=[],Ac=0;Ac<=3.09;Ac+=.01)Lc.push(Mc(Ac));function Sc(t){w(t,"svelte-xk351a",".label-and-input.svelte-xk351a{display:flex;align-items:center;gap:0.25em}.controls-container.svelte-xk351a{display:flex;align-items:center;gap:1em}")}function Nc(t,e,n){const i=t.slice();return i[32]=e[n],i}function zc(t,e,n){const i=t.slice();return i[41]=e[n].cluster,i[42]=e[n].box,i}function Tc(t,e,n){const i=t.slice();return i[35]=e[n],i[37]=n,i}function Cc(t,e,n){const i=t.slice();return i[38]=e[n],i}function qc(t){let e,n,i,r,o;return{c(){e=k("label"),n=k("input"),i=L("Normalize bar charts"),z(n,"type","checkbox"),z(e,"class","label-and-input svelte-xk351a")},m(l,a){$(l,e,a),b(e,n),n.checked=t[1],b(e,i),r||(o=N(n,"change",t[26]),r=!0)},p(t,e){2&e[0]&&(n.checked=t[1])},d(t){t&&x(e),r=!1,o()}}}function Ec(t){let e,n=t[32].data,i=[];for(let e=0;e<n.length;e+=1)i[e]=Dc(zc(t,n,e));return{c(){e=M("g");for(let t=0;t<i.length;t+=1)i[t].c()},m(t,n){$(t,e,n);for(let t=0;t<i.length;t+=1)i[t].m(e,null)},p(t,r){if(38084&r[0]){let o;for(n=t[32].data,o=0;o<n.length;o+=1){const l=zc(t,n,o);i[o]?i[o].p(l,r):(i[o]=Dc(l),i[o].c(),i[o].m(e,null))}for(;o<i.length;o+=1)i[o].d(1);i.length=n.length}},i:l,o:l,d(t){t&&x(e),_(i,t)}}}function Oc(t){let e,n,i,r=t[32].data,o=[];for(let e=0;e<r.length;e+=1)o[e]=Pc(Tc(t,r,e));return n=new or({props:{scale:t[11],x:t[14].left,label:t[1]?"percent":"count",format:t[1]?Ue("~%"):_n}}),{c(){e=M("g");for(let t=0;t<o.length;t+=1)o[t].c();ht(n.$$.fragment)},m(t,r){$(t,e,r);for(let t=0;t<o.length;t+=1)o[t].m(e,null);dt(n,t,r),i=!0},p(t,i){if(6212&i[0]){let n;for(r=t[32].data,n=0;n<r.length;n+=1){const l=Tc(t,r,n);o[n]?o[n].p(l,i):(o[n]=Pc(l),o[n].c(),o[n].m(e,null))}for(;n<o.length;n+=1)o[n].d(1);o.length=r.length}const l={};2048&i[0]&&(l.scale=t[11]),2&i[0]&&(l.label=t[1]?"percent":"count"),2&i[0]&&(l.format=t[1]?Ue("~%"):_n),n.$set(l)},i(t){i||(ot(n.$$.fragment,t),i=!0)},o(t){lt(n.$$.fragment,t),i=!1},d(t){t&&x(e),_(o,t),ft(n,t)}}}function Dc(t){let e,n,i,r,o,l,a,s,c,u,h,d,f,p,g,m,v,y,w,_,k,L,A,S;return{c(){e=M("g"),n=M("path"),o=M("rect"),c=M("line"),m=M("line"),_=M("line"),z(n,"d",i=t[15](t[6][t[32].feature],t[42].densities)),z(n,"fill",r=t[12](t[41])),z(o,"x",l=t[6][t[32].feature](t[42].q1)??0),z(o,"width",a=(t[6][t[32].feature](t[42].q3)??0)-(t[6][t[32].feature](t[42].q1)??0)),z(o,"y",s=-t[10]/2),z(o,"height",t[10]),z(o,"fill","var(--gray-1)"),z(c,"x1",u=t[6][t[32].feature](t[42].median)??0),z(c,"x2",h=t[6][t[32].feature](t[42].median)??0),z(c,"stroke-width",d=2),z(c,"y1",f=-t[10]/2),z(c,"y2",p=t[10]/2),z(c,"stroke",g="black"),z(m,"x1",v=t[6][t[32].feature](t[42].low)??0),z(m,"x2",y=t[6][t[32].feature](t[42].q1)??0),z(m,"stroke-width",w=1),z(m,"stroke","var(--gray-1)"),z(_,"x1",k=t[6][t[32].feature](t[42].q3)??0),z(_,"x2",L=t[6][t[32].feature](t[42].high)??0),z(_,"stroke-width",A=1),z(_,"stroke","var(--gray-1)"),z(e,"transform",S="translate(0,"+((t[7](t[41])??0)+t[7].bandwidth()/2)+")")},m(t,i){$(t,e,i),b(e,n),b(e,o),b(e,c),b(e,m),b(e,_)},p(t,d){68&d[0]&&i!==(i=t[15](t[6][t[32].feature],t[42].densities))&&z(n,"d",i),4100&d[0]&&r!==(r=t[12](t[41]))&&z(n,"fill",r),68&d[0]&&l!==(l=t[6][t[32].feature](t[42].q1)??0)&&z(o,"x",l),68&d[0]&&a!==(a=(t[6][t[32].feature](t[42].q3)??0)-(t[6][t[32].feature](t[42].q1)??0))&&z(o,"width",a),1024&d[0]&&s!==(s=-t[10]/2)&&z(o,"y",s),1024&d[0]&&z(o,"height",t[10]),68&d[0]&&u!==(u=t[6][t[32].feature](t[42].median)??0)&&z(c,"x1",u),68&d[0]&&h!==(h=t[6][t[32].feature](t[42].median)??0)&&z(c,"x2",h),1024&d[0]&&f!==(f=-t[10]/2)&&z(c,"y1",f),1024&d[0]&&p!==(p=t[10]/2)&&z(c,"y2",p),68&d[0]&&v!==(v=t[6][t[32].feature](t[42].low)??0)&&z(m,"x1",v),68&d[0]&&y!==(y=t[6][t[32].feature](t[42].q1)??0)&&z(m,"x2",y),68&d[0]&&k!==(k=t[6][t[32].feature](t[42].q3)??0)&&z(_,"x1",k),68&d[0]&&L!==(L=t[6][t[32].feature](t[42].high)??0)&&z(_,"x2",L),132&d[0]&&S!==(S="translate(0,"+((t[7](t[41])??0)+t[7].bandwidth()/2)+")")&&z(e,"transform",S)},d(t){t&&x(e)}}}function Bc(t){let e,n,i,r,o;return{c(){e=M("rect"),z(e,"x",n=Xc(t[38].data[0],t[6][t[32].feature])+1),z(e,"width",i=Fc(t[6][t[32].feature])-2),z(e,"y",r=t[11](t[38][1])),z(e,"height",o=t[11](t[38][0])-t[11](t[38][1]))},m(t,n){$(t,e,n)},p(t,l){68&l[0]&&n!==(n=Xc(t[38].data[0],t[6][t[32].feature])+1)&&z(e,"x",n),68&l[0]&&i!==(i=Fc(t[6][t[32].feature])-2)&&z(e,"width",i),2052&l[0]&&r!==(r=t[11](t[38][1]))&&z(e,"y",r),2052&l[0]&&o!==(o=t[11](t[38][0])-t[11](t[38][1]))&&z(e,"height",o)},d(t){t&&x(e)}}}function jc(t){let e,n=t[38][0]!==t[38][1]&&Bc(t);return{c(){n&&n.c(),e=S()},m(t,i){n&&n.m(t,i),$(t,e,i)},p(t,i){t[38][0]!==t[38][1]?n?n.p(t,i):(n=Bc(t),n.c(),n.m(e.parentNode,e)):n&&(n.d(1),n=null)},d(t){n&&n.d(t),t&&x(e)}}}function Pc(t){let e,n,i=t[35],r=[];for(let e=0;e<i.length;e+=1)r[e]=jc(Cc(t,i,e));return{c(){e=M("g");for(let t=0;t<r.length;t+=1)r[t].c();z(e,"fill",n=t[12](t[37]))},m(t,n){$(t,e,n);for(let t=0;t<r.length;t+=1)r[t].m(e,null)},p(t,o){if(2116&o[0]){let n;for(i=t[35],n=0;n<i.length;n+=1){const l=Cc(t,i,n);r[n]?r[n].p(l,o):(r[n]=jc(l),r[n].c(),r[n].m(e,null))}for(;n<r.length;n+=1)r[n].d(1);r.length=i.length}4096&o[0]&&n!==(n=t[12](t[37]))&&z(e,"fill",n)},d(t){t&&x(e),_(r,t)}}}function Hc(t){let e,n,i,r,o,l,a,s;const c=[Oc,Ec],u=[];function h(t,e){return"categorical"===t[32].kind?0:1}return n=h(t),i=u[n]=c[n](t),o=new Vi({props:{scale:t[6][t[32].feature],y:t[4].bandwidth()-t[14].bottom,showBaseline:!0,baselineColor:"var(--gray-6)",tickColor:"var(--gray-6)",integerOnly:"discrete"===t[9][t[32].feature].subkind,value_map:Wc(t[9][t[32].feature]),label:t[32].feature}}),{c(){e=M("g"),i.c(),r=M("g"),ht(o.$$.fragment),z(r,"class","x-axis"),z(r,"id",l="axis-"+t[32].feature),z(e,"transform",a="translate(0,"+t[4](t[32].feature)+")")},m(t,i){$(t,e,i),u[n].m(e,null),b(e,r),dt(o,r,null),s=!0},p(t,d){let f=n;n=h(t),n===f?u[n].p(t,d):(it(),lt(u[f],1,1,(()=>{u[f]=null})),rt(),i=u[n],i?i.p(t,d):(i=u[n]=c[n](t),i.c()),ot(i,1),i.m(e,r));const p={};68&d[0]&&(p.scale=t[6][t[32].feature]),16&d[0]&&(p.y=t[4].bandwidth()-t[14].bottom),516&d[0]&&(p.integerOnly="discrete"===t[9][t[32].feature].subkind),516&d[0]&&(p.value_map=Wc(t[9][t[32].feature])),4&d[0]&&(p.label=t[32].feature),o.$set(p),(!s||4&d[0]&&l!==(l="axis-"+t[32].feature))&&z(r,"id",l),(!s||20&d[0]&&a!==(a="translate(0,"+t[4](t[32].feature)+")"))&&z(e,"transform",a)},i(t){s||(ot(i),ot(o.$$.fragment,t),s=!0)},o(t){lt(i),lt(o.$$.fragment,t),s=!1},d(t){t&&x(e),u[n].d(),ft(o)}}}function Rc(t){let e,n,i,r,o,l,a,s,c,u,h,d,f=t[5].length+"",p=1===t[5].length?"instance":"instances",g=`${Ic}px`,m=t[13].length>0&&qc(t),v=t[2],y=[];for(let e=0;e<v.length;e+=1)y[e]=Hc(Nc(t,v,e));const w=t=>lt(y[t],1,1,(()=>{y[t]=null}));return{c(){e=k("div"),n=k("div"),m&&m.c(),i=A(),r=k("div"),o=L(f),l=A(),a=L(p),s=L(" selected"),c=A(),u=M("svg"),h=M("g");for(let t=0;t<y.length;t+=1)y[t].c();z(n,"class","controls-container svelte-xk351a"),E(n,"height",g),z(u,"width",t[0]),z(u,"height",t[8])},m(f,p){$(f,e,p),b(e,n),m&&m.m(n,null),b(n,i),b(n,r),b(r,o),b(r,l),b(r,a),b(r,s),b(e,c),b(e,u),b(u,h);for(let t=0;t<y.length;t+=1)y[t].m(h,null);t[27](h),d=!0},p(t,e){if(t[13].length>0?m?m.p(t,e):(m=qc(t),m.c(),m.m(n,i)):m&&(m.d(1),m=null),(!d||32&e[0])&&f!==(f=t[5].length+"")&&C(o,f),(!d||32&e[0])&&p!==(p=1===t[5].length?"instance":"instances")&&C(a,p),57046&e[0]){let n;for(v=t[2],n=0;n<v.length;n+=1){const i=Nc(t,v,n);y[n]?(y[n].p(i,e),ot(y[n],1)):(y[n]=Hc(i),y[n].c(),ot(y[n],1),y[n].m(h,null))}for(it(),n=v.length;n<y.length;n+=1)w(n);rt()}(!d||1&e[0])&&z(u,"width",t[0]),(!d||256&e[0])&&z(u,"height",t[8])},i(t){if(!d){for(let t=0;t<v.length;t+=1)ot(y[t]);d=!0}},o(t){y=y.filter(Boolean);for(let t=0;t<y.length;t+=1)lt(y[t]);d=!1},d(n){n&&x(e),m&&m.d(),_(y,n),t[27](null)}}}const Ic=20;function Vc(t){return"categorical"===t.kind}function Wc(t){return"value_map"in t?t.value_map:{}}function Fc(t){return t&&"bandwidth"in t?t.bandwidth():0}function Xc(t,e){var n;return e&&null!==(n=e(t))&&void 0!==n?n:0}function Yc(t,e,n){let i,r,o,l,a,s,c,u,h,d,f,g,m,v,y,b,w;p(t,Cn,(t=>n(24,y=t))),p(t,Tn,(t=>n(9,b=t))),p(t,qn,(t=>n(25,w=t)));let{pd:$}=e,{width:x}=e,{height:_}=e,{features:k}=e;const M={top:10,right:5,bottom:40,left:50};let L=!1,A=[];const S=new Map,N=R();function z({selection:t}){const e=this.id.split("-",2)[1];if(null===t)S.delete(e);else{const[n,i]=t,r=h[e];if("bandwidth"in r){const t=r.domain().filter((t=>{var e;const o=null!==(e=r(t))&&void 0!==e?e:0,l=o+r.bandwidth();return n<=l&&i>=o}));S.set(e,{kind:"categorical",categories:t})}else{const t=r.invert(n),o=r.invert(i);S.set(e,{kind:"quantitative",left:t,right:o})}}n(5,c=s.filter((t=>Array.from(S).every((([e,n])=>{const i=b[e];if("quantitative"===n.kind&&"quantitative"===i.kind){const i=y[e][t];return i>=n.left&&i<=n.right}if("categorical"===n.kind&&"categorical"===i.kind){const i=y[e][t];return n.categories.includes(i)}return!1}))))),N("filter",c)}let T,C;return t.$$set=t=>{"pd"in t&&n(16,$=t.pd),"width"in t&&n(0,x=t.width),"height"in t&&n(17,_=t.height),"features"in t&&n(18,k=t.features)},t.$$.update=()=>{131072&t.$$.dirty[0]&&n(8,i=_-Ic),65536&t.$$.dirty[0]&&n(21,r=wn($.ice.clusters.length)),262656&t.$$.dirty[0]&&n(13,o=k.filter((t=>"categorical"===b[t].kind))),2097152&t.$$.dirty[0]&&n(12,l=ai().domain(r).range(An)),262400&t.$$.dirty[0]&&n(4,a=si().domain(k).range([0,i])),33554432&t.$$.dirty[0]&&(s=wn(w)),33554432&t.$$.dirty[0]&&n(5,c=wn(w)),2097154&t.$$.dirty[0]&&n(23,u=function(){var t=bi([]),e=oc,n=rc,i=lc;function r(r){var o,l,a=Array.from(t.apply(this,arguments),ac),s=a.length,c=-1;for(const t of r)for(o=0,++c;o<s;++o)(a[o][c]=[0,+i(t,a[o].key,c,r)]).data=t;for(o=0,l=yi(e(a));o<s;++o)a[l[o]].index=o;return n(a,l),a}return r.keys=function(e){return arguments.length?(t="function"==typeof e?e:bi(Array.from(e)),r):t},r.value=function(t){return arguments.length?(i="function"==typeof t?t:bi(+t),r):i},r.order=function(t){return arguments.length?(e=null==t?oc:"function"==typeof t?t:bi(Array.from(t)),r):e},r.offset=function(t){return arguments.length?(n=null==t?rc:t,r):n},r}().keys(r).value(((t,e)=>{var n;return null!==(n=t[1].get(e))&&void 0!==n?n:0})).offset(L?sc:rc).order(cc)),262657&t.$$.dirty[0]&&n(6,h=Object.fromEntries(k.map((t=>{const e=b[t];return[t,"quantitative"===e.kind?tn().domain([e.values[0],e.values[e.values.length-1]]).range([M.left,x-M.right]):si().domain(e.values).range([M.left,x-M.right])]})))),25494048&t.$$.dirty[0]&&n(2,A=k.map((t=>{if("categorical"===b[t].kind){const e=bn(c,(t=>t.length),(e=>y[t][e]),(t=>$.ice.cluster_labels[t]));return{feature:t,kind:"categorical",data:u(Array.from(e))}}{const e=bn(c,(e=>{var n,i,r,o,l;const a=e.map((e=>y[t][e])).sort(me);let s=[];if(a.length>1){const t=function(t,e,n){var i,r;return i=xc.gaussian,r=_c.nrd(t),function(e){var n=0,o=0;for(n=0;n<t.length;n++)o+=i((e-t[n])/r);return o/r/t.length}}(a),e=Be(a[0],a[a.length-1],20);e[0]!==a[0]&&e.unshift(a[0]),e[e.length-1]!==a[a.length-1]&&e.push(a[a.length-1]),s=e.map((e=>({x:e,density:t(e)})))}const c=null!==(n=nc(a,.5))&&void 0!==n?n:0,u=null!==(i=nc(a,.25))&&void 0!==i?i:0,h=null!==(r=nc(a,.75))&&void 0!==r?r:0,d=h-u,f=u-1.5*d,p=h+1.5*d;return{low:null!==(o=ic(a,(t=>t>=f?t:Number.POSITIVE_INFINITY)))&&void 0!==o?o:0,q1:u,median:c,q3:h,high:null!==(l=ec(a,(t=>t<=p?t:Number.NEGATIVE_INFINITY)))&&void 0!==l?l:0,densities:s}}),(t=>$.ice.cluster_labels[t]));return{feature:t,kind:"quantitative",data:Array.from(e,(([t,e])=>({cluster:t,box:e})))}}}))),4&t.$$.dirty[0]&&n(22,d=Math.max(...A.filter(Vc).map((t=>t.data)).flat(3))),4194322&t.$$.dirty[0]&&n(11,f=tn().domain([0,L?1:d]).range([a.bandwidth()-M.bottom,M.top])),2097168&t.$$.dirty[0]&&n(7,g=si().domain(r).range([M.top,a.bandwidth()-M.bottom]).padding(.05)),128&t.$$.dirty[0]&&n(10,m=Math.min(5,g.bandwidth()/2)),17&t.$$.dirty[0]&&n(20,v=cs().extent([[M.left,-10+a.bandwidth()-M.bottom],[x-M.right,10+a.bandwidth()-M.bottom]]).on("start brush end",z)),1572872&t.$$.dirty[0]&&T&&(n(19,C=fl(T).selectAll(".x-axis")),C.call(v))},[x,L,A,T,a,c,h,g,i,b,m,f,l,o,M,function(t,e){var n;const i=tn().domain([0,null!==(n=ec(e,(t=>t.density)))&&void 0!==n?n:0]).range([0,g.bandwidth()/2]),r=function(t,e,n){var i=null,r=bi(!0),o=null,l=$i,a=null;function s(s){var c,u,h,d,f,p=(s=yi(s)).length,g=!1,m=new Array(p),v=new Array(p);for(null==o&&(a=l(f=vi())),c=0;c<=p;++c){if(!(c<p&&r(d=s[c],c,s))===g)if(g=!g)u=c,a.areaStart(),a.lineStart();else{for(a.lineEnd(),a.lineStart(),h=c-1;h>=u;--h)a.point(m[h],v[h]);a.lineEnd(),a.areaEnd()}g&&(m[c]=+t(d,c,s),v[c]=+e(d,c,s),a.point(i?+i(d,c,s):m[c],n?+n(d,c,s):v[c]))}if(f)return a=null,f+""||null}function c(){return ki().defined(r).curve(l).context(o)}return t="function"==typeof t?t:void 0===t?xi:bi(+t),e="function"==typeof e?e:bi(void 0===e?0:+e),n="function"==typeof n?n:void 0===n?_i:bi(+n),s.x=function(e){return arguments.length?(t="function"==typeof e?e:bi(+e),i=null,s):t},s.x0=function(e){return arguments.length?(t="function"==typeof e?e:bi(+e),s):t},s.x1=function(t){return arguments.length?(i=null==t?null:"function"==typeof t?t:bi(+t),s):i},s.y=function(t){return arguments.length?(e="function"==typeof t?t:bi(+t),n=null,s):e},s.y0=function(t){return arguments.length?(e="function"==typeof t?t:bi(+t),s):e},s.y1=function(t){return arguments.length?(n=null==t?null:"function"==typeof t?t:bi(+t),s):n},s.lineX0=s.lineY0=function(){return c().x(t).y(e)},s.lineY1=function(){return c().x(t).y(n)},s.lineX1=function(){return c().x(i).y(e)},s.defined=function(t){return arguments.length?(r="function"==typeof t?t:bi(!!t),s):r},s.curve=function(t){return arguments.length?(l=t,null!=o&&(a=l(o)),s):l},s.context=function(t){return arguments.length?(null==t?o=a=null:a=l(o=t),s):o},s}().x((e=>{var n;return null!==(n=t(e.x))&&void 0!==n?n:0})).y0((t=>-i(t.density))).y1((t=>i(t.density)));return r(e)},$,_,k,C,v,r,d,u,y,w,function(){L=this.checked,n(1,L)},function(t){V[t?"unshift":"push"]((()=>{T=t,n(3,T)}))}]}const Kc=class extends gt{constructor(t){super(),pt(this,t,Yc,Rc,h,{pd:16,width:0,height:17,features:18},Sc,[-1,-1])}};function Uc(t){w(t,"svelte-d2a28i",".zoomed-pdp-container.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{width:100%;height:100%;display:flex;flex-direction:column}.zoomed-pdp-header.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{height:2em;display:flex;align-items:center;background-color:white;gap:1.5em;padding-left:0.5em;padding-right:0.5em;border-bottom:1px solid var(--gray-1)}.feature-selects.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{flex:0 1 auto;min-width:0;display:flex;align-items:center;gap:0.5em}.feature-selects.svelte-d2a28i label.svelte-d2a28i.svelte-d2a28i{flex:0 1 auto;display:flex;align-items:center;gap:0.25em;min-width:0}.feature-selects.svelte-d2a28i label span.svelte-d2a28i.svelte-d2a28i{flex:0 0 auto}.feature-selects.svelte-d2a28i label.svelte-d2a28i select.svelte-d2a28i{flex:0 1 auto;min-width:0;text-overflow:ellipsis}.zoomed-pdp-content.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{flex:1;padding:0.5em}.one-way-pdp-grid.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{display:flex;width:100%;height:100%}.two-way-pdp-grid.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{display:grid;width:100%;height:100%}.label-and-input.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{flex:0 0 auto;display:flex;align-items:center;gap:0.25em}.showOneWay-true-color-both.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{grid-template-rows:1fr 2fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-interaction two-way-pdp'}.showOneWay-true-color-interactions.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{grid-template-rows:1fr 2fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-interaction two-way-interaction'}.showOneWay-true-color-predictions.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{grid-template-rows:1fr 2fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-pdp two-way-pdp'}.showOneWay-false-color-both.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-interaction two-way-pdp'\n      'two-way-interaction two-way-pdp'}.showOneWay-false-color-interactions.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-interaction two-way-interaction'\n      'two-way-interaction two-way-interaction'}.showOneWay-false-color-predictions.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-pdp two-way-pdp'\n      'two-way-pdp two-way-pdp'}.detailed-plot-message-container.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{height:100%;width:100%;align-items:center;justify-content:center;display:flex}.detailed-plot-message-content.svelte-d2a28i.svelte-d2a28i.svelte-d2a28i{width:40em;display:flex;flex-direction:column;justify-content:center;gap:1em}.detailed-plot-message-content.svelte-d2a28i>button.svelte-d2a28i.svelte-d2a28i{margin:auto}")}function Gc(t,e,n){const i=t.slice();return i[38]=e[n].value,i[39]=e[n].title,i}function Zc(t,e,n){const i=t.slice();return i[42]=e[n],i}function Jc(t,e,n){const i=t.slice();return i[42]=e[n],i}function Qc(t){let e,n,i,r=t[42]+"";return{c(){e=k("option"),n=L(r),e.__value=i=t[42],e.value=e.__value},m(t,i){$(t,e,i),b(e,n)},p(t,o){524288&o[0]&&r!==(r=t[42]+"")&&C(n,r),524288&o[0]&&i!==(i=t[42])&&(e.__value=i,e.value=e.__value)},d(t){t&&x(e)}}}function tu(t){let e,n,i,r=t[42]+"";return{c(){e=k("option"),n=L(r),e.__value=i=t[42],e.value=e.__value},m(t,i){$(t,e,i),b(e,n)},p(t,o){524288&o[0]&&r!==(r=t[42]+"")&&C(n,r),524288&o[0]&&i!==(i=t[42])&&(e.__value=i,e.value=e.__value)},d(t){t&&x(e)}}}function eu(t){let e,n,i,r,o,l,a,s,u,h,d,f,p=1===t[0].num_features?"Distribution":"Distributions";function g(t,e){return 2===t[0].num_features?iu:nu}let m=g(t),v=m(t);return{c(){e=k("label"),n=k("input"),i=A(),r=L(p),o=A(),l=k("label"),a=k("input"),s=L("Scale locally"),u=A(),v.c(),h=S(),z(n,"type","checkbox"),z(e,"class","label-and-input svelte-d2a28i"),z(a,"type","checkbox"),z(l,"class","label-and-input svelte-d2a28i")},m(c,p){$(c,e,p),b(e,n),n.checked=t[10],b(e,i),b(e,r),$(c,o,p),$(c,l,p),b(l,a),a.checked=t[7],b(l,s),$(c,u,p),v.m(c,p),$(c,h,p),d||(f=[N(n,"change",t[29]),N(a,"change",t[30])],d=!0)},p(t,e){1024&e[0]&&(n.checked=t[10]),1&e[0]&&p!==(p=1===t[0].num_features?"Distribution":"Distributions")&&C(r,p),128&e[0]&&(a.checked=t[7]),m===(m=g(t))&&v?v.p(t,e):(v.d(1),v=m(t),v&&(v.c(),v.m(h.parentNode,h)))},d(t){t&&x(e),t&&x(o),t&&x(l),t&&x(u),v.d(t),t&&x(h),d=!1,c(f)}}}function nu(t){let e,n,i,r,o,l,a,s=t[21],c=[];for(let e=0;e<s.length;e+=1)c[e]=ru(Gc(t,s,e));let u="cluster-lines"===t[2]&&ou(t);return{c(){e=k("label"),n=L("ICE:\n          "),i=k("select");for(let t=0;t<c.length;t+=1)c[t].c();r=A(),u&&u.c(),o=S(),z(i,"class","svelte-d2a28i"),void 0===t[2]&&K((()=>t[33].call(i))),z(e,"class","label-and-input svelte-d2a28i")},m(s,h){$(s,e,h),b(e,n),b(e,i);for(let t=0;t<c.length;t+=1)c[t].m(i,null);O(i,t[2]),$(s,r,h),u&&u.m(s,h),$(s,o,h),l||(a=N(i,"change",t[33]),l=!0)},p(t,e){if(2097152&e[0]){let n;for(s=t[21],n=0;n<s.length;n+=1){const r=Gc(t,s,n);c[n]?c[n].p(r,e):(c[n]=ru(r),c[n].c(),c[n].m(i,null))}for(;n<c.length;n+=1)c[n].d(1);c.length=s.length}2097156&e[0]&&O(i,t[2]),"cluster-lines"===t[2]?u?u.p(t,e):(u=ou(t),u.c(),u.m(o.parentNode,o)):u&&(u.d(1),u=null)},d(t){t&&x(e),_(c,t),t&&x(r),u&&u.d(t),t&&x(o),l=!1,a()}}}function iu(t){let e,n,i,r,o,l,a,s,u,h,d,f;return{c(){e=k("label"),n=k("input"),i=L("One-way plots"),r=A(),o=k("label"),l=L("Color\n          "),a=k("select"),s=k("option"),s.textContent="both",u=k("option"),u.textContent="interactions",h=k("option"),h.textContent="predictions",z(n,"type","checkbox"),z(e,"class","label-and-input svelte-d2a28i"),s.__value="both",s.value=s.__value,u.__value="interactions",u.value=u.__value,h.__value="predictions",h.value=h.__value,z(a,"class","svelte-d2a28i"),void 0===t[12]&&K((()=>t[32].call(a))),z(o,"class","label-and-input svelte-d2a28i")},m(c,p){$(c,e,p),b(e,n),n.checked=t[11],b(e,i),$(c,r,p),$(c,o,p),b(o,l),b(o,a),b(a,s),b(a,u),b(a,h),O(a,t[12]),d||(f=[N(n,"change",t[31]),N(a,"change",t[32])],d=!0)},p(t,e){2048&e[0]&&(n.checked=t[11]),4096&e[0]&&O(a,t[12])},d(t){t&&x(e),t&&x(r),t&&x(o),d=!1,c(f)}}}function ru(t){let e,n,i,r=t[39]+"";return{c(){e=k("option"),n=L(r),e.__value=i=t[38],e.value=e.__value},m(t,i){$(t,e,i),b(e,n)},p:l,d(t){t&&x(e)}}}function ou(t){let e,n,i,r,o;return{c(){e=k("label"),n=k("input"),i=L("Describe clusters"),z(n,"type","checkbox"),z(e,"class","label-and-input svelte-d2a28i")},m(l,a){$(l,e,a),b(e,n),n.checked=t[1],b(e,i),r||(o=N(n,"change",t[34]),r=!0)},p(t,e){2&e[0]&&(n.checked=t[1])},d(t){t&&x(e),r=!1,o()}}}function lu(t){let e,n,i,r,o,l=null!==t[8]&&null!==t[9]&&t[11]&&cu(t),a=("both"===t[12]||"interactions"===t[12])&&uu(t),s=("both"===t[12]||"predictions"===t[12])&&hu(t);return{c(){e=k("div"),l&&l.c(),n=A(),a&&a.c(),i=A(),s&&s.c(),z(e,"class",r="two-way-pdp-grid showOneWay-"+(null!==t[8]&&null!==t[9]&&t[11])+"-color-"+t[12]+" svelte-d2a28i")},m(t,r){$(t,e,r),l&&l.m(e,null),b(e,n),a&&a.m(e,null),b(e,i),s&&s.m(e,null),o=!0},p(t,c){null!==t[8]&&null!==t[9]&&t[11]?l?(l.p(t,c),2816&c[0]&&ot(l,1)):(l=cu(t),l.c(),ot(l,1),l.m(e,n)):l&&(it(),lt(l,1,1,(()=>{l=null})),rt()),"both"===t[12]||"interactions"===t[12]?a?(a.p(t,c),4096&c[0]&&ot(a,1)):(a=uu(t),a.c(),ot(a,1),a.m(e,i)):a&&(it(),lt(a,1,1,(()=>{a=null})),rt()),"both"===t[12]||"predictions"===t[12]?s?(s.p(t,c),4096&c[0]&&ot(s,1)):(s=hu(t),s.c(),ot(s,1),s.m(e,null)):s&&(it(),lt(s,1,1,(()=>{s=null})),rt()),(!o||6912&c[0]&&r!==(r="two-way-pdp-grid showOneWay-"+(null!==t[8]&&null!==t[9]&&t[11])+"-color-"+t[12]+" svelte-d2a28i"))&&z(e,"class",r)},i(t){o||(ot(l),ot(a),ot(s),o=!0)},o(t){lt(l),lt(a),lt(s),o=!1},d(t){t&&x(e),l&&l.d(),a&&a.d(),s&&s.d()}}}function au(t){let e,n,i,r,o;i=new tc({props:{pd:t[0],width:t[1]?t[17]:t[3],height:t[4],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?mu:10,distributionHeight:t[10]?mu:0,iceLevel:t[2],indices:t[14],showColorLegend:!1}});let l=t[1]&&du(t);return{c(){e=k("div"),n=k("div"),ht(i.$$.fragment),r=A(),l&&l.c(),E(n,"flex","1"),z(e,"class","one-way-pdp-grid svelte-d2a28i")},m(t,a){$(t,e,a),b(e,n),dt(i,n,null),b(e,r),l&&l.m(e,null),o=!0},p(t,n){const r={};1&n[0]&&(r.pd=t[0]),131082&n[0]&&(r.width=t[1]?t[17]:t[3]),16&n[0]&&(r.height=t[4]),128&n[0]&&(r.scaleLocally=t[7]),1024&n[0]&&(r.showMarginalDistribution=t[10]),1024&n[0]&&(r.marginTop=t[10]?mu:10),1024&n[0]&&(r.distributionHeight=t[10]?mu:0),4&n[0]&&(r.iceLevel=t[2]),16384&n[0]&&(r.indices=t[14]),i.$set(r),t[1]?l?(l.p(t,n),2&n[0]&&ot(l,1)):(l=du(t),l.c(),ot(l,1),l.m(e,null)):l&&(it(),lt(l,1,1,(()=>{l=null})),rt())},i(t){o||(ot(i.$$.fragment,t),ot(l),o=!0)},o(t){lt(i.$$.fragment,t),lt(l),o=!1},d(t){t&&x(e),ft(i),l&&l.d()}}}function su(t){let e,n;function i(t,e){return""===t[6]&&""===t[5]?pu:fu}let r=i(t),o=r(t);return{c(){e=k("div"),n=k("div"),o.c(),z(n,"class","detailed-plot-message-content svelte-d2a28i"),z(e,"class","detailed-plot-message-container svelte-d2a28i")},m(t,i){$(t,e,i),b(e,n),o.m(n,null)},p(t,e){r===(r=i(t))&&o?o.p(t,e):(o.d(1),o=r(t),o&&(o.c(),o.m(n,null)))},i:l,o:l,d(t){t&&x(e),o.d()}}}function cu(t){let e,n,i,r,o,l;return n=new tc({props:{pd:t[8],width:t[17],height:t[16],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?mu:10,distributionHeight:t[10]?mu:0,iceLevel:"lines"}}),o=new tc({props:{pd:t[9],width:t[17],height:t[16],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?mu:10,distributionHeight:t[10]?mu:0,iceLevel:"lines"}}),{c(){e=k("div"),ht(n.$$.fragment),i=A(),r=k("div"),ht(o.$$.fragment),E(e,"grid-area","one-way-left"),E(r,"grid-area","one-way-right")},m(t,a){$(t,e,a),dt(n,e,null),$(t,i,a),$(t,r,a),dt(o,r,null),l=!0},p(t,e){const i={};256&e[0]&&(i.pd=t[8]),131072&e[0]&&(i.width=t[17]),65536&e[0]&&(i.height=t[16]),128&e[0]&&(i.scaleLocally=t[7]),1024&e[0]&&(i.showMarginalDistribution=t[10]),1024&e[0]&&(i.marginTop=t[10]?mu:10),1024&e[0]&&(i.distributionHeight=t[10]?mu:0),n.$set(i);const r={};512&e[0]&&(r.pd=t[9]),131072&e[0]&&(r.width=t[17]),65536&e[0]&&(r.height=t[16]),128&e[0]&&(r.scaleLocally=t[7]),1024&e[0]&&(r.showMarginalDistribution=t[10]),1024&e[0]&&(r.marginTop=t[10]?mu:10),1024&e[0]&&(r.distributionHeight=t[10]?mu:0),o.$set(r)},i(t){l||(ot(n.$$.fragment,t),ot(o.$$.fragment,t),l=!0)},o(t){lt(n.$$.fragment,t),lt(o.$$.fragment,t),l=!1},d(t){t&&x(e),ft(n),t&&x(i),t&&x(r),ft(o)}}}function uu(t){let e,n,i;return n=new tc({props:{pd:t[0],width:"both"===t[12]?t[17]:t[3],height:null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?mu:10,marginRight:t[10]?mu:10,distributionHeight:t[10]?mu:0,iceLevel:"lines",colorShows:"interactions",showColorLegend:!0}}),{c(){e=k("div"),ht(n.$$.fragment),E(e,"grid-area","two-way-interaction")},m(t,r){$(t,e,r),dt(n,e,null),i=!0},p(t,e){const i={};1&e[0]&&(i.pd=t[0]),135176&e[0]&&(i.width="both"===t[12]?t[17]:t[3]),35600&e[0]&&(i.height=null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4]),128&e[0]&&(i.scaleLocally=t[7]),1024&e[0]&&(i.showMarginalDistribution=t[10]),1024&e[0]&&(i.marginTop=t[10]?mu:10),1024&e[0]&&(i.marginRight=t[10]?mu:10),1024&e[0]&&(i.distributionHeight=t[10]?mu:0),n.$set(i)},i(t){i||(ot(n.$$.fragment,t),i=!0)},o(t){lt(n.$$.fragment,t),i=!1},d(t){t&&x(e),ft(n)}}}function hu(t){let e,n,i;return n=new tc({props:{pd:t[0],width:"both"===t[12]?t[17]:t[3],height:null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4],scaleLocally:t[7],showMarginalDistribution:t[10],marginTop:t[10]?mu:10,marginRight:t[10]?mu:10,distributionHeight:t[10]?mu:0,iceLevel:t[2],showColorLegend:!0}}),{c(){e=k("div"),ht(n.$$.fragment),E(e,"grid-area","two-way-pdp")},m(t,r){$(t,e,r),dt(n,e,null),i=!0},p(t,e){const i={};1&e[0]&&(i.pd=t[0]),135176&e[0]&&(i.width="both"===t[12]?t[17]:t[3]),35600&e[0]&&(i.height=null!==t[8]&&null!==t[9]&&t[11]?t[15]:t[4]),128&e[0]&&(i.scaleLocally=t[7]),1024&e[0]&&(i.showMarginalDistribution=t[10]),1024&e[0]&&(i.marginTop=t[10]?mu:10),1024&e[0]&&(i.marginRight=t[10]?mu:10),1024&e[0]&&(i.distributionHeight=t[10]?mu:0),4&e[0]&&(i.iceLevel=t[2]),n.$set(i)},i(t){i||(ot(n.$$.fragment,t),i=!0)},o(t){lt(n.$$.fragment,t),i=!1},d(t){t&&x(e),ft(n)}}}function du(t){let e,n,i;return n=new Kc({props:{pd:t[0],width:t[17],height:t[4],features:t[0].ice.interacting_features}}),n.$on("filter",t[22]),{c(){e=k("div"),ht(n.$$.fragment),E(e,"flex","1")},m(t,r){$(t,e,r),dt(n,e,null),i=!0},p(t,e){const i={};1&e[0]&&(i.pd=t[0]),131072&e[0]&&(i.width=t[17]),16&e[0]&&(i.height=t[4]),1&e[0]&&(i.features=t[0].ice.interacting_features),n.$set(i)},i(t){i||(ot(n.$$.fragment,t),i=!0)},o(t){lt(n.$$.fragment,t),i=!1},d(t){t&&x(e),ft(n)}}}function fu(t){let e,n,i,r,o,l,a,s,c,u,h,d,f=2===t[18].length?"Computing...":"Compute Now";return{c(){e=k("div"),n=L("The two-way PDP between "),i=L(t[6]),r=L(" and "),o=L(t[5]),l=L("\n              was not pre-computed, since we did not detect a likely interaction\n              between the two features."),a=A(),s=k("button"),c=L(f),s.disabled=u=2===t[18].length,z(s,"class","svelte-d2a28i")},m(u,f){$(u,e,f),b(e,n),b(e,i),b(e,r),b(e,o),b(e,l),$(u,a,f),$(u,s,f),b(s,c),h||(d=N(s,"click",t[20]),h=!0)},p(t,e){64&e[0]&&C(i,t[6]),32&e[0]&&C(o,t[5]),262144&e[0]&&f!==(f=2===t[18].length?"Computing...":"Compute Now")&&C(c,f),262144&e[0]&&u!==(u=2===t[18].length)&&(s.disabled=u)},d(t){t&&x(e),t&&x(a),t&&x(s),h=!1,d()}}}function pu(t){let e;return{c(){e=k("div"),e.textContent="Select one or two features above.",E(e,"text-align","center")},m(t,n){$(t,e,n)},p:l,d(t){t&&x(e)}}}function gu(t){let e,n,i,r,o,l,a,s,u,h,d,f,p,g,m,v,y,w,M,L,S,T,C=t[19],q=[];for(let e=0;e<C.length;e+=1)q[e]=Qc(Jc(t,C,e));let E=t[19],D=[];for(let e=0;e<E.length;e+=1)D[e]=tu(Zc(t,E,e));let B=t[0]&&eu(t);const j=[su,au,lu],P=[];function H(t,e){return null===t[0]?0:1===t[0].num_features?1:2}return w=H(t),M=P[w]=j[w](t),{c(){e=k("div"),n=k("div"),i=k("div"),r=k("label"),o=k("span"),o.textContent="Feat. 1",l=A(),a=k("select"),s=k("option");for(let t=0;t<q.length;t+=1)q[t].c();u=A(),h=k("label"),d=k("span"),d.textContent="Feat. 2",f=A(),p=k("select"),g=k("option");for(let t=0;t<D.length;t+=1)D[t].c();m=A(),B&&B.c(),v=A(),y=k("div"),M.c(),z(o,"class","svelte-d2a28i"),s.__value="",s.value=s.__value,z(a,"class","svelte-d2a28i"),void 0===t[6]&&K((()=>t[27].call(a))),z(r,"class","svelte-d2a28i"),z(d,"class","svelte-d2a28i"),g.__value="",g.value=g.__value,z(p,"class","svelte-d2a28i"),void 0===t[5]&&K((()=>t[28].call(p))),z(h,"class","svelte-d2a28i"),z(i,"class","feature-selects svelte-d2a28i"),z(n,"class","zoomed-pdp-header svelte-d2a28i"),z(y,"class","zoomed-pdp-content svelte-d2a28i"),z(e,"class","zoomed-pdp-container svelte-d2a28i")},m(c,x){$(c,e,x),b(e,n),b(n,i),b(i,r),b(r,o),b(r,l),b(r,a),b(a,s);for(let t=0;t<q.length;t+=1)q[t].m(a,null);O(a,t[6]),b(i,u),b(i,h),b(h,d),b(h,f),b(h,p),b(p,g);for(let t=0;t<D.length;t+=1)D[t].m(p,null);O(p,t[5]),b(n,m),B&&B.m(n,null),b(e,v),b(e,y),P[w].m(y,null),t[35](y),L=!0,S||(T=[N(a,"change",t[27]),N(p,"change",t[28])],S=!0)},p(t,e){if(524288&e[0]){let n;for(C=t[19],n=0;n<C.length;n+=1){const i=Jc(t,C,n);q[n]?q[n].p(i,e):(q[n]=Qc(i),q[n].c(),q[n].m(a,null))}for(;n<q.length;n+=1)q[n].d(1);q.length=C.length}if(524352&e[0]&&O(a,t[6]),524288&e[0]){let n;for(E=t[19],n=0;n<E.length;n+=1){const i=Zc(t,E,n);D[n]?D[n].p(i,e):(D[n]=tu(i),D[n].c(),D[n].m(p,null))}for(;n<D.length;n+=1)D[n].d(1);D.length=E.length}524320&e[0]&&O(p,t[5]),t[0]?B?B.p(t,e):(B=eu(t),B.c(),B.m(n,null)):B&&(B.d(1),B=null);let i=w;w=H(t),w===i?P[w].p(t,e):(it(),lt(P[i],1,1,(()=>{P[i]=null})),rt(),M=P[w],M?M.p(t,e):(M=P[w]=j[w](t),M.c()),ot(M,1),M.m(y,null))},i(t){L||(ot(M),L=!0)},o(t){lt(M),L=!1},d(n){n&&x(e),_(q,n),_(D,n),B&&B.d(),P[w].d(),t[35](null),S=!1,c(T)}}}const mu=50;function vu(t,e,n){let i,r,o,l,a,s,c,u,h;var d,f;p(t,Zn,(t=>n(25,l=t))),p(t,On,(t=>n(26,a=t))),p(t,Yn,(t=>n(5,s=t))),p(t,Xn,(t=>n(6,c=t))),p(t,Wn,(t=>n(18,u=t))),p(t,zn,(t=>n(19,h=t)));let g=null,v=!1,y=null,b=null,w=!1;const $=[{value:"lines",title:"Standard"},{value:"centered-lines",title:"Centered"},{value:"cluster-lines",title:"Clusters"}];let x,_,k,M="lines",L=!1,A=!0,S="both";H((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(3,_=t.inlineSize),n(4,k=t.blockSize)}else n(3,_=e.contentRect.width),n(4,k=e.contentRect.height)}));return t.observe(x),()=>t.unobserve(x)}));let N=null;return t.$$.update=()=>{96&t.$$.dirty[0]&&function(){var t,e;c===s&&m(Yn,s="",s),""===c&&""!==s&&(m(Xn,c=s,c),m(Yn,s="",s)),n(0,g=""===s?null!==(t=l.get(c))&&void 0!==t?t:null:null!==(e=a.find((t=>t.x_feature===c&&t.y_feature===s||t.x_feature===s&&t.y_feature===c)))&&void 0!==e?e:null)}(),67108864&t.$$.dirty[0]&&a&&function(){const t=a.find((t=>t.x_feature===u[0]&&t.y_feature===u[1]||t.x_feature===u[1]&&t.y_feature===u[0]));t&&(2===u.length&&u[0]===c&&u[1]===s&&n(0,g=t),m(Wn,u=[],u))}(),58720257&t.$$.dirty[0]&&g&&2===g.num_features&&(n(8,y=null!==n(23,d=l.get(g.x_feature))&&void 0!==d?d:null),n(9,b=null!==n(24,f=l.get(g.y_feature))&&void 0!==f?f:null)),4&t.$$.dirty[0]&&"cluster-lines"!==M&&n(1,w=!1),8&t.$$.dirty[0]&&n(17,i=_/2),16&t.$$.dirty[0]&&n(16,r=k/3),16&t.$$.dirty[0]&&n(15,o=2*k/3),2&t.$$.dirty[0]&&(w||n(14,N=null))},[g,w,M,_,k,s,c,v,y,b,L,A,S,x,N,o,r,i,u,h,function(){m(Wn,u=[c,s],u)},$,function(t){n(14,N=t.detail)},d,f,l,a,function(){c=D(this),Xn.set(c)},function(){s=D(this),Yn.set(s)},function(){L=this.checked,n(10,L)},function(){v=this.checked,n(7,v)},function(){A=this.checked,n(11,A)},function(){S=D(this),n(12,S)},function(){M=D(this),n(2,M),n(21,$)},function(){w=this.checked,n(1,w),n(2,M)},function(t){V[t?"unshift":"push"]((()=>{x=t,n(13,x)}))}]}const yu=class extends gt{constructor(t){super(),pt(this,t,vu,gu,h,{},Uc,[-1,-1])}};function bu(t){w(t,"svelte-kiv6ja",".controls-features.svelte-kiv6ja.svelte-kiv6ja{display:flex;flex-direction:column;max-height:100%;row-gap:0.25em}ul.svelte-kiv6ja.svelte-kiv6ja{list-style:none}.fs-row.svelte-kiv6ja.svelte-kiv6ja{display:flex;align-items:center;column-gap:0.25em}input.svelte-kiv6ja.svelte-kiv6ja{min-width:0}.fs-row.svelte-kiv6ja label.svelte-kiv6ja{flex:1}.individual-features.svelte-kiv6ja.svelte-kiv6ja{flex:0 1 auto;overflow-y:scroll;min-height:0}.hidden.svelte-kiv6ja.svelte-kiv6ja{display:none}")}function wu(t,e,n){const i=t.slice();return i[19]=e[n].feature,i[20]=e[n].hidden,i[21]=e[n].disabled,i}function $u(t,e){let n,i,r,o,l,a,s,u,h,d,f,p,g,m=e[19]+"";function v(){return e[14](e[19])}return{key:t,first:null,c(){n=k("li"),i=k("input"),a=A(),s=k("label"),u=L(m),f=A(),z(i,"id",r=e[19]+"-checkbox"),z(i,"type","checkbox"),z(i,"name","features"),i.__value=o=e[19],i.value=i.__value,i.disabled=l=e[21],z(i,"class","svelte-kiv6ja"),e[13][0].push(i),z(s,"class","pdpilot-cutoff svelte-kiv6ja"),z(s,"for",h=e[19]+"-checkbox"),z(s,"title",d=e[19]),z(n,"class","fs-row svelte-kiv6ja"),B(n,"hidden",e[20]),this.first=n},m(t,r){$(t,n,r),b(n,i),i.checked=~e[1].indexOf(i.__value),b(n,a),b(n,s),b(s,u),b(n,f),p||(g=[N(i,"change",e[12]),N(i,"change",v)],p=!0)},p(t,a){e=t,16&a&&r!==(r=e[19]+"-checkbox")&&z(i,"id",r),16&a&&o!==(o=e[19])&&(i.__value=o,i.value=i.__value),16&a&&l!==(l=e[21])&&(i.disabled=l),2&a&&(i.checked=~e[1].indexOf(i.__value)),16&a&&m!==(m=e[19]+"")&&C(u,m),16&a&&h!==(h=e[19]+"-checkbox")&&z(s,"for",h),16&a&&d!==(d=e[19])&&z(s,"title",d),16&a&&B(n,"hidden",e[20])},d(t){t&&x(n),e[13][0].splice(e[13][0].indexOf(i),1),p=!1,c(g)}}}function xu(t){let e,n,i,r,o,a,s,u,h,d,f,p,g,m,v,y=[],w=new Map,_=t[4];const M=t=>t[19];for(let e=0;e<_.length;e+=1){let n=wu(t,_,e),i=M(n);w.set(i,y[e]=$u(i,n))}return{c(){e=k("div"),n=k("ul"),i=k("li"),r=k("input"),a=A(),s=k("label"),s.textContent="All features",u=A(),h=k("label"),d=L("Search\n    "),f=k("input"),p=A(),g=k("ul");for(let t=0;t<y.length;t+=1)y[t].c();z(r,"id","features-checkbox"),z(r,"type","checkbox"),r.indeterminate=t[3],r.disabled=o=""!==t[0]||!t[5],z(r,"class","svelte-kiv6ja"),z(s,"for","features-checkbox"),z(s,"class","svelte-kiv6ja"),z(i,"class","fs-row svelte-kiv6ja"),z(n,"class","svelte-kiv6ja"),z(f,"class","svelte-kiv6ja"),z(h,"class","fs-row svelte-kiv6ja"),z(g,"class","individual-features svelte-kiv6ja"),z(e,"class","controls-features svelte-kiv6ja")},m(o,l){$(o,e,l),b(e,n),b(n,i),b(i,r),r.checked=t[2],b(i,a),b(i,s),b(e,u),b(e,h),b(h,d),b(h,f),q(f,t[0]),b(e,p),b(e,g);for(let t=0;t<y.length;t+=1)y[t].m(g,null);m||(v=[N(r,"change",t[10]),N(r,"change",t[6]),N(f,"input",t[11])],m=!0)},p(t,[e]){8&e&&(r.indeterminate=t[3]),33&e&&o!==(o=""!==t[0]||!t[5])&&(r.disabled=o),4&e&&(r.checked=t[2]),1&e&&f.value!==t[0]&&q(f,t[0]),146&e&&(_=t[4],y=ct(y,e,M,1,t,_,w,g,at,$u,null,wu))},i:l,o:l,d(t){t&&x(e);for(let t=0;t<y.length;t+=1)y[t].d();m=!1,c(v)}}}function _u(t,e,n){let i,r,o;p(t,zn,(t=>n(9,o=t)));let{enabledFeatures:l}=e;const a=R();let s=!0,c=!1,u="",h=o,d=new Set;function f(){0===h.length?(n(2,s=!1),n(3,c=!1)):h.length===o.length?(n(2,s=!0),n(3,c=!1)):h.length>0&&h.length<o.length&&(n(2,s=!0),n(3,c=!0))}function g(t){h.includes(t)?d.delete(t):d.add(t)}const m=[[]];return t.$$set=t=>{"enabledFeatures"in t&&n(8,l=t.enabledFeatures)},t.$$.update=()=>{256&t.$$.dirty&&function(t){n(1,h=o.filter((e=>t.includes(e)&&!d.has(e)))),f(),a("changeNameFilters",h)}(l),768&t.$$.dirty&&n(5,i=l.length===o.length),769&t.$$.dirty&&n(4,r=o.map((t=>({feature:t,hidden:!t.includes(u),disabled:!l.includes(t)})))),2&t.$$.dirty&&(f(),a("changeNameFilters",h))},[u,h,s,c,r,i,function(){s?(n(1,h=o),n(3,c=!1)):(n(1,h=[]),n(3,c=!1)),d=new Set},g,l,o,function(){s=this.checked,n(2,s)},function(){u=this.value,n(0,u)},function(){h=T(m[0],this.__value,this.checked),n(1,h)},m,t=>g(t)]}const ku=class extends gt{constructor(t){super(),pt(this,t,_u,xu,h,{enabledFeatures:8},bu)}};function Mu(t){w(t,"svelte-zyfurg","ul.svelte-zyfurg.svelte-zyfurg{list-style:none}.label-and-input.svelte-zyfurg.svelte-zyfurg{display:flex;align-items:center;gap:0.25em}ul.svelte-zyfurg ul.svelte-zyfurg{margin-left:1em}")}function Lu(t){let e,n,i,r,o,a,s,u,h,d,f,p,g,m,v,y,w,_,M,L,S,T,C,q,E,O,D,B;return{c(){e=k("div"),n=k("ul"),i=k("li"),r=k("label"),o=k("input"),s=k("span"),s.textContent="Ordered",u=A(),h=k("ul"),d=k("li"),f=k("label"),p=k("input"),g=k("span"),g.textContent="Increasing",m=A(),v=k("label"),y=k("input"),w=k("span"),w.textContent="Decreasing",_=A(),M=k("label"),L=k("input"),S=k("span"),S.textContent="Mixed",T=A(),C=k("li"),q=k("label"),E=k("input"),O=k("span"),O.textContent="Nominal",z(o,"type","checkbox"),o.indeterminate=a=t[0].ordered.shapes.length>0&&t[0].ordered.shapes.length<t[1].length,z(r,"class","label-and-input svelte-zyfurg"),z(p,"type","checkbox"),p.__value="increasing",p.value=p.__value,t[6][0].push(p),z(f,"class","label-and-input svelte-zyfurg"),z(y,"type","checkbox"),y.__value="decreasing",y.value=y.__value,t[6][0].push(y),z(v,"class","label-and-input svelte-zyfurg"),z(L,"type","checkbox"),L.__value="mixed",L.value=L.__value,t[6][0].push(L),z(M,"class","label-and-input svelte-zyfurg"),z(h,"class","svelte-zyfurg"),z(E,"type","checkbox"),z(q,"class","label-and-input svelte-zyfurg"),z(n,"class","svelte-zyfurg")},m(l,a){$(l,e,a),b(e,n),b(n,i),b(i,r),b(r,o),o.checked=t[0].ordered.checked,b(r,s),b(i,u),b(i,h),b(h,d),b(d,f),b(f,p),p.checked=~t[0].ordered.shapes.indexOf(p.__value),b(f,g),b(d,m),b(d,v),b(v,y),y.checked=~t[0].ordered.shapes.indexOf(y.__value),b(v,w),b(d,_),b(d,M),b(M,L),L.checked=~t[0].ordered.shapes.indexOf(L.__value),b(M,S),b(n,T),b(n,C),b(C,q),b(q,E),E.checked=t[0].nominal.checked,b(q,O),D||(B=[N(o,"change",t[4]),N(o,"change",t[2]),N(p,"change",t[5]),N(p,"change",t[3]),N(y,"change",t[7]),N(y,"change",t[3]),N(L,"change",t[8]),N(L,"change",t[3]),N(E,"change",t[9])],D=!0)},p(t,[e]){1&e&&a!==(a=t[0].ordered.shapes.length>0&&t[0].ordered.shapes.length<t[1].length)&&(o.indeterminate=a),1&e&&(o.checked=t[0].ordered.checked),1&e&&(p.checked=~t[0].ordered.shapes.indexOf(p.__value)),1&e&&(y.checked=~t[0].ordered.shapes.indexOf(y.__value)),1&e&&(L.checked=~t[0].ordered.shapes.indexOf(L.__value)),1&e&&(E.checked=t[0].nominal.checked)},i:l,o:l,d(n){n&&x(e),t[6][0].splice(t[6][0].indexOf(p),1),t[6][0].splice(t[6][0].indexOf(y),1),t[6][0].splice(t[6][0].indexOf(L),1),D=!1,c(B)}}}function Au(t,e,n){let i=["increasing","decreasing","mixed"],r={ordered:{checked:!0,shapes:i},nominal:{checked:!0}};const o=R();H((()=>{o("changeKindFilters",r)}));const l=[[]];return t.$$.update=()=>{1&t.$$.dirty&&o("changeKindFilters",r)},[r,i,function(){r.ordered.checked?n(0,r.ordered.shapes=i,r):n(0,r.ordered.shapes=[],r)},function(){n(0,r.ordered.checked=0!==r.ordered.shapes.length,r)},function(){r.ordered.checked=this.checked,n(0,r)},function(){r.ordered.shapes=T(l[0],this.__value,this.checked),n(0,r)},l,function(){r.ordered.shapes=T(l[0],this.__value,this.checked),n(0,r)},function(){r.ordered.shapes=T(l[0],this.__value,this.checked),n(0,r)},function(){r.nominal.checked=this.checked,n(0,r)}]}const Su=class extends gt{constructor(t){super(),pt(this,t,Au,Lu,h,{},Mu)}};function Nu(t){w(t,"svelte-2uqume",".toggle-and-title.svelte-2uqume.svelte-2uqume{display:flex;align-items:center;gap:0.25em}.icon-tabler-chevron-down.svelte-2uqume polyline.svelte-2uqume{transition:transform 150ms}.rotate-polyline.svelte-2uqume.svelte-2uqume{transform-origin:50% 50%;transform:rotate(-90deg)}")}function zu(t){let e,n,i,r,o,a,s,c,u,h,d,f=`${Tu}px`,p=`${Tu}px`;return{c(){e=k("div"),n=k("button"),i=M("svg"),r=M("path"),o=M("polyline"),s=A(),c=k("div"),u=L(t[1]),z(r,"stroke","none"),z(r,"d","M0 0h24v24H0z"),z(r,"fill","none"),z(o,"points",a="2 12 12 22 22 12"),z(o,"class","svelte-2uqume"),B(o,"rotate-polyline",!t[0]),z(i,"xmlns","http://www.w3.org/2000/svg"),z(i,"class","icon-tabler icon-tabler-chevron-down svelte-2uqume"),z(i,"width",Tu),z(i,"height",Tu),z(i,"viewBox","0 0 24 24"),z(i,"stroke-width","4"),z(i,"stroke","currentColor"),z(i,"fill","none"),z(i,"stroke-linecap","round"),z(i,"stroke-linejoin","round"),E(n,"border","none"),E(n,"width",f),E(n,"height",p),E(n,"padding","0"),z(c,"class","group-title"),z(e,"class","toggle-and-title svelte-2uqume")},m(l,a){$(l,e,a),b(e,n),b(n,i),b(i,r),b(i,o),b(e,s),b(e,c),b(c,u),h||(d=N(n,"click",t[2]),h=!0)},p(t,[e]){1&e&&B(o,"rotate-polyline",!t[0]),2&e&&C(u,t[1])},i:l,o:l,d(t){t&&x(e),h=!1,d()}}}const Tu=8;function Cu(t,e,n){let{expanded:i=!1}=e,{title:r}=e;return t.$$set=t=>{"expanded"in t&&n(0,i=t.expanded),"title"in t&&n(1,r=t.title)},[i,r,()=>n(0,i=!i)]}const qu=class extends gt{constructor(t){super(),pt(this,t,Cu,zu,h,{expanded:0,title:1},Nu)}};function Eu(t){w(t,"svelte-1mkvanr",".controls-container.svelte-1mkvanr.svelte-1mkvanr{height:100%;flex:0 0 200px;min-width:200px;max-width:200px;padding:0.25em;border-right:1px solid var(--gray-1);display:flex;flex-direction:column;gap:0.5em}.feature-selector-wrapper-outer.svelte-1mkvanr.svelte-1mkvanr{flex:0 1 auto;min-height:0;display:flex;flex-direction:column}.feature-selector-wrapper-inner.svelte-1mkvanr.svelte-1mkvanr{flex:1;min-height:0}.filter-header.svelte-1mkvanr+.filter-content.svelte-1mkvanr{margin-top:0.25em}.filter-content.svelte-1mkvanr.svelte-1mkvanr{margin-left:0.75em}")}function Ou(t){let e,n,i,r,o,l,a,s,c,u,h,d,f,p,g,m,v,y,w;function _(e){t[8](e)}let M={title:"Type"};function L(e){t[9](e)}void 0!==t[0]&&(M.expanded=t[0]),l=new qu({props:M}),V.push((()=>ut(l,"expanded",_,t[0]))),u=new Su({}),u.$on("changeKindFilters",t[3]);let S={title:"Name"};return void 0!==t[1]&&(S.expanded=t[1]),p=new qu({props:S}),V.push((()=>ut(p,"expanded",L,t[1]))),y=new ku({props:{enabledFeatures:t[2]}}),y.$on("changeNameFilters",t[4]),{c(){e=k("div"),n=k("div"),n.textContent="Feature Filters",i=A(),r=k("div"),o=k("div"),ht(l.$$.fragment),s=A(),c=k("div"),ht(u.$$.fragment),h=A(),d=k("div"),f=k("div"),ht(p.$$.fragment),m=A(),v=k("div"),ht(y.$$.fragment),z(n,"class","pdpilot-bold"),z(o,"class","filter-header svelte-1mkvanr"),z(c,"class","filter-content svelte-1mkvanr"),B(c,"pdp-hide",!t[0]),z(f,"class","filter-header svelte-1mkvanr"),z(v,"class","filter-content feature-selector-wrapper-inner svelte-1mkvanr"),B(v,"pdp-hide",!t[1]),z(d,"class","filter-container feature-selector-wrapper-outer svelte-1mkvanr"),z(e,"class","controls-container svelte-1mkvanr")},m(t,a){$(t,e,a),b(e,n),b(e,i),b(e,r),b(r,o),dt(l,o,null),b(r,s),b(r,c),dt(u,c,null),b(e,h),b(e,d),b(d,f),dt(p,f,null),b(d,m),b(d,v),dt(y,v,null),w=!0},p(t,[e]){const n={};!a&&1&e&&(a=!0,n.expanded=t[0],U((()=>a=!1))),l.$set(n),(!w||1&e)&&B(c,"pdp-hide",!t[0]);const i={};!g&&2&e&&(g=!0,i.expanded=t[1],U((()=>g=!1))),p.$set(i);const r={};4&e&&(r.enabledFeatures=t[2]),y.$set(r),(!w||2&e)&&B(v,"pdp-hide",!t[1])},i(t){w||(ot(l.$$.fragment,t),ot(u.$$.fragment,t),ot(p.$$.fragment,t),ot(y.$$.fragment,t),w=!0)},o(t){lt(l.$$.fragment,t),lt(u.$$.fragment,t),lt(p.$$.fragment,t),lt(y.$$.fragment,t),w=!1},d(t){t&&x(e),ft(l),ft(u),ft(p),ft(y)}}}function Du(t,e,n){let i,r,o;p(t,Zn,(t=>n(6,r=t))),p(t,zn,(t=>n(7,o=t)));const l=R();let a,s=!0,c=!0;return t.$$.update=()=>{224&t.$$.dirty&&n(2,i=o.filter((t=>{const e=r.get(t);return!(!e||!a)&&(e.ordered?a.ordered.shapes.includes(e.shape):a.nominal.checked)})))},[s,c,i,function(t){n(5,a=t.detail)},function(t){l("changeFilters",t.detail)},a,r,o,function(t){s=t,n(0,s)},function(t){c=t,n(1,c)}]}const Bu=class extends gt{constructor(t){super(),pt(this,t,Du,Ou,h,{},Eu)}};function ju(t){return 0===t.length||1===t[0].num_features}function Pu(t){w(t,"svelte-19snser",".tooltip-container.svelte-19snser{position:relative;display:flex;align-items:center}.tooltip-content.svelte-19snser{position:absolute;padding:5px;border-radius:5px;max-width:30em;border:1px solid black;color:black;background-color:white;z-index:1;pointer-events:none}")}function Hu(t){let e,n,i,r,o,a,s;return{c(){e=M("svg"),n=M("path"),i=M("circle"),r=M("line"),o=M("path"),z(n,"stroke","none"),z(n,"d","M0 0h24v24H0z"),z(i,"cx","12"),z(i,"cy","12"),z(i,"r","9"),z(r,"x1","12"),z(r,"y1","17"),z(r,"x2","12"),z(r,"y2","17.01"),z(o,"d","M12 13.5a1.5 1.5 0 0 1 1 -1.5a2.6 2.6 0 1 0 -3 -4"),z(e,"xmlns","http://www.w3.org/2000/svg"),z(e,"class","pdpilot-icon icon-tabler icon-tabler-help"),z(e,"width","24"),z(e,"height","24"),z(e,"viewBox","0 0 24 24"),z(e,"stroke-width","2"),z(e,"stroke","currentColor"),z(e,"fill","none"),z(e,"stroke-linecap","round"),z(e,"stroke-linejoin","round")},m(l,c){$(l,e,c),b(e,n),b(e,i),b(e,r),b(e,o),a||(s=[N(e,"mouseenter",t[15]),N(e,"mouseleave",t[16])],a=!0)},p:l,d(t){t&&x(e),a=!1,c(s)}}}function Ru(t){let e,n,i,r,o,a,s;return{c(){e=M("svg"),n=M("path"),i=M("circle"),r=M("line"),o=M("line"),z(n,"stroke","none"),z(n,"d","M0 0h24v24H0z"),z(n,"fill","none"),z(i,"cx","12"),z(i,"cy","12"),z(i,"r","9"),z(r,"x1","12"),z(r,"y1","8"),z(r,"x2","12"),z(r,"y2","12"),z(o,"x1","12"),z(o,"y1","16"),z(o,"x2","12.01"),z(o,"y2","16"),z(e,"xmlns","http://www.w3.org/2000/svg"),z(e,"class","pdpilot-icon icon-tabler icon-tabler-alert-circle"),z(e,"width","24"),z(e,"height","24"),z(e,"viewBox","0 0 24 24"),z(e,"stroke-width","2"),z(e,"stroke","currentColor"),z(e,"fill","none"),z(e,"stroke-linecap","round"),z(e,"stroke-linejoin","round")},m(l,c){$(l,e,c),b(e,n),b(e,i),b(e,r),b(e,o),a||(s=[N(e,"mouseenter",t[13]),N(e,"mouseleave",t[14])],a=!0)},p:l,d(t){t&&x(e),a=!1,c(s)}}}function Iu(t){let e,n,i=`${t[5]}\n      ${t[6]}\n      ${t[7]}\n      ${t[8]}`;const r=t[12].default,o=function(t,e,n,i){if(t){const i=g(t,e,n,null);return t[0](i)}}(r,t,t[11]);return{c(){e=k("div"),o&&o.c(),z(e,"class","tooltip-content pdpilot-small svelte-19snser"),E(e,"top",t[1]),E(e,"right",t[3]),E(e,"bottom",t[4]),E(e,"left",t[2]),E(e,"margin",i),E(e,"width",t[9])},m(t,i){$(t,e,i),o&&o.m(e,null),n=!0},p(t,l){o&&o.p&&(!n||2048&l)&&function(t,e,n,i,r,o){if(r){const l=g(e,n,i,o);t.p(l,r)}}(o,r,t,t[11],n?function(t,e,n,i){if(t[2]&&i){const r=t[2](i(n));if(void 0===e.dirty)return r;if("object"==typeof r){const t=[],n=Math.max(e.dirty.length,r.length);for(let i=0;i<n;i+=1)t[i]=e.dirty[i]|r[i];return t}return e.dirty|r}return e.dirty}(r,t[11],l,null):function(t){if(t.ctx.length>32){const e=[],n=t.ctx.length/32;for(let t=0;t<n;t++)e[t]=-1;return e}return-1}(t[11]),null),2&l&&E(e,"top",t[1]),8&l&&E(e,"right",t[3]),16&l&&E(e,"bottom",t[4]),4&l&&E(e,"left",t[2]),480&l&&i!==(i=`${t[5]}\n      ${t[6]}\n      ${t[7]}\n      ${t[8]}`)&&E(e,"margin",i),512&l&&E(e,"width",t[9])},i(t){n||(ot(o,t),n=!0)},o(t){lt(o,t),n=!1},d(t){t&&x(e),o&&o.d(t)}}}function Vu(t){let e,n,i;function r(t,e){return"alert"===t[0]?Ru:Hu}let o=r(t),l=o(t),a=t[10]&&Iu(t);return{c(){e=k("div"),l.c(),n=A(),a&&a.c(),z(e,"class","tooltip-container svelte-19snser")},m(t,r){$(t,e,r),l.m(e,null),b(e,n),a&&a.m(e,null),i=!0},p(t,[i]){o===(o=r(t))&&l?l.p(t,i):(l.d(1),l=o(t),l&&(l.c(),l.m(e,n))),t[10]?a?(a.p(t,i),1024&i&&ot(a,1)):(a=Iu(t),a.c(),ot(a,1),a.m(e,null)):a&&(it(),lt(a,1,1,(()=>{a=null})),rt())},i(t){i||(ot(a),i=!0)},o(t){lt(a),i=!1},d(t){t&&x(e),l.d(),a&&a.d()}}}function Wu(t,e,n){let{$$slots:i={},$$scope:r}=e,{kind:o="help"}=e,{top:l="auto"}=e,{left:a="auto"}=e,{right:s="auto"}=e,{bottom:c="auto"}=e,{marginTop:u="0"}=e,{marginRight:h="0"}=e,{marginBottom:d="0"}=e,{marginLeft:f="0"}=e,{width:p="30em"}=e,g=!1;return t.$$set=t=>{"kind"in t&&n(0,o=t.kind),"top"in t&&n(1,l=t.top),"left"in t&&n(2,a=t.left),"right"in t&&n(3,s=t.right),"bottom"in t&&n(4,c=t.bottom),"marginTop"in t&&n(5,u=t.marginTop),"marginRight"in t&&n(6,h=t.marginRight),"marginBottom"in t&&n(7,d=t.marginBottom),"marginLeft"in t&&n(8,f=t.marginLeft),"width"in t&&n(9,p=t.width),"$$scope"in t&&n(11,r=t.$$scope)},[o,l,a,s,c,u,h,d,f,p,g,r,i,()=>n(10,g=!0),()=>n(10,g=!1),()=>n(10,g=!0),()=>n(10,g=!1)]}const Fu=class extends gt{constructor(t){super(),pt(this,t,Wu,Vu,h,{kind:0,top:1,left:2,right:3,bottom:4,marginTop:5,marginRight:6,marginBottom:7,marginLeft:8,width:9},Pu)}};function Xu(t){w(t,"svelte-3r8bme",".group-container.svelte-3r8bme.svelte-3r8bme{height:100%;width:100%;display:flex;flex-direction:column;min-height:2em}.pdp-grid-container.svelte-3r8bme.svelte-3r8bme{flex:1;min-height:0}.pdp-grid.svelte-3r8bme.svelte-3r8bme{height:100%;display:grid}.group-header.svelte-3r8bme.svelte-3r8bme{height:2em;display:flex;align-items:center;gap:1em;border-bottom:1px solid var(--gray-1);padding-left:0.5em;padding-right:0.5em}.two-way-color-container.svelte-3r8bme.svelte-3r8bme{flex:1;margin-left:auto;display:flex;align-items:center}.two-way-color-legend.svelte-3r8bme.svelte-3r8bme{flex:1}.page-change.svelte-3r8bme.svelte-3r8bme{display:flex;align-items:center}.current-page-number.svelte-3r8bme.svelte-3r8bme{width:2em;text-align:center}.label-and-input.svelte-3r8bme.svelte-3r8bme{display:flex;align-items:center;gap:0.25em}.pdp-grid-element.svelte-3r8bme.svelte-3r8bme{position:relative}.pdp-grid-element.svelte-3r8bme:hover .expand-pdp-button.svelte-3r8bme{display:block}.expand-pdp-button.svelte-3r8bme.svelte-3r8bme{position:absolute;display:none;bottom:2px;left:2px}.dont-shrink.svelte-3r8bme.svelte-3r8bme{flex:0 0 auto}.dont-show.svelte-3r8bme.svelte-3r8bme{display:none}ul.svelte-3r8bme.svelte-3r8bme{list-style:none}li.svelte-3r8bme+li.svelte-3r8bme{margin-top:0.5em}")}function Yu(t,e,n){const i=t.slice();return i[48]=e[n],i}function Ku(t,e,n){const i=t.slice();return i[51]=e[n].value,i[52]=e[n].title,i}function Uu(t,e,n){const i=t.slice();return i[55]=e[n],i}function Gu(t){let e,n,i,r=t[55].name+"";return{c(){e=k("option"),n=L(r),e.__value=i=t[55],e.value=e.__value},m(t,i){$(t,e,i),b(e,n)},p(t,o){2&o[0]&&r!==(r=t[55].name+"")&&C(n,r),2&o[0]&&i!==(i=t[55])&&(e.__value=i,e.value=e.__value)},d(t){t&&x(e)}}}function Zu(t){let e;return{c(){e=k("ul"),e.innerHTML='<li class="svelte-3r8bme"><span class="pdpilot-bold">Interaction:</span> Plots for feature\n                pairs with more interaction are ranked higher.</li> \n              <li class="svelte-3r8bme"><span class="pdpilot-bold">Variance:</span> Plots that have more\n                variation in their average predictions are ranked higher.</li>',z(e,"class","svelte-3r8bme")},m(t,n){$(t,e,n)},d(t){t&&x(e)}}}function Ju(t){let e;return{c(){e=k("ul"),e.innerHTML='<li class="svelte-3r8bme"><span class="pdpilot-bold">Variance:</span> Plots that have more\n                variance in their ICE lines are ranked higher.</li> \n              <li class="svelte-3r8bme"><span class="pdpilot-bold">Cluster difference:</span> Plots that\n                have ICE clusters farther from the partial dependence line are ranked\n                higher.</li> \n              <li class="svelte-3r8bme"><span class="pdpilot-bold">Highlighted similarity:</span> Plots where\n                the highlighted lines are closer together and farther from the partial\n                dependence line are ranked higher.</li> \n              <li class="svelte-3r8bme"><span class="pdpilot-bold">Highlighted distribution:</span> Plots\n                for features whose distributions of highlighted instances are more\n                different from the overall distributions are ranked higher.</li>',z(e,"class","svelte-3r8bme")},m(t,n){$(t,e,n)},d(t){t&&x(e)}}}function Qu(t){let e;function n(t,e){return 1===t[18]?Ju:Zu}let i=n(t),r=i(t);return{c(){e=k("div"),r.c()},m(t,n){$(t,e,n),r.m(e,null)},p(t,o){i!==(i=n(t))&&(r.d(1),r=i(t),r&&(r.c(),r.m(e,null)))},d(t){t&&x(e),r.d()}}}function th(t){let e,n,i,r,o,l,a,s;return{c(){e=k("button"),n=M("svg"),i=M("path"),r=M("path"),o=M("path"),z(i,"stroke","none"),z(i,"d","M0 0h24v24H0z"),z(i,"fill","none"),z(r,"d","M20 11a8.1 8.1 0 0 0 -15.5 -2m-.5 -4v4h4"),z(o,"d","M4 13a8.1 8.1 0 0 0 15.5 2m.5 4v-4h-4"),z(n,"xmlns","http://www.w3.org/2000/svg"),z(n,"class","pdpilot-icon icon-tabler icon-tabler-refresh"),z(n,"width","24"),z(n,"height","24"),z(n,"viewBox","0 0 24 24"),z(n,"stroke-width","2"),z(n,"stroke","currentColor"),z(n,"fill","none"),z(n,"stroke-linecap","round"),z(n,"stroke-linejoin","round"),z(e,"title","Update sorting"),e.disabled=l=!t[13]},m(l,c){$(l,e,c),b(e,n),b(n,i),b(n,r),b(n,o),a||(s=N(e,"click",t[33]),a=!0)},p(t,n){8192&n[0]&&l!==(l=!t[13])&&(e.disabled=l)},d(t){t&&x(e),a=!1,s()}}}function eh(t){let e,n,i,r,o,l=t[21],a=[];for(let e=0;e<l.length;e+=1)a[e]=nh(Ku(t,l,e));return{c(){e=k("label"),n=L("ICE:\n        "),i=k("select");for(let t=0;t<a.length;t+=1)a[t].c();void 0===t[6]&&K((()=>t[34].call(i))),z(e,"class","label-and-input dont-shrink svelte-3r8bme")},m(l,s){$(l,e,s),b(e,n),b(e,i);for(let t=0;t<a.length;t+=1)a[t].m(i,null);O(i,t[6]),r||(o=N(i,"change",t[34]),r=!0)},p(t,e){if(2097152&e[0]){let n;for(l=t[21],n=0;n<l.length;n+=1){const r=Ku(t,l,n);a[n]?a[n].p(r,e):(a[n]=nh(r),a[n].c(),a[n].m(i,null))}for(;n<a.length;n+=1)a[n].d(1);a.length=l.length}2097216&e[0]&&O(i,t[6])},d(t){t&&x(e),_(a,t),r=!1,o()}}}function nh(t){let e,n,i,r=t[52]+"";return{c(){e=k("option"),n=L(r),e.__value=i=t[51],e.value=e.__value},m(t,i){$(t,e,i),b(e,n)},p:l,d(t){t&&x(e)}}}function ih(t){let e,n,i,r,o;return{c(){e=k("label"),n=k("input"),i=k("span"),i.textContent="Distributions",z(n,"type","checkbox"),z(e,"class","label-and-input svelte-3r8bme")},m(l,a){$(l,e,a),b(e,n),n.checked=t[8],b(e,i),r||(o=N(n,"change",t[36]),r=!0)},p(t,e){256&e[0]&&(n.checked=t[8])},d(t){t&&x(e),r=!1,o()}}}function rh(t){let e,n,i,r,o,l,a,s,c,u,h;return s=new Fu({props:{kind:"help",right:"0",top:"0",marginRight:"1em",marginTop:"1.5em",width:"30em",$$slots:{default:[ah]},$$scope:{ctx:t}}}),{c(){e=k("div"),n=k("label"),i=L("Color\n            "),r=k("select"),o=k("option"),o.textContent="interactions",l=k("option"),l.textContent="predictions",a=A(),ht(s.$$.fragment),o.__value="interactions",o.value=o.__value,l.__value="predictions",l.value=l.__value,void 0===t[7]&&K((()=>t[37].call(r))),z(n,"class","label-and-input svelte-3r8bme"),z(e,"class","label-and-input dont-shrink svelte-3r8bme")},m(d,f){$(d,e,f),b(e,n),b(n,i),b(n,r),b(r,o),b(r,l),O(r,t[7]),b(e,a),dt(s,e,null),c=!0,u||(h=N(r,"change",t[37]),u=!0)},p(t,e){128&e[0]&&O(r,t[7]);const n={};524416&e[0]|134217728&e[1]&&(n.$$scope={dirty:e,ctx:t}),s.$set(n)},i(t){c||(ot(s.$$.fragment,t),c=!0)},o(t){lt(s.$$.fragment,t),c=!1},d(t){t&&x(e),ft(s),u=!1,h()}}}function oh(t){let e;return{c(){e=L("This color scale is for a standard two-way PDP. The color of a\n                cell represents the model's average prediction when setting the\n                instances to have the given values for pair of features.")},m(t,n){$(t,e,n)},p:l,d(t){t&&x(e)}}}function lh(t){let e,n,i,r,o;return{c(){e=L("This color scale shows the difference between the value in a\n                two-way PDP and the expected value if there was no interaction\n                between the pair of features. It indicates whether the\n                interaction between the two features makes the model's average\n                prediction for the given values "),n=k("span"),n.textContent="lower",i=L("\n                or\n                "),r=k("span"),r.textContent="higher",o=L(". The units are the same as your target variable."),E(n,"background",t[19].interpolator()(.1)),E(n,"border-radius","4px"),E(n,"padding","0.125em 0.25em"),E(n,"color","white"),E(r,"background",t[19].interpolator()(.9)),E(r,"border-radius","4px"),E(r,"padding","0.125em 0.25em"),E(r,"color","white")},m(t,l){$(t,e,l),$(t,n,l),$(t,i,l),$(t,r,l),$(t,o,l)},p(t,e){524288&e[0]&&E(n,"background",t[19].interpolator()(.1)),524288&e[0]&&E(r,"background",t[19].interpolator()(.9))},d(t){t&&x(e),t&&x(n),t&&x(i),t&&x(r),t&&x(o)}}}function ah(t){let e;function n(t,e){return"interactions"===t[7]?lh:oh}let i=n(t),r=i(t);return{c(){e=k("div"),r.c()},m(t,n){$(t,e,n),r.m(e,null)},p(t,o){i===(i=n(t))&&r?r.p(t,o):(r.d(1),r=i(t),r&&(r.c(),r.m(e,null)))},d(t){t&&x(e),r.d()}}}function sh(t,e){let n,i,r,o,l,a,s,c,u=`${e[11]}px`,h=`${e[12]}px`;function d(){return e[39](e[48])}return i=new tc({props:{pd:e[48],width:e[11],height:e[12],scaleLocally:e[15],colorShows:e[7],showMarginalDistribution:e[8],marginTop:10,marginRight:10,distributionHeight:10,showColorLegend:e[15],iceLevel:e[6],allowBrushing:1===e[18],iceLineWidth:.5}}),{key:t,first:null,c(){n=k("div"),ht(i.$$.fragment),r=A(),o=k("button"),o.innerHTML='<svg xmlns="http://www.w3.org/2000/svg" class="pdpilot-icon icon-tabler icon-tabler-arrows-maximize" width="24" height="24" viewBox="0 0 24 24" stroke-width="2" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"></path><path d="M16 4l4 0l0 4m-6 2l6 -6m-12 16l-4 0l0 -4m0 4l6 -6m6 6l4 0l0 -4m-6 -2l6 6m-12 -16l-4 0l0 4m0 -4l6 6"></path></svg>',l=A(),z(o,"class","expand-pdp-button svelte-3r8bme"),z(n,"class","pdp-grid-element svelte-3r8bme"),E(n,"max-width",u),E(n,"max-height",h),this.first=n},m(t,e){$(t,n,e),dt(i,n,null),b(n,r),b(n,o),b(n,l),a=!0,s||(c=N(o,"click",d),s=!0)},p(t,r){e=t;const o={};131072&r[0]&&(o.pd=e[48]),2048&r[0]&&(o.width=e[11]),4096&r[0]&&(o.height=e[12]),32768&r[0]&&(o.scaleLocally=e[15]),128&r[0]&&(o.colorShows=e[7]),256&r[0]&&(o.showMarginalDistribution=e[8]),32768&r[0]&&(o.showColorLegend=e[15]),64&r[0]&&(o.iceLevel=e[6]),262144&r[0]&&(o.allowBrushing=1===e[18]),i.$set(o),2048&r[0]&&u!==(u=`${e[11]}px`)&&E(n,"max-width",u),4096&r[0]&&h!==(h=`${e[12]}px`)&&E(n,"max-height",h)},i(t){a||(ot(i.$$.fragment,t),a=!0)},o(t){lt(i.$$.fragment,t),a=!1},d(t){t&&x(n),ft(i),s=!1,c()}}}function ch(t){let e,n,i,r,o,l,a,s,u,h,d,f,p,g,m,v,y,w,S,T,q,D,j,P,H,R,I,V,W,F,X,Y,U,G,Z,J,Q,tt,et,nt,at,ut,pt,gt,mt,vt,yt=[],bt=new Map,wt=`repeat(${t[5]}, minmax(0,${t[11]}px))`,$t=`repeat(${t[4]}, minmax(0,${t[12]}px))`,xt=t[1],_t=[];for(let e=0;e<xt.length;e+=1)_t[e]=Gu(Uu(t,xt,e));V=new Fu({props:{kind:"help",left:"0",top:"0",marginRight:"1em",marginTop:"1.5em",width:"30em",$$slots:{default:[Qu]},$$scope:{ctx:t}}});let kt=1===t[18]&&t[2].forBrushing&&th(t),Mt=1===t[18]&&eh(t),Lt=1===t[18]&&ih(t),At=2===t[18]&&rh(t);nt=new Ds({props:{width:t[14],height:uh,color:"interactions"===t[7]?t[19]:t[20],marginLeft:15,marginRight:15}});let St=t[17];const Nt=t=>t[48].id;for(let e=0;e<St.length;e+=1){let n=Yu(t,St,e),i=Nt(n);bt.set(i,yt[e]=sh(i,n))}return{c(){e=k("div"),n=k("div"),i=k("div"),r=k("button"),o=M("svg"),l=M("path"),a=M("line"),s=M("line"),u=M("line"),d=A(),f=k("div"),p=L(t[3]),g=A(),m=k("button"),v=M("svg"),y=M("path"),w=M("line"),S=M("line"),T=M("line"),D=A(),j=k("div"),P=k("label"),H=L("Sort:\n        "),R=k("select");for(let t=0;t<_t.length;t+=1)_t[t].c();I=A(),ht(V.$$.fragment),W=A(),kt&&kt.c(),F=A(),Mt&&Mt.c(),X=A(),Y=k("label"),U=k("input"),G=k("span"),G.textContent="Scale locally",Z=A(),Lt&&Lt.c(),J=A(),Q=k("div"),At&&At.c(),tt=A(),et=k("div"),ht(nt.$$.fragment),at=A(),ut=k("div"),pt=k("div");for(let t=0;t<yt.length;t+=1)yt[t].c();z(l,"stroke","none"),z(l,"d"," M0 0h24v24H0z"),z(l,"fill","none"),z(a,"x1","5"),z(a,"y1","12"),z(a,"x2","19"),z(a,"y2","12"),z(s,"x1","5"),z(s,"y1","12"),z(s,"x2","11"),z(s,"y2","18"),z(u,"x1","5"),z(u,"y1","12"),z(u,"x2","11"),z(u,"y2","6"),z(o,"xmlns","http://www.w3.org/2000/svg"),z(o,"class","pdpilot-icon icon-tabler icon-tabler-arrow-left"),z(o,"width","24"),z(o,"height","24"),z(o,"viewBox","0 0 24 24"),z(o,"stroke-width","2"),z(o,"stroke","currentColor"),z(o,"fill","none"),z(o,"stroke-linecap","round"),z(o,"stroke-linejoin","round"),r.disabled=h=t[3]<=1,z(r,"title","Previous page"),z(f,"class","current-page-number svelte-3r8bme"),z(y,"stroke","none"),z(y,"d","M0 0h24v24H0z"),z(y,"fill","none"),z(w,"x1","5"),z(w,"y1","12"),z(w,"x2","19"),z(w,"y2","12"),z(S,"x1","13"),z(S,"y1","18"),z(S,"x2","19"),z(S,"y2","12"),z(T,"x1","13"),z(T,"y1","6"),z(T,"x2","19"),z(T,"y2","12"),z(v,"xmlns","http://www.w3.org/2000/svg"),z(v,"class","pdpilot-icon icon-tabler icon-tabler-arrow-right"),z(v,"width","24"),z(v,"height","24"),z(v,"viewBox","0 0 24 24"),z(v,"stroke-width","2"),z(v,"stroke","currentColor"),z(v,"fill","none"),z(v,"stroke-linecap","round"),z(v,"stroke-linejoin","round"),m.disabled=q=t[3]>=t[16],z(m,"title","Next page"),z(i,"class","page-change dont-shrink svelte-3r8bme"),void 0===t[2]&&K((()=>t[32].call(R))),z(P,"class","label-and-input svelte-3r8bme"),z(j,"class","dont-shrink label-and-input svelte-3r8bme"),z(U,"type","checkbox"),z(Y,"class","label-and-input dont-shrink svelte-3r8bme"),z(et,"class","two-way-color-legend svelte-3r8bme"),B(et,"dont-show",1===t[18]||t[15]),z(Q,"class","two-way-color-container svelte-3r8bme"),z(n,"class","group-header svelte-3r8bme"),z(pt,"class","pdp-grid svelte-3r8bme"),E(pt,"grid-template-columns",wt),E(pt,"grid-template-rows",$t),z(ut,"class","pdp-grid-container svelte-3r8bme"),z(e,"class","group-container svelte-3r8bme")},m(c,h){$(c,e,h),b(e,n),b(n,i),b(i,r),b(r,o),b(o,l),b(o,a),b(o,s),b(o,u),b(i,d),b(i,f),b(f,p),b(i,g),b(i,m),b(m,v),b(v,y),b(v,w),b(v,S),b(v,T),b(n,D),b(n,j),b(j,P),b(P,H),b(P,R);for(let t=0;t<_t.length;t+=1)_t[t].m(R,null);O(R,t[2]),b(j,I),dt(V,j,null),b(n,W),kt&&kt.m(n,null),b(n,F),Mt&&Mt.m(n,null),b(n,X),b(n,Y),b(Y,U),U.checked=t[15],b(Y,G),b(n,Z),Lt&&Lt.m(n,null),b(n,J),b(n,Q),At&&At.m(Q,null),b(Q,tt),b(Q,et),dt(nt,et,null),t[38](et),b(e,at),b(e,ut),b(ut,pt);for(let t=0;t<yt.length;t+=1)yt[t].m(pt,null);t[40](ut),gt=!0,mt||(vt=[N(r,"click",t[30]),N(m,"click",t[31]),N(R,"change",t[32]),N(U,"change",t[35])],mt=!0)},p(t,e){if((!gt||8&e[0]&&h!==(h=t[3]<=1))&&(r.disabled=h),(!gt||8&e[0])&&C(p,t[3]),(!gt||65544&e[0]&&q!==(q=t[3]>=t[16]))&&(m.disabled=q),2&e[0]){let n;for(xt=t[1],n=0;n<xt.length;n+=1){const i=Uu(t,xt,n);_t[n]?_t[n].p(i,e):(_t[n]=Gu(i),_t[n].c(),_t[n].m(R,null))}for(;n<_t.length;n+=1)_t[n].d(1);_t.length=xt.length}6&e[0]&&O(R,t[2]);const i={};262144&e[0]|134217728&e[1]&&(i.$$scope={dirty:e,ctx:t}),V.$set(i),1===t[18]&&t[2].forBrushing?kt?kt.p(t,e):(kt=th(t),kt.c(),kt.m(n,F)):kt&&(kt.d(1),kt=null),1===t[18]?Mt?Mt.p(t,e):(Mt=eh(t),Mt.c(),Mt.m(n,X)):Mt&&(Mt.d(1),Mt=null),32768&e[0]&&(U.checked=t[15]),1===t[18]?Lt?Lt.p(t,e):(Lt=ih(t),Lt.c(),Lt.m(n,J)):Lt&&(Lt.d(1),Lt=null),2===t[18]?At?(At.p(t,e),262144&e[0]&&ot(At,1)):(At=rh(t),At.c(),ot(At,1),At.m(Q,tt)):At&&(it(),lt(At,1,1,(()=>{At=null})),rt());const o={};16384&e[0]&&(o.width=t[14]),1572992&e[0]&&(o.color="interactions"===t[7]?t[19]:t[20]),nt.$set(o),(!gt||294912&e[0])&&B(et,"dont-show",1===t[18]||t[15]),17209792&e[0]&&(St=t[17],it(),yt=ct(yt,e,Nt,1,t,St,bt,pt,st,sh,null,Yu),rt()),2080&e[0]&&wt!==(wt=`repeat(${t[5]}, minmax(0,${t[11]}px))`)&&E(pt,"grid-template-columns",wt),4112&e[0]&&$t!==($t=`repeat(${t[4]}, minmax(0,${t[12]}px))`)&&E(pt,"grid-template-rows",$t)},i(t){if(!gt){ot(V.$$.fragment,t),ot(At),ot(nt.$$.fragment,t);for(let t=0;t<St.length;t+=1)ot(yt[t]);gt=!0}},o(t){lt(V.$$.fragment,t),lt(At),lt(nt.$$.fragment,t);for(let t=0;t<yt.length;t+=1)lt(yt[t]);gt=!1},d(n){n&&x(e),_(_t,n),ft(V),kt&&kt.d(),Mt&&Mt.d(),Lt&&Lt.d(),At&&At.d(),ft(nt),t[38](null);for(let t=0;t<yt.length;t+=1)yt[t].d();t[40](null),mt=!1,c(vt)}}}const uh=24;function hh(t,e,n){let i,r,o,l,a,s,c,u,h,d,f,g,v,y,b;p(t,Fn,(t=>n(41,c=t))),p(t,Yn,(t=>n(42,u=t))),p(t,Xn,(t=>n(43,h=t))),p(t,Kn,(t=>n(29,d=t))),p(t,Tn,(t=>n(44,f=t))),p(t,Jn,(t=>n(45,g=t))),p(t,Vn,(t=>n(46,v=t))),p(t,Gn,(t=>n(19,y=t))),p(t,Un,(t=>n(20,b=t)));let w,{data:$}=e,{sortingOptions:x}=e;const _=[{value:"lines",title:"Standard"},{value:"centered-lines",title:"Centered"},{value:"cluster-centers",title:"Clusters"}];let k,M,L,A,S,N,z="lines",T="interactions",C=!1;H((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(26,L=t.inlineSize),n(27,A=t.blockSize)}else n(26,L=e.contentRect.width),n(27,A=e.contentRect.height)}));t.observe(k);const e=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(14,E=t.inlineSize)}else n(14,E=e.contentRect.width)}));return e.observe(M),()=>{t.unobserve(k),e.unobserve(k)}}));let q=!1,E=140,O=x[0];function B(t){n(13,q=!1),n(25,w=O.sort(t,{highlightedIndices:v,highlightedDistributions:g,featureInfo:f}))}let j=1;function P(t){t<1||t>a||n(3,j=t)}let R=!1;function I(t){m(Xn,h=t.x_feature,h),m(Yn,u=2===t.num_features?t.y_feature:"",u),m(Fn,c="detailed-plot",c)}return t.$$set=t=>{"data"in t&&n(0,$=t.data),"sortingOptions"in t&&n(1,x=t.sortingOptions)},t.$$.update=()=>{1&t.$$.dirty[0]&&n(18,i=ju($)?1:2),1&t.$$.dirty[0]&&n(28,r=Math.min($.length,12)),268435456&t.$$.dirty[0]&&n(4,[o,l]=function(t){const e=Math.ceil(Math.sqrt(t)),n=Math.ceil(t/e);return 1===i?[e,n]:[n,e]}(r),o,(n(5,l),n(28,r),n(0,$))),67108896&t.$$.dirty[0]&&n(11,S=Math.floor(L/l)),134217744&t.$$.dirty[0]&&n(12,N=Math.floor(A/o)),5&t.$$.dirty[0]&&(O.forBrushing||n(25,w=O.sort($))),5&t.$$.dirty[0]&&O.forBrushing&&B($),536870912&t.$$.dirty[0]&&d&&n(13,q=!0),1&t.$$.dirty[0]&&$&&P(1),268435457&t.$$.dirty[0]&&n(16,a=Math.ceil($.length/r)),301989896&t.$$.dirty[0]&&n(17,s=w.slice((j-1)*r,j*r)),1&t.$$.dirty[0]&&P(1)},[$,x,O,j,o,l,z,T,C,k,M,S,N,q,E,R,a,s,i,y,b,_,B,P,I,w,L,A,r,d,()=>P(j-1),()=>P(j+1),function(){O=D(this),n(2,O),n(1,x)},()=>B($),function(){z=D(this),n(6,z),n(21,_)},function(){R=this.checked,n(15,R)},function(){C=this.checked,n(8,C)},function(){T=D(this),n(7,T)},function(t){V[t?"unshift":"push"]((()=>{M=t,n(10,M)}))},t=>I(t),function(t){V[t?"unshift":"push"]((()=>{k=t,n(9,k)}))}]}const dh=class extends gt{constructor(t){super(),pt(this,t,hh,ch,h,{data:0,sortingOptions:1},Xu,[-1,-1])}};function fh(t){return t.length}function ph(t,e){let n=0,i=0;if(void 0===e)for(let e of t)null!=e&&(e=+e)>=e&&(++n,i+=e);else{let r=-1;for(let o of t)null!=(o=e(o,++r,t))&&(o=+o)>=o&&(++n,i+=o)}if(n)return i/n}const gh=[{name:"Variance",forBrushing:!1,sort:function(t){return 0!==t.length&&ju(t)?t.sort(((t,e)=>ve(t.deviation,e.deviation))):t}},{name:"Cluster difference",forBrushing:!1,sort:function(t){return 0!==t.length&&ju(t)?t.sort(((t,e)=>ve(t.ice.cluster_distance,e.ice.cluster_distance))):t}},{name:"Highlighted similarity",forBrushing:!0,sort:function(t,e){if(0===t.length||!ju(t)||!e||!e.highlightedIndices||e.highlightedIndices.length<=1)return t;const n=e.highlightedIndices,i=Object.fromEntries(t.map((t=>{var e;const i=n.map((e=>t.ice.centered_ice_lines[e])),r=function(t){if(!(r=t.length))return[];for(var e=-1,n=ic(t,fh),i=new Array(n);++e<n;)for(var r,o=-1,l=i[e]=new Array(r);++o<r;)l[o]=t[o][e];return i}(i).map((t=>{var e;return null!==(e=ph(t))&&void 0!==e?e:0})),o=function(t,e,n){return t.map((t=>{let i=0,r=0;for(let o=0;o<t.length;o++)i+=(t[o]-e[o])**2,r+=(t[o]-n[o])**2;return Math.sqrt(r)/Math.sqrt(i)}))}(i,r,t.ice.centered_pdp);return[t.x_feature,null!==(e=ph(o))&&void 0!==e?e:0]})));return t.sort(((t,e)=>ve(i[t.x_feature],i[e.x_feature])))}},{name:"Highlighted distribution",forBrushing:!0,sort:function(t,e){if(!(0!==t.length&&ju(t)&&e&&e.highlightedDistributions&&e.featureInfo))return t;const n=e.highlightedDistributions,i=e.featureInfo,r=Object.fromEntries(t.map((t=>{const e=n.get(t.x_feature);if(!e)return[t.x_feature,0];const r=i[t.x_feature].distribution.percents,o=e.percents;let l=0;for(let t=0;t<r.length;t++)l+=Math.abs(o[t]-r[t]);return[t.x_feature,l]})));return t.sort(((t,e)=>ve(r[t.x_feature],r[e.x_feature])))}}],mh=[{name:"Interaction",forBrushing:!1,sort:function(t){return 0===t.length||ju(t)?t:t.sort(((t,e)=>ve(t.H,e.H)))}},{name:"Variance",forBrushing:!1,sort:function(t){return 0===t.length||ju(t)?t:t.sort(((t,e)=>ve(t.deviation,e.deviation)))}}];function vh(t){w(t,"svelte-cuqal2",".one-way-grid-container.svelte-cuqal2{height:100%;display:flex}.pdp-grid-wrapper.svelte-cuqal2{flex:1;min-width:0}")}function yh(t){let e,n,i,r,o,l,a;return i=new Bu({}),i.$on("changeFilters",t[1]),l=new dh({props:{data:t[0],sortingOptions:gh}}),{c(){e=k("div"),n=k("div"),ht(i.$$.fragment),r=A(),o=k("div"),ht(l.$$.fragment),z(o,"class","pdp-grid-wrapper svelte-cuqal2"),z(e,"class","one-way-grid-container svelte-cuqal2")},m(t,s){$(t,e,s),b(e,n),dt(i,n,null),b(e,r),b(e,o),dt(l,o,null),a=!0},p(t,[e]){const n={};1&e&&(n.data=t[0]),l.$set(n)},i(t){a||(ot(i.$$.fragment,t),ot(l.$$.fragment,t),a=!0)},o(t){lt(i.$$.fragment,t),lt(l.$$.fragment,t),a=!1},d(t){t&&x(e),ft(i),ft(l)}}}function bh(t,e,n){let i,r,o;p(t,En,(t=>n(3,r=t))),p(t,zn,(t=>n(4,o=t)));let l=o;return t.$$.update=()=>{12&t.$$.dirty&&n(0,i=r.filter((t=>l.includes(t.x_feature))))},[i,function(t){n(2,l=t.detail)},l,r]}const wh=class extends gt{constructor(t){super(),pt(this,t,bh,yh,h,{},vh)}};function $h(t){w(t,"svelte-1mkvanr",".controls-container.svelte-1mkvanr.svelte-1mkvanr{height:100%;flex:0 0 200px;min-width:200px;max-width:200px;padding:0.25em;border-right:1px solid var(--gray-1);display:flex;flex-direction:column;gap:0.5em}.feature-selector-wrapper-outer.svelte-1mkvanr.svelte-1mkvanr{flex:0 1 auto;min-height:0;display:flex;flex-direction:column}.feature-selector-wrapper-inner.svelte-1mkvanr.svelte-1mkvanr{flex:1;min-height:0}.filter-header.svelte-1mkvanr+.filter-content.svelte-1mkvanr{margin-top:0.25em}.filter-content.svelte-1mkvanr.svelte-1mkvanr{margin-left:0.75em}")}function xh(t){let e,n,i,r,o,l,a,s,c,u,h;function d(e){t[3](e)}let f={title:"Name"};return void 0!==t[0]&&(f.expanded=t[0]),l=new qu({props:f}),V.push((()=>ut(l,"expanded",d,t[0]))),u=new ku({props:{enabledFeatures:t[1]}}),u.$on("changeNameFilters",t[2]),{c(){e=k("div"),n=k("div"),n.textContent="Feature Filters",i=A(),r=k("div"),o=k("div"),ht(l.$$.fragment),s=A(),c=k("div"),ht(u.$$.fragment),z(n,"class","pdpilot-bold"),z(o,"class","filter-header svelte-1mkvanr"),z(c,"class","filter-content feature-selector-wrapper-inner svelte-1mkvanr"),B(c,"pdp-hide",!t[0]),z(r,"class","filter-container feature-selector-wrapper-outer svelte-1mkvanr"),z(e,"class","controls-container svelte-1mkvanr")},m(t,a){$(t,e,a),b(e,n),b(e,i),b(e,r),b(r,o),dt(l,o,null),b(r,s),b(r,c),dt(u,c,null),h=!0},p(t,[e]){const n={};!a&&1&e&&(a=!0,n.expanded=t[0],U((()=>a=!1))),l.$set(n);const i={};2&e&&(i.enabledFeatures=t[1]),u.$set(i),(!h||1&e)&&B(c,"pdp-hide",!t[0])},i(t){h||(ot(l.$$.fragment,t),ot(u.$$.fragment,t),h=!0)},o(t){lt(l.$$.fragment,t),lt(u.$$.fragment,t),h=!1},d(t){t&&x(e),ft(l),ft(u)}}}function _h(t,e,n){let i;p(t,zn,(t=>n(1,i=t)));const r=R();let o=!0;return[o,i,function(t){r("changeFilters",t.detail)},function(t){o=t,n(0,o)}]}const kh=class extends gt{constructor(t){super(),pt(this,t,_h,xh,h,{},$h)}};function Mh(t){w(t,"svelte-1akrxps",".two-way-grid-container.svelte-1akrxps{height:100%;display:flex}.pdp-grid-wrapper.svelte-1akrxps{flex:1;min-width:0}")}function Lh(t){let e,n,i,r,o,l,a;return i=new kh({}),i.$on("changeFilters",t[1]),l=new dh({props:{data:t[0],sortingOptions:mh}}),{c(){e=k("div"),n=k("div"),ht(i.$$.fragment),r=A(),o=k("div"),ht(l.$$.fragment),z(o,"class","pdp-grid-wrapper svelte-1akrxps"),z(e,"class","two-way-grid-container svelte-1akrxps")},m(t,s){$(t,e,s),b(e,n),dt(i,n,null),b(e,r),b(e,o),dt(l,o,null),a=!0},p(t,[e]){const n={};1&e&&(n.data=t[0]),l.$set(n)},i(t){a||(ot(i.$$.fragment,t),ot(l.$$.fragment,t),a=!0)},o(t){lt(i.$$.fragment,t),lt(l.$$.fragment,t),a=!1},d(t){t&&x(e),ft(i),ft(l)}}}function Ah(t,e,n){let i,r,o;p(t,On,(t=>n(3,r=t))),p(t,zn,(t=>n(4,o=t)));let l=o;return t.$$.update=()=>{12&t.$$.dirty&&n(0,i=r.filter((t=>l.includes(t.x_feature)&&l.includes(t.y_feature))))},[i,function(t){n(2,l=t.detail)},l,r]}const Sh=class extends gt{constructor(t){super(),pt(this,t,Ah,Lh,h,{},Mh)}};function Nh(t){w(t,"svelte-1qv3cht",".pdpilot-widget-container.svelte-1qv3cht{box-sizing:border-box;width:100%;display:flex;flex-direction:column;font-size:16px;border:1px solid var(--gray-1);background-color:white;color:black;--magenta:rgb(121, 35, 103);--blue:rgb(0, 95, 204);--gray-0:rgb(247, 247, 247);--gray-1:rgb(226, 226, 226);--gray-2:rgb(198, 198, 198);--gray-3:rgb(171, 171, 171);--gray-4:rgb(145, 145, 145);--gray-5:rgb(119, 119, 119);--gray-6:rgb(94, 94, 94);--gray-7:rgb(71, 71, 71);--gray-8:rgb(48, 48, 48);--gray-9:rgb(27, 27, 27);--black:black;--red:#d62728;--light-red:#fc655a}.pdp-tab-content.svelte-1qv3cht{flex:1;min-height:0}.pdpilot-widget-container.svelte-1qv3cht .pdp-hide{display:none}.pdpilot-widget-container.svelte-1qv3cht canvas,.pdpilot-widget-container.svelte-1qv3cht svg{display:block}.pdpilot-widget-container.svelte-1qv3cht *{box-sizing:border-box;margin:0;padding:0;line-height:1.2}.pdpilot-widget-container.svelte-1qv3cht button{color:black;background-color:white;border:1px solid black;border-radius:0.25em;text-align:center;cursor:pointer;font-size:1em;padding:0.0625em 0.0625em;font-family:inherit}.pdpilot-widget-container.svelte-1qv3cht button:hover:enabled{background-color:var(--gray-0)}.pdpilot-widget-container.svelte-1qv3cht button:active:enabled{background-color:var(--gray-1)}.pdpilot-widget-container.svelte-1qv3cht button:disabled{cursor:not-allowed;background-color:transparent;color:var(--gray-4);border-color:var(--gray-4)}.pdpilot-widget-container.svelte-1qv3cht h1{font-size:1.125em;font-weight:500}.pdpilot-widget-container.svelte-1qv3cht h2{font-size:1.0625em;font-weight:500}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-large{font-size:1.125em}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-small{font-size:0.875em}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-bold{font-weight:500}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-icon{width:1em;height:1em}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-cutoff{overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.pdpilot-widget-container.svelte-1qv3cht .icon-tabler{-webkit-transform:translate(0px, 0px);transform:translate(0px, 0px)}")}function zh(t){let e,n,i,r,o,l,a,s,c,u,h,d,f=`${t[0]}px`;return n=new oi({}),o=new wh({}),s=new Sh({}),h=new yu({}),{c(){e=k("div"),ht(n.$$.fragment),i=A(),r=k("div"),ht(o.$$.fragment),l=A(),a=k("div"),ht(s.$$.fragment),c=A(),u=k("div"),ht(h.$$.fragment),z(r,"class","pdp-tab-content svelte-1qv3cht"),B(r,"pdp-hide","one-way-plots"!==t[1]),z(a,"class","pdp-tab-content svelte-1qv3cht"),B(a,"pdp-hide","two-way-plots"!==t[1]),z(u,"class","pdp-tab-content svelte-1qv3cht"),B(u,"pdp-hide","detailed-plot"!==t[1]),z(e,"class","pdpilot-widget-container svelte-1qv3cht"),E(e,"height",f)},m(t,f){$(t,e,f),dt(n,e,null),b(e,i),b(e,r),dt(o,r,null),b(e,l),b(e,a),dt(s,a,null),b(e,c),b(e,u),dt(h,u,null),d=!0},p(t,[n]){(!d||2&n)&&B(r,"pdp-hide","one-way-plots"!==t[1]),(!d||2&n)&&B(a,"pdp-hide","two-way-plots"!==t[1]),(!d||2&n)&&B(u,"pdp-hide","detailed-plot"!==t[1]),1&n&&f!==(f=`${t[0]}px`)&&E(e,"height",f)},i(t){d||(ot(n.$$.fragment,t),ot(o.$$.fragment,t),ot(s.$$.fragment,t),ot(h.$$.fragment,t),d=!0)},o(t){lt(n.$$.fragment,t),lt(o.$$.fragment,t),lt(s.$$.fragment,t),lt(h.$$.fragment,t),d=!1},d(t){t&&x(e),ft(n),ft(o),ft(s),ft(h)}}}function Th(t,e,n){let i,r;return p(t,In,(t=>n(0,i=t))),p(t,Fn,(t=>n(1,r=t))),[i,r]}const Ch=class extends gt{constructor(t){super(),pt(this,t,Th,zh,h,{},Nh)}};class qh extends o.DOMWidgetModel{defaults(){return Object.assign(Object.assign({},super.defaults()),{_model_name:qh.model_name,_model_module:qh.model_module,_model_module_version:qh.model_module_version,_view_name:qh.view_name,_view_module:qh.view_module,_view_module_version:qh.view_module_version,feature_names:[],feature_info:{},dataset:{},num_instances:0,one_way_pds:[],two_way_pds:[],two_way_pdp_extent:[0,0],two_way_interaction_extent:[0,0],ice_line_extent:[0,0],ice_cluster_center_extent:[0,0],ice_cluster_band_extent:[0,0],ice_cluster_line_extent:[0,0],height:600,highlighted_indices:[],two_way_to_calculate:[]})}}qh.serializers=Object.assign({},o.DOMWidgetModel.serializers),qh.model_name="PDPilotModel",qh.model_module=n,qh.model_module_version=e,qh.view_name="PDPilotView",qh.view_module=n,qh.view_module_version=e;class Eh extends o.DOMWidgetView{render(){Qn(this.model),new Ch({target:this.el})}}})(),r})()));